/*
 * This file was generated automatically by ExtUtils::ParseXS version 3.44 from the
 * contents of Virt.xs. Do not edit this file, edit Virt.xs instead.
 *
 *    ANY CHANGES MADE HERE WILL BE LOST!
 *
 */

#line 1 "lib/Sys/Virt.xs"
/* -*- c -*-
 *
 * Copyright (C) 2006-2016 Red Hat
 * Copyright (C) 2006-2014 Daniel P. Berrange
 *
 * This program is free software; You can redistribute it and/or modify
 * it under either:
 *
 * a) the GNU General Public License as published by the Free
 *   Software Foundation; either version 2, or (at your option) any
 *   later version,
 *
 * or
 *
 * b) the "Artistic License"
 *
 * The file "LICENSE" distributed along with this file provides full
 * details of the terms and conditions of the two licenses.
 */

#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"

#include <libvirt/virterror.h>
#include <libvirt/libvirt.h>

/*
 * On 32-bit OS (and some 64-bit) Perl does not have an
 * integer type capable of storing 64 bit numbers. So
 * we serialize to/from strings on these platforms
 */

static long long
virt_SvIVll(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoll(SvPV_nolen(sv), NULL, 10);
#endif
}


static unsigned long long
virt_SvIVull(SV *sv) {
#ifdef USE_64_BIT_ALL
    return SvIV(sv);
#else
    return strtoull(SvPV_nolen(sv), NULL, 10);
#endif
}


#ifndef PRId64
#define PRId64 "lld"
#endif


static SV *
virt_newSVll(long long val) {
#ifdef USE_64_BIT_ALL
    return newSViv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRId64, val);
    return newSVpv(buf, len);
#endif
}


#ifndef PRIu64
#define PRIu64 "llu"
#endif

static SV *
virt_newSVull(unsigned long long val) {
#ifdef USE_64_BIT_ALL
    return newSVuv(val);
#else
    char buf[100];
    int len;
    len = snprintf(buf, 100, "%" PRIu64, val);
    return newSVpv(buf, len);
#endif
}


static void
ignoreVirErrorFunc(void * userData, virErrorPtr error) {
    /* Do nothing */
}


static SV *
_sv_from_error(virErrorPtr error)
{
    HV *hv;

    hv = newHV ();

    /* Map virErrorPtr attributes to hash keys */
    (void)hv_store (hv, "level", 5, newSViv (error ? error->level : 0), 0);
    (void)hv_store (hv, "code", 4, newSViv (error ? error->code : 0), 0);
    (void)hv_store (hv, "domain", 6, newSViv (error ? error->domain : VIR_FROM_NONE), 0);
    (void)hv_store (hv, "message", 7, newSVpv (error && error->message ? error->message : "Unknown problem", 0), 0);

    return sv_bless (newRV_noinc ((SV*) hv), gv_stashpv ("Sys::Virt::Error", TRUE));
}


static void
_croak_error(void)
{
    virErrorPtr error = virGetLastError();
    sv_setsv(ERRSV, _sv_from_error (error));

    /* croak does not return, so we free this now to avoid leaking */
    virResetError(error);

    croak (Nullch);
}


static void
_populate_constant(HV *stash, const char *name, int val)
{
    SV *valsv;

    valsv = newSViv(0);
    sv_setuv(valsv,val);
    newCONSTSUB(stash, name, valsv);
}


static void
_populate_constant_str(HV *stash, const char *name, const char *value)
{
    SV *valsv;

    valsv = newSVpv(value, strlen(value));
    newCONSTSUB(stash, name, valsv);
}


static void
_populate_constant_ull(HV *stash, const char *name, unsigned long long val)
{
    SV *valsv;

    valsv = virt_newSVull(val);
    newCONSTSUB(stash, name, valsv);
}


#define REGISTER_CONSTANT(name, key) _populate_constant(stash, #key, name)
#define REGISTER_CONSTANT_STR(name, key) _populate_constant_str(stash, #key, name)
#define REGISTER_CONSTANT_ULL(name, key) _populate_constant_ull(stash, #key, name)

static HV *
vir_typed_param_to_hv(virTypedParameterPtr params, int nparams)
{
    HV *ret = (HV *)sv_2mortal((SV*)newHV());
    unsigned int i;
    const char *field;
    STRLEN val_length;

    for (i = 0 ; i < nparams ; i++) {
        SV *val = NULL;

        switch (params[i].type) {
        case VIR_TYPED_PARAM_INT:
            val = newSViv(params[i].value.i);
            break;

        case VIR_TYPED_PARAM_UINT:
            val = newSViv((int)params[i].value.ui);
            break;

        case VIR_TYPED_PARAM_LLONG:
            val = virt_newSVll(params[i].value.l);
            break;

        case VIR_TYPED_PARAM_ULLONG:
            val = virt_newSVull(params[i].value.ul);
            break;

        case VIR_TYPED_PARAM_DOUBLE:
            val = newSVnv(params[i].value.d);
            break;

        case VIR_TYPED_PARAM_BOOLEAN:
            val = newSViv(params[i].value.b);
            break;

        case VIR_TYPED_PARAM_STRING:
            val_length = strlen(params[i].value.s);
            val = newSVpv(params[i].value.s, val_length);
            break;

        }

        field = params[i].field;
        (void)hv_store(ret, field, strlen(params[i].field), val, 0);
    }

    return ret;
}


static int
vir_typed_param_from_hv(HV *newparams, virTypedParameterPtr params, int nparams)
{
    unsigned int i;
    char * ptr;
    STRLEN len;

    /* We only want to set parameters which we're actually changing
     * so here we figure out which elements of 'params' we need to
     * update, and overwrite the others
     */
    for (i = 0 ; i < nparams ;) {
        if (!hv_exists(newparams, params[i].field, strlen(params[i].field))) {
            if ((nparams-i) > 1)
                memmove(params+i, params+i+1, sizeof(*params)*(nparams-(i+1)));
            nparams--;
            continue;
        }

        i++;
    }

    for (i = 0 ; i < nparams ; i++) {
        SV **val;

        val = hv_fetch (newparams, params[i].field, strlen(params[i].field), 0);

        switch (params[i].type) {
        case VIR_TYPED_PARAM_INT:
            params[i].value.i = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_UINT:
            params[i].value.ui = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_LLONG:
            params[i].value.l = virt_SvIVll(*val);
            break;

        case VIR_TYPED_PARAM_ULLONG:
            params[i].value.ul = virt_SvIVull(*val);
            break;

        case VIR_TYPED_PARAM_DOUBLE:
            params[i].value.d = SvNV(*val);
            break;

        case VIR_TYPED_PARAM_BOOLEAN:
            params[i].value.b = SvIV(*val);
            break;

        case VIR_TYPED_PARAM_STRING:
            ptr = SvPV(*val, len);
            if (!(params[i].value.s = strdup((char *)ptr)))
                abort();
            break;
        }
    }

    return nparams;
}


static void
vir_typed_param_add_string_list_from_hv(HV *newparams,
                                        virTypedParameterPtr *params,
                                        int *nparams,
                                        const char *key)
{
    if (!hv_exists(newparams, key, strlen(key))) {
        return;
    }
    SSize_t nstr, i;
    virTypedParameterPtr localparams = *params;

    SV **val = hv_fetch(newparams, key, strlen(key), 0);
    AV *av = (AV*)(SvRV(*val));
    nstr = av_len(av) + 1;

    Renew(localparams, *nparams + nstr, virTypedParameter);

    for (i = 0 ; i < nstr ; i++) {
        STRLEN len;
        SV **subval = av_fetch(av, i, 0);
        char *ptr = SvPV(*subval, len);

        strncpy(localparams[*nparams + i].field, key,
                VIR_TYPED_PARAM_FIELD_LENGTH);
        localparams[*nparams + i].field[VIR_TYPED_PARAM_FIELD_LENGTH - 1] = '\0';

        localparams[*nparams + i].type = VIR_TYPED_PARAM_STRING;
        if (!(localparams[*nparams + i].value.s = strdup(ptr)))
            abort();
    }

    *params = localparams;
    *nparams += nstr;
}


static void
vir_typed_param_safe_free(virTypedParameterPtr params, int nparams)
{
    virTypedParamsClear(params, nparams);
    Safefree(params);
}

static void
migrate_parse_params(virTypedParameterPtr *paramsRet,
                     int *nparamsRet,
                     HV *newparams)
{
    virTypedParameterPtr params;
    int nparams;

    nparams = 21;
    Newx(params, nparams, virTypedParameter);

    strncpy(params[0].field, VIR_MIGRATE_PARAM_URI,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[0].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[1].field, VIR_MIGRATE_PARAM_DEST_NAME,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[1].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[2].field, VIR_MIGRATE_PARAM_DEST_XML,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[2].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[3].field, VIR_MIGRATE_PARAM_GRAPHICS_URI,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[3].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[4].field, VIR_MIGRATE_PARAM_BANDWIDTH,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[4].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(params[5].field, VIR_MIGRATE_PARAM_LISTEN_ADDRESS,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[5].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[6].field, VIR_MIGRATE_PARAM_DISKS_PORT,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[6].type = VIR_TYPED_PARAM_INT;

    strncpy(params[7].field, VIR_MIGRATE_PARAM_COMPRESSION,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[7].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[8].field, VIR_MIGRATE_PARAM_COMPRESSION_MT_DTHREADS,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[8].type = VIR_TYPED_PARAM_INT;

    strncpy(params[9].field, VIR_MIGRATE_PARAM_COMPRESSION_MT_LEVEL,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[9].type = VIR_TYPED_PARAM_INT;

    strncpy(params[10].field, VIR_MIGRATE_PARAM_COMPRESSION_MT_THREADS,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[10].type = VIR_TYPED_PARAM_INT;

    strncpy(params[11].field, VIR_MIGRATE_PARAM_COMPRESSION_XBZRLE_CACHE,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[11].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(params[12].field, VIR_MIGRATE_PARAM_PERSIST_XML,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[12].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[13].field, VIR_MIGRATE_PARAM_AUTO_CONVERGE_INITIAL,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[13].type = VIR_TYPED_PARAM_INT;

    strncpy(params[14].field, VIR_MIGRATE_PARAM_AUTO_CONVERGE_INCREMENT,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[14].type = VIR_TYPED_PARAM_INT;

    strncpy(params[15].field, VIR_MIGRATE_PARAM_BANDWIDTH_POSTCOPY,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[15].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(params[16].field, VIR_MIGRATE_PARAM_PARALLEL_CONNECTIONS,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[16].type = VIR_TYPED_PARAM_INT;

    strncpy(params[17].field, VIR_MIGRATE_PARAM_TLS_DESTINATION,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[17].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[18].field, VIR_MIGRATE_PARAM_DISKS_URI,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[18].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[19].field, VIR_MIGRATE_PARAM_COMPRESSION_ZLIB_LEVEL,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[19].type = VIR_TYPED_PARAM_INT;

    strncpy(params[20].field, VIR_MIGRATE_PARAM_COMPRESSION_ZSTD_LEVEL,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[20].type = VIR_TYPED_PARAM_INT;

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    vir_typed_param_add_string_list_from_hv(newparams, &params, &nparams,
                                            VIR_MIGRATE_PARAM_MIGRATE_DISKS);

    *paramsRet = params;
    *nparamsRet = nparams;
}


static int
_domain_event_lifecycle_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 int event,
                                 int detail,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_generic_callback(virConnectPtr con,
                               virDomainPtr dom,
                               void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_rtcchange_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 long long utcoffset,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(virt_newSVll(utcoffset)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_watchdog_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int action,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(action)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_io_error_callback(virConnectPtr con,
                                virDomainPtr dom,
                                const char *srcPath,
                                const char *devAlias,
                                int action,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(srcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(action)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_disk_change_callback(virConnectPtr con,
                                   virDomainPtr dom,
                                   const char *oldSrcPath,
                                   const char *newSrcPath,
                                   const char *devAlias,
                                   int reason,
                                   void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(oldSrcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(newSrcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_tray_change_callback(virConnectPtr con,
                                   virDomainPtr dom,
                                   const char *devAlias,
                                   int reason,
                                   void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_pmwakeup_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int reason,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_pmsuspend_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 int reason,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_pmsuspend_disk_callback(virConnectPtr con,
                                      virDomainPtr dom,
                                      int reason,
                                      void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_io_error_reason_callback(virConnectPtr con,
                                       virDomainPtr dom,
                                       const char *srcPath,
                                       const char *devAlias,
                                       int action,
                                       const char *reason,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(srcPath, 0)));
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    XPUSHs(sv_2mortal(newSViv(action)));
    XPUSHs(sv_2mortal(newSVpv(reason, 0)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_graphics_callback(virConnectPtr con,
                                virDomainPtr dom,
                                int phase,
                                virDomainEventGraphicsAddressPtr local,
                                virDomainEventGraphicsAddressPtr remote,
                                const char *authScheme,
                                virDomainEventGraphicsSubjectPtr subject,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    HV *local_hv;
    HV *remote_hv;
    AV *subject_av;
    int i;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    local_hv = newHV();
    (void)hv_store(local_hv, "family", 6, newSViv(local->family), 0);
    (void)hv_store(local_hv, "node", 4, newSVpv(local->node, 0), 0);
    (void)hv_store(local_hv, "service", 7, newSVpv(local->service, 0), 0);

    remote_hv = newHV();
    (void)hv_store(remote_hv, "family", 6, newSViv(remote->family), 0);
    (void)hv_store(remote_hv, "node", 4, newSVpv(remote->node, 0), 0);
    (void)hv_store(remote_hv, "service", 7, newSVpv(remote->service, 0), 0);

    subject_av = newAV();
    for (i = 0 ; i < subject->nidentity ; i++) {
        HV *identity = newHV();
        (void)hv_store(identity, "type", 4, newSVpv(subject->identities[i].type, 0), 0);
        (void)hv_store(identity, "name", 4, newSVpv(subject->identities[i].name, 0), 0);

        av_push(subject_av, newRV_noinc((SV *)identity));
    }

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(phase)));
    XPUSHs(newRV_noinc((SV*)local_hv));
    XPUSHs(newRV_noinc((SV*)remote_hv));
    XPUSHs(sv_2mortal(newSVpv(authScheme, 0)));
    XPUSHs(newRV_noinc((SV*)subject_av));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_block_job_callback(virConnectPtr con,
                                 virDomainPtr dom,
                                 const char *path,
                                 int type,
                                 int status,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(path, 0)));
    XPUSHs(sv_2mortal(newSViv(type)));
    XPUSHs(sv_2mortal(newSViv(status)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_balloonchange_callback(virConnectPtr con,
                                     virDomainPtr dom,
                                     unsigned long long actual,
                                     void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(virt_newSVull(actual)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_device_generic_callback(virConnectPtr con,
                                      virDomainPtr dom,
                                      const char *devAlias,
                                      void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(devAlias, 0)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_tunable_callback(virConnectPtr con,
                               virDomainPtr dom,
                               virTypedParameterPtr params,
                               size_t nparams,
                               void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    HV *params_hv;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);

    params_hv = vir_typed_param_to_hv(params, nparams);

    XPUSHs(domref);
    XPUSHs(newRV(( SV*)params_hv));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_agent_lifecycle_callback(virConnectPtr con,
                                       virDomainPtr dom,
                                       int state,
                                       int reason,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(state)));
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_migration_iteration_callback(virConnectPtr con,
                                           virDomainPtr dom,
                                           int iteration,
                                           void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(iteration)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_job_completed_callback(virConnectPtr con,
                                     virDomainPtr dom,
                                     virTypedParameterPtr params,
                                     int nparams,
                                     void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    HV *params_hv;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);

    params_hv = vir_typed_param_to_hv(params, nparams);

    XPUSHs(domref);
    XPUSHs(newRV(( SV*)params_hv));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_metadata_change_callback(virConnectPtr con,
                                       virDomainPtr dom,
                                       int type,
                                       const char *nsuri,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void*)dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(type)));
    XPUSHs(sv_2mortal(newSVpv(nsuri, 0)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_block_threshold_callback(virConnectPtr con,
                                       virDomainPtr dom,
                                       const char *dev,
                                       const char *path,
                                       unsigned long long threshold,
                                       unsigned long long excess,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void *) dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(dev, 0)));
    XPUSHs(sv_2mortal(newSVpv(path, 0)));
    XPUSHs(sv_2mortal(newSViv(threshold)));
    XPUSHs(sv_2mortal(newSViv(excess)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_memory_failure_callback(virConnectPtr con,
                                      virDomainPtr dom,
                                      int recipient,
                                      int action,
                                      unsigned int flags,
                                      void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void *) dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSViv(recipient)));
    XPUSHs(sv_2mortal(newSViv(action)));
    XPUSHs(sv_2mortal(newSViv(flags)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_domain_event_memory_device_size_change_callback(virConnectPtr con,
                                                 virDomainPtr dom,
                                                 const char *alias,
                                                 unsigned long long size,
                                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *domref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    domref = sv_newmortal();
    sv_setref_pv(domref, "Sys::Virt::Domain", (void *) dom);
    virDomainRef(dom);
    XPUSHs(domref);
    XPUSHs(sv_2mortal(newSVpv(alias, 0)));
    XPUSHs(sv_2mortal(virt_newSVull(size)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_network_event_lifecycle_callback(virConnectPtr con,
                                  virNetworkPtr net,
                                  int event,
                                  int detail,
                                  void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *netref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    netref = sv_newmortal();
    sv_setref_pv(netref, "Sys::Virt::Network", (void*)net);
    virNetworkRef(net);
    XPUSHs(netref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_network_event_generic_callback(virConnectPtr con,
                                virNetworkPtr net,
                                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *netref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    netref = sv_newmortal();
    sv_setref_pv(netref, "Sys::Virt::Network", (void*)net);
    virNetworkRef(net);
    XPUSHs(netref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_storage_pool_event_generic_callback(virConnectPtr con,
                                     virStoragePoolPtr pool,
                                     void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *poolref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    poolref = sv_newmortal();
    sv_setref_pv(poolref, "Sys::Virt::StoragePool", (void*)pool);
    virStoragePoolRef(pool);
    XPUSHs(poolref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_storage_pool_event_lifecycle_callback(virConnectPtr con,
                                       virStoragePoolPtr pool,
                                       int event,
                                       int detail,
                                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *poolref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    poolref = sv_newmortal();
    sv_setref_pv(poolref, "Sys::Virt::StoragePool", (void*)pool);
    virStoragePoolRef(pool);
    XPUSHs(poolref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_node_device_event_generic_callback(virConnectPtr con,
                                    virNodeDevicePtr dev,
                                    void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *devref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    devref = sv_newmortal();
    sv_setref_pv(devref, "Sys::Virt::NodeDevice", (void*)dev);
    virNodeDeviceRef(dev);
    XPUSHs(devref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_node_device_event_lifecycle_callback(virConnectPtr con,
                                      virNodeDevicePtr dev,
                                      int event,
                                      int detail,
                                      void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *devref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    devref = sv_newmortal();
    sv_setref_pv(devref, "Sys::Virt::NodeDevice", (void*)dev);
    virNodeDeviceRef(dev);
    XPUSHs(devref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_secret_event_lifecycle_callback(virConnectPtr con,
                                 virSecretPtr secret,
                                 int event,
                                 int detail,
                                 void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *secretref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    secretref = sv_newmortal();
    sv_setref_pv(secretref, "Sys::Virt::Secret", (void*)secret);
    virSecretRef(secret);
    XPUSHs(secretref);
    XPUSHs(sv_2mortal(newSViv(event)));
    XPUSHs(sv_2mortal(newSViv(detail)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static int
_secret_event_generic_callback(virConnectPtr con,
                               virSecretPtr secret,
                               void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    SV *secretref;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    secretref = sv_newmortal();
    sv_setref_pv(secretref, "Sys::Virt::Secret", (void*)secret);
    virSecretRef(secret);
    XPUSHs(secretref);
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return 0;
}


static void
_domain_event_free(void *opaque)
{
    SV *sv = opaque;
    SvREFCNT_dec(sv);
}


static void
_network_event_free(void *opaque)
{
    SV *sv = opaque;
    SvREFCNT_dec(sv);
}


static void
_storage_pool_event_free(void *opaque)
{
    SV *sv = opaque;
    SvREFCNT_dec(sv);
}


static void
_node_device_event_free(void *opaque)
{
    SV *sv = opaque;
    SvREFCNT_dec(sv);
}


static void
_secret_event_free(void *opaque)
{
    SV *sv = opaque;
    SvREFCNT_dec(sv);
}


static void
_close_callback(virConnectPtr con,
                int reason,
                void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(newSViv(reason)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);
}


static void
_close_callback_free(void *opaque)
{
    SV *sv = opaque;
    SvREFCNT_dec(sv);
}


static int
_event_add_handle(int fd,
                  int events,
                  virEventHandleCallback cb,
                  void *opaque,
                  virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int watch = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref= sv_newmortal();
    opaqueref= sv_newmortal();
    ffref= sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_handle", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
        watch = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
        return -1;

    return watch;
}


static void
_event_update_handle(int watch,
                     int events)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_handle", G_DISCARD);

    FREETMPS;
    LEAVE;
}


static int
_event_remove_handle(int watch)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_handle", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
    return 0;
}


static int
_event_add_timeout(int interval,
                   virEventTimeoutCallback cb,
                   void *opaque,
                   virFreeCallback ff)
{
    SV *cbref;
    SV *opaqueref;
    SV *ffref;
    int ret;
    int timer = 0;
    dSP;

    ENTER;
    SAVETMPS;

    cbref = sv_newmortal();
    opaqueref = sv_newmortal();
    ffref = sv_newmortal();

    sv_setref_pv(cbref, NULL, cb);
    sv_setref_pv(opaqueref, NULL, opaque);
    sv_setref_pv(ffref, NULL, ff);

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(interval)));
    XPUSHs(cbref);
    XPUSHs(opaqueref);
    XPUSHs(ffref);
    PUTBACK;

    ret = call_pv("Sys::Virt::Event::_add_timeout", G_SCALAR);

    SPAGAIN;

    if (ret == 1)
        timer = POPi;

    FREETMPS;
    LEAVE;

    if (ret != 1)
        return -1;

    return timer;
}


static void
_event_update_timeout(int timer,
                      int interval)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    XPUSHs(sv_2mortal(newSViv(interval)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_update_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;
}


static int
_event_remove_timeout(int timer)
{
    dSP;

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_pv("Sys::Virt::Event::_remove_timeout", G_DISCARD);

    FREETMPS;
    LEAVE;

    return 0;
}


static int
_open_auth_callback(virConnectCredentialPtr cred,
                    unsigned int ncred,
                    void *cbdata)
{
    dSP;
    int i, ret, success = -1;
    AV *credlist;

    credlist = newAV();

    ENTER;
    SAVETMPS;
    PUSHMARK(SP);

    for (i = 0 ; i < ncred ; i++) {
        HV *credrec = newHV();

        (void)hv_store(credrec, "type", 4, newSViv(cred[i].type), 0);
        (void)hv_store(credrec, "prompt", 6, newSVpv(cred[i].prompt, 0), 0);
        (void)hv_store(credrec, "challenge", 9, newSVpv(cred[i].challenge, 0), 0);
        if (cred[i].defresult != NULL)
            (void)hv_store(credrec, "result", 6, newSVpv(cred[i].defresult, 0), 0);
        else
            (void)hv_fetch(credrec, "result", 6, 1);

        av_push(credlist, newRV_noinc((SV *)credrec));
    }
    SvREFCNT_inc((SV*)credlist);

    XPUSHs(newRV_noinc((SV*)credlist));
    PUTBACK;

    ret = call_sv((SV*)cbdata, G_SCALAR);

    SPAGAIN;

    if (ret == 1)
        success = POPi;

    for (i = 0 ; i < ncred ; i++) {
        SV **credsv = av_fetch(credlist, i, 0);
        HV *credrec = (HV*)SvRV(*credsv);
        SV **val = hv_fetch(credrec, "result", 6, 0);

        if (val && SvOK(*val)) {
            STRLEN len;
            char *result = SvPV(*val, len);
            if (!(cred[i].result = malloc(len+1)))
                abort();
            memcpy(cred[i].result, result, len+1);
            cred[i].resultlen = (unsigned int)len;
        } else {
            cred[i].resultlen = 0;
            cred[i].result = NULL;
        }
    }

    FREETMPS;
    LEAVE;

    return success;
}


static void
_event_handle_helper(int watch,
                     int fd,
                     int events,
                     void *opaque)
{
    SV *cb = opaque;
    dSP;

    SvREFCNT_inc(cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(watch)));
    XPUSHs(sv_2mortal(newSViv(fd)));
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_sv(cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(cb);
}


static void
_event_timeout_helper(int timer,
                      void *opaque)
{
    SV *cb = opaque;
    dSP;

    SvREFCNT_inc(cb);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(sv_2mortal(newSViv(timer)));
    PUTBACK;

    call_sv(cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(cb);
}


static void
_event_cb_free(void *opaque)
{
    SV *data = opaque;
    SvREFCNT_dec(data);
}


static void
_stream_event_callback(virStreamPtr st,
                       int events,
                       void *opaque)
{
    AV *data = opaque;
    SV **self;
    SV **cb;
    dSP;

    self = av_fetch(data, 0, 0);
    cb = av_fetch(data, 1, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(newSViv(events)));
    PUTBACK;

    call_sv(*cb, G_DISCARD);

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);
}


static void
_stream_event_free(void *opaque)
{
    AV *data = opaque;
    SvREFCNT_dec(data);
}


static int
_stream_send_all_source(virStreamPtr st,
                        char *data,
                        size_t nbytes,
                        void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **handler;
    SV *datasv;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    handler = av_fetch(av, 1, 0);
    datasv = newSVpv("", 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(datasv);
    XPUSHs(sv_2mortal(newSViv(nbytes)));
    PUTBACK;

    rv = call_sv((SV*)*handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    if (ret > 0) {
        const char *newdata = SvPV_nolen(datasv);
        if (ret > nbytes)
            ret = nbytes;
        memcpy(data, newdata, nbytes);
    }


    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);
    SvREFCNT_dec(datasv);

    return ret;
}


static int
_stream_sparse_send_all_hole_handler(virStreamPtr st,
                                     int *inData,
                                     long long *length,
                                     void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **hole_handler;
    SV *inDataSV;
    SV *lengthSV;
    int count;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    hole_handler = av_fetch(av, 2, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    PUTBACK;

    count = call_sv((SV*)*hole_handler, G_ARRAY);

    SPAGAIN;

    if (count == 2) {
        /* @hole_handler returns (in_data, length), but on a stack.
         * Therefore the order is reversed. */
        lengthSV = POPs;
        inDataSV = POPs;
        *inData = virt_SvIVll(inDataSV);
        *length = virt_SvIVll(lengthSV);
        ret = 0;
    } else {
        ret = -1;
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return ret;
}


static int
_stream_sparse_send_all_skip_handler(virStreamPtr st,
                                     long long length,
                                     void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **skip_handler;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    skip_handler = av_fetch(av, 3, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(virt_newSVll(length)));
    PUTBACK;

    rv = call_sv((SV*)*skip_handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    PUTBACK;
    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return ret;
}


static int
_stream_recv_all_sink(virStreamPtr st,
                      const char *data,
                      size_t nbytes,
                      void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **handler;
    SV *datasv;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    handler = av_fetch(av, 1, 0);
    datasv = newSVpv(data, nbytes);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(datasv);
    XPUSHs(sv_2mortal(newSViv(nbytes)));
    PUTBACK;

    rv = call_sv((SV*)*handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);
    SvREFCNT_dec(datasv);

    return ret;
}


static int
_stream_sparse_recv_hole_handler(virStreamPtr st,
                                 long long offset,
                                 void *opaque)
{
    AV *av = opaque;
    SV **self;
    SV **hole_handler;
    int rv;
    int ret;
    dSP;

    self = av_fetch(av, 0, 0);
    hole_handler = av_fetch(av, 2, 0);

    SvREFCNT_inc(*self);

    ENTER;
    SAVETMPS;

    PUSHMARK(SP);
    XPUSHs(*self);
    XPUSHs(sv_2mortal(virt_newSVll(offset)));
    PUTBACK;

    rv = call_sv((SV*)*hole_handler, G_SCALAR);

    SPAGAIN;

    if (rv == 1) {
        ret = POPi;
    } else {
        ret = -1;
    }

    FREETMPS;
    LEAVE;

    SvREFCNT_dec(*self);

    return ret;
}


#line 2431 "lib/Sys/Virt.c"
#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#ifndef dVAR
#  define dVAR		dNOOP
#endif


/* This stuff is not part of the API! You have been warned. */
#ifndef PERL_VERSION_DECIMAL
#  define PERL_VERSION_DECIMAL(r,v,s) (r*1000000 + v*1000 + s)
#endif
#ifndef PERL_DECIMAL_VERSION
#  define PERL_DECIMAL_VERSION \
	  PERL_VERSION_DECIMAL(PERL_REVISION,PERL_VERSION,PERL_SUBVERSION)
#endif
#ifndef PERL_VERSION_GE
#  define PERL_VERSION_GE(r,v,s) \
	  (PERL_DECIMAL_VERSION >= PERL_VERSION_DECIMAL(r,v,s))
#endif
#ifndef PERL_VERSION_LE
#  define PERL_VERSION_LE(r,v,s) \
	  (PERL_DECIMAL_VERSION <= PERL_VERSION_DECIMAL(r,v,s))
#endif

/* XS_INTERNAL is the explicit static-linkage variant of the default
 * XS macro.
 *
 * XS_EXTERNAL is the same as XS_INTERNAL except it does not include
 * "STATIC", ie. it exports XSUB symbols. You probably don't want that
 * for anything but the BOOT XSUB.
 *
 * See XSUB.h in core!
 */


/* TODO: This might be compatible further back than 5.10.0. */
#if PERL_VERSION_GE(5, 10, 0) && PERL_VERSION_LE(5, 15, 1)
#  undef XS_EXTERNAL
#  undef XS_INTERNAL
#  if defined(__CYGWIN__) && defined(USE_DYNAMIC_LOADING)
#    define XS_EXTERNAL(name) __declspec(dllexport) XSPROTO(name)
#    define XS_INTERNAL(name) STATIC XSPROTO(name)
#  endif
#  if defined(__SYMBIAN32__)
#    define XS_EXTERNAL(name) EXPORT_C XSPROTO(name)
#    define XS_INTERNAL(name) EXPORT_C STATIC XSPROTO(name)
#  endif
#  ifndef XS_EXTERNAL
#    if defined(HASATTRIBUTE_UNUSED) && !defined(__cplusplus)
#      define XS_EXTERNAL(name) void name(pTHX_ CV* cv __attribute__unused__)
#      define XS_INTERNAL(name) STATIC void name(pTHX_ CV* cv __attribute__unused__)
#    else
#      ifdef __cplusplus
#        define XS_EXTERNAL(name) extern "C" XSPROTO(name)
#        define XS_INTERNAL(name) static XSPROTO(name)
#      else
#        define XS_EXTERNAL(name) XSPROTO(name)
#        define XS_INTERNAL(name) STATIC XSPROTO(name)
#      endif
#    endif
#  endif
#endif

/* perl >= 5.10.0 && perl <= 5.15.1 */


/* The XS_EXTERNAL macro is used for functions that must not be static
 * like the boot XSUB of a module. If perl didn't have an XS_EXTERNAL
 * macro defined, the best we can do is assume XS is the same.
 * Dito for XS_INTERNAL.
 */
#ifndef XS_EXTERNAL
#  define XS_EXTERNAL(name) XS(name)
#endif
#ifndef XS_INTERNAL
#  define XS_INTERNAL(name) XS(name)
#endif

/* Now, finally, after all this mess, we want an ExtUtils::ParseXS
 * internal macro that we're free to redefine for varying linkage due
 * to the EXPORT_XSUB_SYMBOLS XS keyword. This is internal, use
 * XS_EXTERNAL(name) or XS_INTERNAL(name) in your code if you need to!
 */

#undef XS_EUPXS
#if defined(PERL_EUPXS_ALWAYS_EXPORT)
#  define XS_EUPXS(name) XS_EXTERNAL(name)
#else
   /* default to internal */
#  define XS_EUPXS(name) XS_INTERNAL(name)
#endif

#ifndef PERL_ARGS_ASSERT_CROAK_XS_USAGE
#define PERL_ARGS_ASSERT_CROAK_XS_USAGE assert(cv); assert(params)

/* prototype to pass -Wmissing-prototypes */
STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params);

STATIC void
S_croak_xs_usage(const CV *const cv, const char *const params)
{
    const GV *const gv = CvGV(cv);

    PERL_ARGS_ASSERT_CROAK_XS_USAGE;

    if (gv) {
        const char *const gvname = GvNAME(gv);
        const HV *const stash = GvSTASH(gv);
        const char *const hvname = stash ? HvNAME(stash) : NULL;

        if (hvname)
	    Perl_croak_nocontext("Usage: %s::%s(%s)", hvname, gvname, params);
        else
	    Perl_croak_nocontext("Usage: %s(%s)", gvname, params);
    } else {
        /* Pants. I don't think that it should be possible to get here. */
	Perl_croak_nocontext("Usage: CODE(0x%" UVxf ")(%s)", PTR2UV(cv), params);
    }
}
#undef  PERL_ARGS_ASSERT_CROAK_XS_USAGE

#define croak_xs_usage        S_croak_xs_usage

#endif

/* NOTE: the prototype of newXSproto() is different in versions of perls,
 * so we define a portable version of newXSproto()
 */
#ifdef newXS_flags
#define newXSproto_portable(name, c_impl, file, proto) newXS_flags(name, c_impl, file, proto, 0)
#else
#define newXSproto_portable(name, c_impl, file, proto) (PL_Sv=(SV*)newXS(name, c_impl, file), sv_setpv(PL_Sv, proto), (CV*)PL_Sv)
#endif /* !defined(newXS_flags) */

#if PERL_VERSION_LE(5, 21, 5)
#  define newXS_deffile(a,b) Perl_newXS(aTHX_ a,b,file)
#else
#  define newXS_deffile(a,b) Perl_newXS_deffile(aTHX_ a,b)
#endif

#line 2575 "lib/Sys/Virt.c"

XS_EUPXS(XS_Sys__Virt__open); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__open)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "name, flags");
    {
	SV *	name = ST(0)
;
	unsigned int	flags = (unsigned int)SvUV(ST(1))
;
#line 2430 "lib/Sys/Virt.xs"
    const char *uri = NULL;
#line 2590 "lib/Sys/Virt.c"
	virConnectPtr	RETVAL;
#line 2432 "lib/Sys/Virt.xs"
    if (SvOK(name))
        uri = SvPV_nolen(name);

    if (!(RETVAL = virConnectOpenAuth(uri, NULL, flags)))
        _croak_error();
#line 2598 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__open_auth); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__open_auth)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "name, creds, cb, flags");
    {
	SV *	name = ST(0)
;
	SV *	creds = ST(1)
;
	SV *	cb = ST(2)
;
	unsigned int	flags = (unsigned int)SvUV(ST(3))
;
#line 2448 "lib/Sys/Virt.xs"
    AV *credlist;
    virConnectAuth auth;
    int i;
    const char *uri = NULL;
#line 2630 "lib/Sys/Virt.c"
	virConnectPtr	RETVAL;
#line 2453 "lib/Sys/Virt.xs"
    if (SvOK(name))
        uri = SvPV_nolen(name);

    if (SvOK(cb) && SvOK(creds)) {
        memset(&auth, 0, sizeof auth);
        credlist = (AV*)SvRV(creds);
        auth.ncredtype = av_len(credlist) + 1;
        Newx(auth.credtype, auth.ncredtype, int);
        for (i = 0 ; i < auth.ncredtype ; i++) {
            SV **type = av_fetch(credlist, i, 0);
            auth.credtype[i] = SvIV(*type);
        }

        auth.cb = _open_auth_callback;
        auth.cbdata = cb;
        RETVAL = virConnectOpenAuth(uri,
                                    &auth,
                                    flags);
        Safefree(auth.credtype);
    } else {
        RETVAL = virConnectOpenAuth(uri,
                                    virConnectAuthPtrDefault,
                                    flags);
    }
    if (!RETVAL)
        _croak_error();
#line 2659 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_restore_domain); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_restore_domain)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "con, fromsv=&PL_sv_undef, dxmlsv=&PL_sv_undef, params_sv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	fromsv;
	SV *	dxmlsv;
	SV *	params_sv;
	unsigned int	flags;
#line 2491 "lib/Sys/Virt.xs"
    const char *from = NULL;
    const char *dxml = NULL;
    HV *params_hv = NULL;
    virTypedParameterPtr params;
    int nparams;
#line 2691 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::restore_domain() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    fromsv = &PL_sv_undef;
	else {
	    fromsv = ST(1)
;
	}

	if (items < 3)
	    dxmlsv = &PL_sv_undef;
	else {
	    dxmlsv = ST(2)
;
	}

	if (items < 4)
	    params_sv = &PL_sv_undef;
	else {
	    params_sv = ST(3)
;
	}

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 2497 "lib/Sys/Virt.xs"
    if (!SvOK(fromsv) && !SvOK(params_sv))
        croak("Either $from or $params parameter must be supplied");

    if (SvOK(dxmlsv))
        dxml = SvPV_nolen(dxmlsv);

    if (SvOK(fromsv))
        from = SvPV_nolen(fromsv);

    if (SvOK(params_sv)) {
        params_hv = (HV*)SvRV(params_sv);
    }

    if (params_hv) {
        nparams = 2;

        /* If parameters were supplied using the old way, we'll convert them
         * to the new style libvirt API, i.e.
         * dom->restore(filename, dxml, {FOO => bar}, flags) becomes
         * dom->restore({SAVE_PARAM_FILE => file,
         *               SAVE_PARAM_DXML => dxml,
         *               FOO => bar}, flags)
         */
        if (from)
            hv_store(params_hv,
                     VIR_DOMAIN_SAVE_PARAM_FILE,
                     strlen(VIR_DOMAIN_SAVE_PARAM_FILE),
                     fromsv, 0);
        if (dxml)
            hv_store(params_hv,
                     VIR_DOMAIN_SAVE_PARAM_DXML,
                     strlen(VIR_DOMAIN_SAVE_PARAM_DXML),
                     dxmlsv, 0);

        Newx(params, nparams, virTypedParameter);
        strncpy(params[0].field, VIR_DOMAIN_SAVE_PARAM_FILE,
                VIR_TYPED_PARAM_FIELD_LENGTH);
        params[0].type = VIR_TYPED_PARAM_STRING;

        strncpy(params[1].field, VIR_DOMAIN_SAVE_PARAM_DXML,
                VIR_TYPED_PARAM_FIELD_LENGTH);
        params[1].type = VIR_TYPED_PARAM_STRING;

        nparams = vir_typed_param_from_hv(params_hv, params, nparams);

        if ((virDomainRestoreParams(con, params, nparams, flags)) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }
        vir_typed_param_safe_free(params, nparams);
    } else {
        if (dxml || flags) {
            if (virDomainRestoreFlags(con, from, dxml, flags) < 0)
                _croak_error();
        } else {
            if (virDomainRestore(con, from) < 0)
                _croak_error();
        }
    }
#line 2788 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_save_image_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_save_image_xml_description)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, file, flags=0");
    {
	virConnectPtr	con;
	const char *	file = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 2563 "lib/Sys/Virt.xs"
    char *xml;
#line 2808 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_save_image_xml_description() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 2565 "lib/Sys/Virt.xs"
    if (!(xml = virDomainSaveImageGetXMLDesc(con, file, flags)))
        _croak_error();
    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 2830 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_define_save_image_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_define_save_image_xml)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, file, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	const char *	file = (const char *)SvPV_nolen(ST(1))
;
	const char *	xml = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::define_save_image_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 2580 "lib/Sys/Virt.xs"
    if (virDomainSaveImageDefineXML(con, file, xml, flags) < 0)
        _croak_error();
#line 2871 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__get_library_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__get_library_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "void");
    {
#line 2588 "lib/Sys/Virt.xs"
    unsigned long version;
#line 2887 "lib/Sys/Virt.c"
	unsigned long	RETVAL;
	dXSTARG;
#line 2590 "lib/Sys/Virt.xs"
    if (virGetVersion(&version, NULL, NULL) < 0)
        _croak_error();
    RETVAL = version;
#line 2894 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__get_conn_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__get_conn_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 2601 "lib/Sys/Virt.xs"
    unsigned long version;
#line 2912 "lib/Sys/Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::_get_conn_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2603 "lib/Sys/Virt.xs"
    if (virConnectGetVersion(con, &version) < 0)
        _croak_error();
    RETVAL = version;
#line 2927 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__get_conn_library_version); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__get_conn_library_version)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 2614 "lib/Sys/Virt.xs"
    unsigned long version;
#line 2945 "lib/Sys/Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::_get_conn_library_version() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2616 "lib/Sys/Virt.xs"
    if (virConnectGetLibVersion(con, &version) < 0)
        _croak_error();
    RETVAL = version;
#line 2960 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_is_encrypted); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_is_encrypted)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::is_encrypted() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2627 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectIsEncrypted(conn)) < 0)
        _croak_error();
#line 2989 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_is_secure); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_is_secure)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::is_secure() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2637 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectIsSecure(conn)) < 0)
        _croak_error();
#line 3018 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_is_alive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_is_alive)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "conn");
    {
	virConnectPtr	conn;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::is_alive() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2647 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectIsAlive(conn)) < 0)
        _croak_error();
#line 3047 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_set_keep_alive); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_set_keep_alive)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "conn, interval, count");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	int	interval = (int)SvIV(ST(1))
;
	unsigned int	count = (unsigned int)SvUV(ST(2))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::set_keep_alive() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2659 "lib/Sys/Virt.xs"
    if (virConnectSetKeepAlive(conn, interval, count) < 0)
        _croak_error();
#line 3080 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_type() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2667 "lib/Sys/Virt.xs"
    RETVAL = virConnectGetType(con);
#line 3107 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_uri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_uri)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_uri() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2676 "lib/Sys/Virt.xs"
    RETVAL = virConnectGetURI(con);
#line 3136 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_sysinfo); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_sysinfo)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_sysinfo() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2686 "lib/Sys/Virt.xs"
    RETVAL = virConnectGetSysinfo(con, flags);
#line 3173 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 2695 "lib/Sys/Virt.xs"
    virNodeInfo info;
#line 3192 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_info() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2697 "lib/Sys/Virt.xs"
    if (virNodeGetInfo(con, &info) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "model", 5, newSVpv(info.model, 0), 0);
    (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
    (void)hv_store (RETVAL, "cpus", 4, newSViv(info.cpus), 0);
    (void)hv_store (RETVAL, "mhz", 3, newSViv(info.mhz), 0);
    (void)hv_store (RETVAL, "nodes", 5, newSViv(info.nodes), 0);
    (void)hv_store (RETVAL, "sockets", 7, newSViv(info.sockets), 0);
    (void)hv_store (RETVAL, "cores", 5, newSViv(info.cores), 0);
    (void)hv_store (RETVAL, "threads", 7, newSViv(info.threads), 0);
#line 3215 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_security_model); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_security_model)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 2717 "lib/Sys/Virt.xs"
    virSecurityModel secmodel;
#line 3237 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_security_model() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2719 "lib/Sys/Virt.xs"
    if (virNodeGetSecurityModel(con, &secmodel) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "model", 5, newSVpv(secmodel.model, 0), 0);
    (void)hv_store (RETVAL, "doi", 3, newSVpv(secmodel.doi, 0), 0);
#line 3254 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_sev_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_sev_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    {
	virConnectPtr	conn;
	unsigned int	flags;
#line 2733 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 3278 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_sev_info() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2736 "lib/Sys/Virt.xs"
    if (virNodeGetSEVInfo(conn, &params, &nparams, flags) < 0) {
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    virTypedParamsFree(params, nparams);
#line 3302 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_cpu_map); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_cpu_map)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 2750 "lib/Sys/Virt.xs"
    unsigned char *cpumaps;
    unsigned int online;
    int ncpus;
#line 3329 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_cpu_map() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2754 "lib/Sys/Virt.xs"
    if ((ncpus = virNodeGetCPUMap(con, &cpumaps, &online, flags)) < 0)
        _croak_error();

    EXTEND(SP, 3);
    PUSHs(sv_2mortal(newSViv(ncpus)));
    PUSHs(sv_2mortal(newSVpvn((char*)cpumaps, VIR_CPU_MAPLEN(ncpus))));
    PUSHs(sv_2mortal(newSViv(online)));
    free(cpumaps);
#line 3354 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_node_free_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_free_memory)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 2767 "lib/Sys/Virt.xs"
    unsigned long long mem;
#line 3371 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2769 "lib/Sys/Virt.xs"
    if ((mem = virNodeGetFreeMemory(con)) == 0)
        _croak_error();

    RETVAL = virt_newSVull(mem);
#line 3386 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_cells_free_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_cells_free_memory)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, start, end");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	start = (int)SvIV(ST(1))
;
	int	end = (int)SvIV(ST(2))
;
#line 2783 "lib/Sys/Virt.xs"
    unsigned long long *mem;
    int i, num, ncells;
#line 3411 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_cells_free_memory() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 2786 "lib/Sys/Virt.xs"
    ncells = (end - start) + 1;
    Newx(mem, ncells, unsigned long long);
    if ((num = virNodeGetCellsFreeMemory(con, mem, start, ncells)) < 0) {
        Safefree(mem);
        _croak_error();
    }
    EXTEND(SP, num);
    for (i = 0 ; i < num ; i++) {
        SV *val = newSViv(mem[i]);
        PUSHs(sv_2mortal(val));
    }
    Safefree(mem);
#line 3433 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_node_free_pages); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_free_pages)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "con, pagesizes, start, end, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	pagesizes = ST(1)
;
	int	start = (int)SvIV(ST(2))
;
	int	end = (int)SvIV(ST(3))
;
	unsigned int	flags;
#line 2808 "lib/Sys/Virt.xs"
    AV *pagesizeslist;
    unsigned int *pages;
    unsigned int npages;
    unsigned long long *counts;
    int ncells;
    int i, j;
#line 3464 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_free_pages() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 2815 "lib/Sys/Virt.xs"
    ncells = (end - start) + 1;
    pagesizeslist = (AV *)SvRV(pagesizes);
    npages = av_len(pagesizeslist) + 1;
    Newx(pages, npages, unsigned int);
    for (i = 0; i < npages; i++) {
        SV **pagesize = av_fetch(pagesizeslist, i, 0);
        pages[i] = SvIV(*pagesize);
    }

    Newx(counts, npages * ncells, unsigned long long);

    if (virNodeGetFreePages(con, npages, pages, start,
                            ncells, counts, flags) < 0) {
        Safefree(counts);
        Safefree(pages);
        _croak_error();
    }
    EXTEND(SP, ncells);
    for (i = 0; i < ncells; i++) {
        HV *rec = newHV();
        HV *prec = newHV();
        (void)hv_store(rec, "cell", 4, newSViv(start + i), 0);
        (void)hv_store(rec, "pages", 5, newRV_noinc((SV *)prec), 0);

        for (j = 0; j < npages; j++) {
            (void)hv_store_ent(prec,
                               newSViv(pages[j]),
                               virt_newSVull(counts[(i * npages) + j]),
                               0);
        }
        PUSHs(newRV_noinc((SV *)rec));
    }
    Safefree(counts);
    Safefree(pages);
#line 3515 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_node_alloc_pages); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_node_alloc_pages)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "con, pages, start, end, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	pages = ST(1)
;
	int	start = (int)SvIV(ST(2))
;
	int	end = (int)SvIV(ST(3))
;
	unsigned int	flags;
#line 2858 "lib/Sys/Virt.xs"
    AV *pageslist;
    unsigned int npages;
    unsigned int *pagesizes;
    unsigned long long *pagecounts;
    unsigned int ncells;
    unsigned int i;
#line 3546 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::node_alloc_pages() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 2865 "lib/Sys/Virt.xs"
    ncells = (end - start) + 1;
    pageslist = (AV *)SvRV(pages);
    npages = av_len(pageslist) + 1;

    Newx(pagesizes, npages, unsigned int);
    Newx(pagecounts, npages, unsigned long long);
    for (i = 0; i < npages; i++) {
        SV **pageinforv = av_fetch(pageslist, i, 0);
        AV *pageinfo = (AV*)SvRV(*pageinforv);
        SV **pagesize = av_fetch(pageinfo, 0, 0);
        SV **pagecount = av_fetch(pageinfo, 1, 0);

        pagesizes[i] = SvIV(*pagesize);
        pagecounts[i] = virt_SvIVull(*pagecount);
    }

    if (virNodeAllocPages(con, npages, pagesizes, pagecounts,
                          start, ncells, flags) < 0) {
        Safefree(pagesizes);
        Safefree(pagecounts);
        _croak_error();
    }

    Safefree(pagesizes);
    Safefree(pagecounts);
#line 3588 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_node_cpu_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_cpu_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "con, cpuNum=VIR_NODE_CPU_STATS_ALL_CPUS, flags=0");
    {
	virConnectPtr	con;
	int	cpuNum;
	unsigned int	flags;
#line 2898 "lib/Sys/Virt.xs"
    virNodeCPUStatsPtr params;
    int nparams = 0;
    int i;
#line 3609 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_cpu_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    cpuNum = VIR_NODE_CPU_STATS_ALL_CPUS;
	else {
	    cpuNum = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 2902 "lib/Sys/Virt.xs"
    if (virNodeGetCPUStats(con, cpuNum, NULL, &nparams, flags) < 0)
        _croak_error();

    Newx(params, nparams, virNodeCPUStats);
    if (virNodeGetCPUStats(con, cpuNum, params, &nparams, flags) < 0) {
        Safefree(params);
        _croak_error();
    }
    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    for (i = 0 ; i < nparams ; i++) {
        if (strcmp(params[i].field, VIR_NODE_CPU_STATS_KERNEL) == 0) {
            (void)hv_store (RETVAL, "kernel", 6, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_USER) == 0) {
            (void)hv_store (RETVAL, "user", 4, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_IDLE) == 0) {
            (void)hv_store (RETVAL, "idle", 4, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_IOWAIT) == 0) {
            (void)hv_store (RETVAL, "iowait", 6, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_INTR) == 0) {
            (void)hv_store (RETVAL, "intr", 4, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_CPU_STATS_UTILIZATION) == 0) {
            (void)hv_store (RETVAL, "utilization", 11, virt_newSVull(params[i].value), 0);
        }
    }
    Safefree(params);
#line 3659 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_memory_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_memory_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "con, cellNum=VIR_NODE_MEMORY_STATS_ALL_CELLS, flags=0");
    {
	virConnectPtr	con;
	int	cellNum;
	unsigned int	flags;
#line 2937 "lib/Sys/Virt.xs"
    virNodeMemoryStatsPtr params;
    int nparams = 0;
    int i;
#line 3685 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_memory_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    cellNum = VIR_NODE_MEMORY_STATS_ALL_CELLS;
	else {
	    cellNum = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 2941 "lib/Sys/Virt.xs"
    if (virNodeGetMemoryStats(con, cellNum, NULL, &nparams, flags) < 0)
        _croak_error();

    Newx(params, nparams, virNodeMemoryStats);
    if (virNodeGetMemoryStats(con, cellNum, params, &nparams, flags) < 0) {
        Safefree(params);
        _croak_error();
    }
    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    for (i = 0 ; i < nparams ; i++) {
        if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_TOTAL) == 0) {
            (void)hv_store (RETVAL, "total", 5, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_FREE) == 0) {
            (void)hv_store (RETVAL, "free", 4, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_BUFFERS) == 0) {
            (void)hv_store (RETVAL, "buffers", 7, virt_newSVull(params[i].value), 0);
        } else if (strcmp(params[i].field, VIR_NODE_MEMORY_STATS_CACHED) == 0) {
            (void)hv_store (RETVAL, "cached", 6, virt_newSVull(params[i].value), 0);
        }
    }
    Safefree(params);
#line 3731 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_node_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_node_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    {
	virConnectPtr	conn;
	unsigned int	flags;
#line 2971 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 3755 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_node_memory_parameters() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 2974 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virNodeGetMemoryParameters(conn, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);

    if (virNodeGetMemoryParameters(conn, params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 3786 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_set_node_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_set_node_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	HV *	newparams;
	unsigned int	flags;
#line 2997 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 3813 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::set_node_memory_parameters() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::set_node_memory_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3000 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virNodeGetMemoryParameters(conn, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);

    if (virNodeGetMemoryParameters(conn, params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virNodeSetMemoryParameters(conn, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 3862 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_set_identity); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_set_identity)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "conn, newident, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	HV *	newident;
	unsigned int	flags;
#line 3027 "lib/Sys/Virt.xs"
    virTypedParameterPtr ident;
    int nident;
#line 3884 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::set_identity() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newident = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::set_identity",
				"newident");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3030 "lib/Sys/Virt.xs"
    nident = 9;
    Newx(ident, nident, virTypedParameter);

    strncpy(ident[0].field, VIR_CONNECT_IDENTITY_USER_NAME,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[0].type = VIR_TYPED_PARAM_STRING;

    strncpy(ident[1].field, VIR_CONNECT_IDENTITY_UNIX_USER_ID,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[1].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(ident[2].field, VIR_CONNECT_IDENTITY_GROUP_NAME,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[2].type = VIR_TYPED_PARAM_STRING;

    strncpy(ident[3].field, VIR_CONNECT_IDENTITY_UNIX_GROUP_ID,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[3].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(ident[4].field, VIR_CONNECT_IDENTITY_PROCESS_ID,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[4].type = VIR_TYPED_PARAM_LLONG;

    strncpy(ident[5].field, VIR_CONNECT_IDENTITY_PROCESS_TIME,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[5].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(ident[6].field, VIR_CONNECT_IDENTITY_SASL_USER_NAME,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[6].type = VIR_TYPED_PARAM_STRING;

    strncpy(ident[7].field, VIR_CONNECT_IDENTITY_X509_DISTINGUISHED_NAME,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[7].type = VIR_TYPED_PARAM_STRING;

    strncpy(ident[8].field, VIR_CONNECT_IDENTITY_SELINUX_CONTEXT,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    ident[8].type = VIR_TYPED_PARAM_STRING;

    nident = vir_typed_param_from_hv(newident, ident, nident);

    if (virConnectSetIdentity(conn, ident, nident, flags) < 0) {
        vir_typed_param_safe_free(ident, nident);
        _croak_error();
    }
    vir_typed_param_safe_free(ident, nident);
#line 3961 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_node_suspend_for_duration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_node_suspend_for_duration)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "conn, target, duration, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	target = (unsigned int)SvUV(ST(1))
;
	SV *	duration = ST(2)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::node_suspend_for_duration() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3086 "lib/Sys/Virt.xs"
    if (virNodeSuspendForDuration(conn, target, virt_SvIVull(duration), flags) < 0)
        _croak_error();
#line 4001 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_find_storage_pool_sources); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_find_storage_pool_sources)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, type, srcspec, flags=0");
    {
	virConnectPtr	con;
	const char *	type = (const char *)SvPV_nolen(ST(1))
;
	const char *	srcspec = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::find_storage_pool_sources() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3097 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectFindStoragePoolSources(con, type, srcspec, flags)) == NULL)
        _croak_error();
#line 4041 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_capabilities)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 3107 "lib/Sys/Virt.xs"
    char *xml;
#line 4060 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3109 "lib/Sys/Virt.xs"
    if (!(xml = virConnectGetCapabilities(con)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 4076 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_domain_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_domain_capabilities)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "con, emulatorsv, archsv, machinesv, virttypesv, flags=0");
    {
	virConnectPtr	con;
	SV *	emulatorsv = ST(1)
;
	SV *	archsv = ST(2)
;
	SV *	machinesv = ST(3)
;
	SV *	virttypesv = ST(4)
;
	unsigned int	flags;
#line 3126 "lib/Sys/Virt.xs"
    char *emulator = NULL;
    char *arch = NULL;
    char *machine = NULL;
    char *virttype = NULL;
    char *xml;
#line 4107 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_domain_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 3132 "lib/Sys/Virt.xs"
    if (SvOK(emulatorsv))
        emulator = SvPV_nolen(emulatorsv);
    if (SvOK(archsv))
        arch = SvPV_nolen(archsv);
    if (SvOK(machinesv))
        machine = SvPV_nolen(machinesv);
    if (SvOK(virttypesv))
        virttype = SvPV_nolen(virttypesv);

    if (!(xml = virConnectGetDomainCapabilities(con,
                                                emulator, arch,
                                                machine, virttype,
                                                flags)))
    _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 4142 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_storage_pool_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_storage_pool_capabilities)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3158 "lib/Sys/Virt.xs"
    char *xml;
#line 4161 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_storage_pool_capabilities() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3160 "lib/Sys/Virt.xs"
    if (!(xml = virConnectGetStoragePoolCapabilities(con, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 4184 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_compare_cpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_compare_cpu)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	char *	xml = (char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 3175 "lib/Sys/Virt.xs"
    int rc;
#line 4205 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::compare_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3177 "lib/Sys/Virt.xs"
    if ((rc = virConnectCompareCPU(con, xml, flags)) < 0)
        _croak_error();

    RETVAL = newSViv(rc);
#line 4227 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_compare_hypervisor_cpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_compare_hypervisor_cpu)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 7)
       croak_xs_usage(cv,  "con, emulatorsv, archsv, machinesv, virttypesv, xml, flags=0");
    {
	virConnectPtr	con;
	SV *	emulatorsv = ST(1)
;
	SV *	archsv = ST(2)
;
	SV *	machinesv = ST(3)
;
	SV *	virttypesv = ST(4)
;
	char *	xml = (char *)SvPV_nolen(ST(5))
;
	unsigned int	flags;
#line 3195 "lib/Sys/Virt.xs"
    char *emulator = NULL;
    char *arch = NULL;
    char *machine = NULL;
    char *virttype = NULL;
    int rc;
#line 4260 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::compare_hypervisor_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 7)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(6))
;
	}
#line 3201 "lib/Sys/Virt.xs"
    if (SvOK(emulatorsv))
        emulator = SvPV_nolen(emulatorsv);
    if (SvOK(archsv))
        arch = SvPV_nolen(archsv);
    if (SvOK(machinesv))
        machine = SvPV_nolen(machinesv);
    if (SvOK(virttypesv))
        virttype = SvPV_nolen(virttypesv);
    if ((rc = virConnectCompareHypervisorCPU(con, emulator, arch, machine, virttype, xml, flags)) < 0)
        _croak_error();

    RETVAL = newSViv(rc);
#line 4290 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_baseline_cpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_baseline_cpu)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	SV *	xml = ST(1)
;
	unsigned int	flags;
#line 3223 "lib/Sys/Virt.xs"
    AV *xmllist;
    const char **xmlstr;
    int xmllen;
    int i;
    char *retxml;
#line 4315 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::baseline_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3229 "lib/Sys/Virt.xs"
    xmllist = (AV*)SvRV(xml);
    xmllen = av_len(xmllist) + 1;
    Newx(xmlstr, xmllen, const char *);
    for (i = 0 ; i < xmllen ; i++) {
        SV **doc = av_fetch(xmllist, i, 0);
        xmlstr[i] = SvPV_nolen(*doc);
    }

    if (!(retxml = virConnectBaselineCPU(con, xmlstr, xmllen, flags))) {
        Safefree(xmlstr);
        _croak_error();
    }

    Safefree(xmlstr);
    RETVAL = newSVpv(retxml, 0);
    free(retxml);
#line 4349 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_baseline_hypervisor_cpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_baseline_hypervisor_cpu)
{
    dVAR; dXSARGS;
    if (items < 6 || items > 7)
       croak_xs_usage(cv,  "con, emulatorsv, archsv, machinesv, virttypesv, xml, flags=0");
    {
	virConnectPtr	con;
	SV *	emulatorsv = ST(1)
;
	SV *	archsv = ST(2)
;
	SV *	machinesv = ST(3)
;
	SV *	virttypesv = ST(4)
;
	SV *	xml = ST(5)
;
	unsigned int	flags;
#line 3258 "lib/Sys/Virt.xs"
    char *emulator = NULL;
    char *arch = NULL;
    char *machine = NULL;
    char *virttype = NULL;
    AV *xmllist;
    const char **xmlstr;
    int xmllen;
    int i;
    char *retxml;
#line 4386 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::baseline_hypervisor_cpu() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 7)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(6))
;
	}
#line 3268 "lib/Sys/Virt.xs"
    if (SvOK(emulatorsv))
        emulator = SvPV_nolen(emulatorsv);
    if (SvOK(archsv))
        arch = SvPV_nolen(archsv);
    if (SvOK(machinesv))
        machine = SvPV_nolen(machinesv);
    if (SvOK(virttypesv))
        virttype = SvPV_nolen(virttypesv);
    xmllist = (AV*)SvRV(xml);
    xmllen = av_len(xmllist) + 1;
    Newx(xmlstr, xmllen, const char *);
    for (i = 0 ; i < xmllen ; i++) {
        SV **doc = av_fetch(xmllist, i, 0);
        xmlstr[i] = SvPV_nolen(*doc);
    }

    if (!(retxml = virConnectBaselineHypervisorCPU(con, emulator, arch, machine, virttype,
                                                   xmlstr, xmllen, flags))) {
        Safefree(xmlstr);
        _croak_error();
    }

    Safefree(xmlstr);
    RETVAL = newSVpv(retxml, 0);
    free(retxml);
#line 4429 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_cpu_model_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_cpu_model_names)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, arch, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	char *	arch = (char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 3302 "lib/Sys/Virt.xs"
    int nnames;
    int i;
    char **names = NULL;
#line 4454 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_cpu_model_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 3306 "lib/Sys/Virt.xs"
    if ((nnames = virConnectGetCPUModelNames(con, arch, &names, flags)) < 0)
        _croak_error();

    EXTEND(SP, nnames);
    for (i = 0 ; i < nnames ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    free(names);
#line 4480 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_max_vcpus)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, type");
    {
	virConnectPtr	con;
	char *	type = (char *)SvPV_nolen(ST(1))
;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_max_vcpus() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3323 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectGetMaxVcpus(con, type)) < 0)
        _croak_error();
#line 4510 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_hostname)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
#line 3333 "lib/Sys/Virt.xs"
    char *host;
#line 4528 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_hostname() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3335 "lib/Sys/Virt.xs"
    if (!(host = virConnectGetHostname(con)))
        _croak_error();

    RETVAL = newSVpv(host, 0);
    free(host);
#line 4544 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_num_of_domains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_domains)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3348 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfDomains(con)) < 0)
        _croak_error();
#line 4573 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_domain_ids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_domain_ids)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxids = (int)SvIV(ST(1))
;
#line 3359 "lib/Sys/Virt.xs"
    int *ids;
    int i, nid;
#line 4596 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_domain_ids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3362 "lib/Sys/Virt.xs"
    Newx(ids, maxids, int);
    if ((nid = virConnectListDomains(con, ids, maxids)) < 0) {
        Safefree(ids);
        _croak_error();
    }
    EXTEND(SP, nid);
    for (i = 0 ; i < nid ; i++) {
        PUSHs(sv_2mortal(newSViv(ids[i])));
    }
    Safefree(ids);
#line 4616 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_domains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_domains)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3378 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfDefinedDomains(con)) < 0)
        _croak_error();
#line 4644 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_domain_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_domain_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3389 "lib/Sys/Virt.xs"
    char **names;
    int ndom;
    int i;
#line 4668 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_domain_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3393 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((ndom = virConnectListDefinedDomains(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, ndom);
    for (i = 0 ; i < ndom ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 4689 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_domains); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_domains)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3411 "lib/Sys/Virt.xs"
    virDomainPtr *doms;
    int i, ndom;
    SV *domrv;
#line 4711 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_domains() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3415 "lib/Sys/Virt.xs"
    if ((ndom = virConnectListAllDomains(con, &doms, flags)) < 0)
        _croak_error();

    EXTEND(SP, ndom);
    for (i = 0 ; i < ndom ; i++) {
        domrv = sv_newmortal();
        sv_setref_pv(domrv, "Sys::Virt::Domain", doms[i]);
        PUSHs(domrv);
    }
    free(doms);
#line 4738 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_interfaces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_interfaces)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3432 "lib/Sys/Virt.xs"
    virInterfacePtr *ifaces;
    int i, niface;
    SV *ifacerv;
#line 4760 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3436 "lib/Sys/Virt.xs"
    if ((niface = virConnectListAllInterfaces(con, &ifaces, flags)) < 0)
        _croak_error();

    EXTEND(SP, niface);
    for (i = 0 ; i < niface ; i++) {
        ifacerv = sv_newmortal();
        sv_setref_pv(ifacerv, "Sys::Virt::Interface", ifaces[i]);
        PUSHs(ifacerv);
    }
    free(ifaces);
#line 4787 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_nwfilters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_nwfilters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3453 "lib/Sys/Virt.xs"
    virNWFilterPtr *nwfilters;
    int i, nnwfilter;
    SV *nwfilterrv;
#line 4809 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_nwfilters() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3457 "lib/Sys/Virt.xs"
    if ((nnwfilter = virConnectListAllNWFilters(con, &nwfilters, flags)) < 0)
        _croak_error();

    EXTEND(SP, nnwfilter);
    for (i = 0 ; i < nnwfilter ; i++) {
        nwfilterrv = sv_newmortal();
        sv_setref_pv(nwfilterrv, "Sys::Virt::NWFilter", nwfilters[i]);
        PUSHs(nwfilterrv);
    }
    free(nwfilters);
#line 4836 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_nwfilter_bindings); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_nwfilter_bindings)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3474 "lib/Sys/Virt.xs"
    virNWFilterBindingPtr *bindings;
    int i, nbinding;
    SV *bindingrv;
#line 4858 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_nwfilter_bindings() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3478 "lib/Sys/Virt.xs"
    if ((nbinding = virConnectListAllNWFilterBindings(con, &bindings, flags)) < 0)
        _croak_error();

    EXTEND(SP, nbinding);
    for (i = 0 ; i < nbinding ; i++) {
        bindingrv = sv_newmortal();
        sv_setref_pv(bindingrv, "Sys::Virt::NWFilterBinding", bindings[i]);
        PUSHs(bindingrv);
    }
    free(bindings);
#line 4885 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_networks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_networks)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3495 "lib/Sys/Virt.xs"
    virNetworkPtr *nets;
    int i, nnet;
    SV *netrv;
#line 4907 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3499 "lib/Sys/Virt.xs"
    if ((nnet = virConnectListAllNetworks(con, &nets, flags)) < 0)
        _croak_error();

    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        netrv = sv_newmortal();
        sv_setref_pv(netrv, "Sys::Virt::Network", nets[i]);
        PUSHs(netrv);
    }
    free(nets);
#line 4934 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_node_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_node_devices)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3516 "lib/Sys/Virt.xs"
    virNodeDevicePtr *devs;
    int i, ndev;
    SV *devrv;
#line 4956 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3520 "lib/Sys/Virt.xs"
    if ((ndev = virConnectListAllNodeDevices(con, &devs, flags)) < 0)
        _croak_error();

    EXTEND(SP, ndev);
    for (i = 0 ; i < ndev ; i++) {
        devrv = sv_newmortal();
        sv_setref_pv(devrv, "Sys::Virt::NodeDevice", devs[i]);
        PUSHs(devrv);
    }
    free(devs);
#line 4983 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_secrets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_secrets)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3537 "lib/Sys/Virt.xs"
    virSecretPtr *secrets;
    int i, nsecret;
    SV *secretrv;
#line 5005 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_secrets() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3541 "lib/Sys/Virt.xs"
    if ((nsecret = virConnectListAllSecrets(con, &secrets, flags)) < 0)
        _croak_error();

    EXTEND(SP, nsecret);
    for (i = 0 ; i < nsecret ; i++) {
        secretrv = sv_newmortal();
        sv_setref_pv(secretrv, "Sys::Virt::Secret", secrets[i]);
        PUSHs(secretrv);
    }
    free(secrets);
#line 5032 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_list_all_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_all_storage_pools)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	flags;
#line 3558 "lib/Sys/Virt.xs"
    virStoragePoolPtr *pools;
    int i, npool;
    SV *poolrv;
#line 5054 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_all_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 3562 "lib/Sys/Virt.xs"
    if ((npool = virConnectListAllStoragePools(con, &pools, flags)) < 0)
        _croak_error();

    EXTEND(SP, npool);
    for (i = 0 ; i < npool ; i++) {
        poolrv = sv_newmortal();
        sv_setref_pv(poolrv, "Sys::Virt::StoragePool", pools[i]);
        PUSHs(poolrv);
    }
    free(pools);
#line 5081 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_networks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_networks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3578 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfNetworks(con)) < 0)
        _croak_error();
#line 5109 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_network_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_network_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3589 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
#line 5132 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3592 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nnet = virConnectListNetworks(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5153 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_networks); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_networks)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_networks() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3609 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfDefinedNetworks(con)) < 0)
        _croak_error();
#line 5181 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_network_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_network_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3620 "lib/Sys/Virt.xs"
    char **names;
    int ndom;
    int i;
#line 5205 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_network_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3624 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((ndom = virConnectListDefinedNetworks(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, ndom);
    for (i = 0 ; i < ndom ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5226 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_storage_pools)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3641 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfStoragePools(con)) < 0)
        _croak_error();
#line 5254 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_storage_pool_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3652 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
#line 5277 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3655 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nnet = virConnectListStoragePools(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5298 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_storage_pools); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_storage_pools)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_storage_pools() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3672 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfDefinedStoragePools(con)) < 0)
        _croak_error();
#line 5326 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_storage_pool_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_storage_pool_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3682 "lib/Sys/Virt.xs"
    char **names;
    int ndom;
    int i;
#line 5350 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_storage_pool_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3686 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((ndom = virConnectListDefinedStoragePools(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, ndom);
    for (i = 0 ; i < ndom ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5371 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_node_devices); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_node_devices)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, cap, flags=0");
    {
	virConnectPtr	con;
	SV *	cap = ST(1)
;
	int	flags;
#line 3705 "lib/Sys/Virt.xs"
    const char *capname = NULL;
#line 5391 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_node_devices() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 3707 "lib/Sys/Virt.xs"
    if (SvOK(cap))
        capname = SvPV_nolen(cap);
    if ((RETVAL = virNodeNumOfDevices(con, capname, flags)) < 0)
        _croak_error();
#line 5414 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_node_device_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_node_device_names)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, cap, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	SV *	cap = ST(1)
;
	int	maxnames = (int)SvIV(ST(2))
;
	int	flags;
#line 3722 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
    const char *capname = NULL;
#line 5441 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_node_device_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}
#line 3726 "lib/Sys/Virt.xs"
    if (SvOK(cap))
        capname = SvPV_nolen(cap);
    Newx(names, maxnames, char *);
    if ((nnet = virNodeListDevices(con, capname, names, maxnames, flags)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5471 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_interfaces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_interfaces)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3745 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfInterfaces(con)) < 0)
        _croak_error();
#line 5499 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_interface_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_interface_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3756 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
#line 5522 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3759 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nnet = virConnectListInterfaces(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5543 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_defined_interfaces); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_defined_interfaces)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_defined_interfaces() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3776 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfDefinedInterfaces(con)) < 0)
        _croak_error();
#line 5571 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_defined_interface_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_defined_interface_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3787 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
#line 5594 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_defined_interface_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3790 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nnet = virConnectListDefinedInterfaces(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5615 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_secrets); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_secrets)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_secrets() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3807 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfSecrets(con)) < 0)
        _croak_error();
#line 5643 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_secret_uuids); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_secret_uuids)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxuuids");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxuuids = (int)SvIV(ST(1))
;
#line 3818 "lib/Sys/Virt.xs"
    char **uuids;
    int i, nsecret;
#line 5666 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_secret_uuids() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3821 "lib/Sys/Virt.xs"
    Newx(uuids, maxuuids, char *);
    if ((nsecret = virConnectListSecrets(con, uuids, maxuuids)) < 0) {
        Safefree(uuids);
        _croak_error();
    }
    EXTEND(SP, nsecret);
    for (i = 0 ; i < nsecret ; i++) {
        PUSHs(sv_2mortal(newSVpv(uuids[i], 0)));
        free(uuids[i]);
    }
    Safefree(uuids);
#line 5687 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_num_of_nwfilters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_num_of_nwfilters)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    {
	virConnectPtr	con;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::num_of_nwfilters() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3838 "lib/Sys/Virt.xs"
    if ((RETVAL = virConnectNumOfNWFilters(con)) < 0)
        _croak_error();
#line 5715 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_list_nwfilter_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_list_nwfilter_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	maxnames = (int)SvIV(ST(1))
;
#line 3849 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
#line 5738 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::list_nwfilter_names() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3852 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nnet = virConnectListNWFilters(con, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 5759 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_get_all_domain_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_get_all_domain_stats)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "con, stats, doms_sv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	unsigned int	stats = (unsigned int)SvUV(ST(1))
;
	SV *	doms_sv;
	unsigned int	flags;
#line 3871 "lib/Sys/Virt.xs"
    AV *doms_av;
    int ndoms;
    int nstats;
    int i;
    virDomainPtr *doms = NULL;
    virDomainStatsRecordPtr *statsrec = NULL;
#line 5787 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::get_all_domain_stats() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    doms_sv = &PL_sv_undef;
	else {
	    doms_sv = ST(2)
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3879 "lib/Sys/Virt.xs"
    if (SvOK(doms_sv)) {
        doms_av = (AV*)SvRV(doms_sv);
        ndoms = av_len(doms_av) + 1;
    } else {
        ndoms = 0;
    }

    if (ndoms) {
        Newx(doms, ndoms + 1, virDomainPtr);

        for (i = 0 ; i < ndoms ; i++) {
            SV **dom = av_fetch(doms_av, i, 0);
            doms[i] = (virDomainPtr)SvIV((SV*)SvRV(*dom));
        }
        doms[ndoms] = NULL;

        if ((nstats = virDomainListGetStats(doms, stats, &statsrec, flags)) < 0) {
            Safefree(doms);
            _croak_error();
        }
    } else {
        doms = NULL;

        if ((nstats = virConnectGetAllDomainStats(con, stats, &statsrec, flags)) < 0) {
            Safefree(doms);
            _croak_error();
        }
    }

    EXTEND(SP, nstats);
    for (i = 0 ; i < nstats ; i++) {
        HV *rec = newHV();
        SV *dom = sv_newmortal();
        HV *data = vir_typed_param_to_hv(statsrec[i]->params,
                                         statsrec[i]->nparams);
        sv_setref_pv(dom, "Sys::Virt::Domain", statsrec[i]->dom);
        virDomainRef(statsrec[i]->dom);
        hv_store(rec, "dom", 3, SvREFCNT_inc(dom), 0);
        hv_store(rec, "data", 4, newRV((SV*)data), 0);
        PUSHs(newRV_noinc((SV*)rec));
    }
    virDomainStatsRecordListFree(statsrec);
    Safefree(doms);
#line 5854 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_domain_xml_from_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_xml_from_native)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, configdata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1))
;
	const char *	configdata = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
#line 3931 "lib/Sys/Virt.xs"
    char *xmldata;
#line 5876 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_xml_from_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3933 "lib/Sys/Virt.xs"
    if (!(xmldata = virConnectDomainXMLFromNative(con, configtype, configdata, flags)))
        _croak_error();

    RETVAL = newSVpv(xmldata, 0);
    free(xmldata);
#line 5899 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_domain_xml_to_native); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_xml_to_native)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, configtype, xmldata, flags=0");
    {
	virConnectPtr	con;
	const char *	configtype = (const char *)SvPV_nolen(ST(1))
;
	const char *	xmldata = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
#line 3949 "lib/Sys/Virt.xs"
    char *configdata;
#line 5922 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_xml_to_native() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 3951 "lib/Sys/Virt.xs"
    if (!(configdata = virConnectDomainXMLToNative(con, configtype, xmldata, flags)))
        _croak_error();

    RETVAL = newSVpv(configdata, 0);
    free(configdata);
#line 5945 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_domain_event_register); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_register)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conref, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0)
;
	SV*	cb = ST(1)
;
#line 3965 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
#line 5969 "lib/Sys/Virt.c"
#line 3968 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if (virConnectDomainEventRegister(con, _domain_event_lifecycle_callback,
                                      opaque, _domain_event_free) < 0)
        _croak_error();
#line 5980 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_domain_event_deregister); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_deregister)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_event_deregister() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 3983 "lib/Sys/Virt.xs"
    virConnectDomainEventDeregister(con, _domain_event_lifecycle_callback);
#line 6007 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_domain_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_register_any)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "conref, domref, eventID, cb");
    {
	SV*	conref = ST(0)
;
	SV*	domref = ST(1)
;
	int	eventID = (int)SvIV(ST(2))
;
	SV*	cb = ST(3)
;
#line 3993 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
    virDomainPtr dom;
    virConnectDomainEventGenericCallback callback;
#line 6034 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 3998 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    if (SvROK(domref)) {
        dom = (virDomainPtr)SvIV((SV*)SvRV(domref));
    } else {
        dom = NULL;
    }

    switch (eventID) {
    case VIR_DOMAIN_EVENT_ID_LIFECYCLE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_lifecycle_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_REBOOT:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_RTC_CHANGE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_rtcchange_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_WATCHDOG:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_watchdog_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_IO_ERROR:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_io_error_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_io_error_reason_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_GRAPHICS:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_graphics_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_CONTROL_ERROR:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_BLOCK_JOB:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_block_job_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_BLOCK_JOB_2:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_block_job_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_DISK_CHANGE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_disk_change_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_TRAY_CHANGE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_tray_change_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_PMSUSPEND:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmsuspend_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_PMSUSPEND_DISK:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmsuspend_disk_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_PMWAKEUP:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_pmwakeup_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_BALLOON_CHANGE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_balloonchange_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_DEVICE_ADDED:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_device_generic_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_device_generic_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_TUNABLE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_tunable_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_AGENT_LIFECYCLE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_agent_lifecycle_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_MIGRATION_ITERATION:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_migration_iteration_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_JOB_COMPLETED:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_job_completed_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_DEVICE_REMOVAL_FAILED:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_device_generic_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_METADATA_CHANGE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_metadata_change_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_BLOCK_THRESHOLD:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_block_threshold_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_MEMORY_FAILURE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_memory_failure_callback);
        break;
    case VIR_DOMAIN_EVENT_ID_MEMORY_DEVICE_SIZE_CHANGE:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_memory_device_size_change_callback);
        break;
    default:
        callback = VIR_DOMAIN_EVENT_CALLBACK(_domain_event_generic_callback);
        break;
    }

    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if ((RETVAL = virConnectDomainEventRegisterAny(con, dom, eventID, callback, opaque, _domain_event_free)) < 0)
        _croak_error();
#line 6139 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_domain_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_domain_event_deregister_any)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::domain_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4108 "lib/Sys/Virt.xs"
    virConnectDomainEventDeregisterAny(con, callbackID);
#line 6169 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_network_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_network_event_register_any)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "conref, netref, eventID, cb");
    {
	SV*	conref = ST(0)
;
	SV*	netref = ST(1)
;
	int	eventID = (int)SvIV(ST(2))
;
	SV*	cb = ST(3)
;
#line 4118 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
    virNetworkPtr net;
    virConnectNetworkEventGenericCallback callback;
#line 6196 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 4123 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    if (SvROK(netref)) {
        net = (virNetworkPtr)SvIV((SV*)SvRV(netref));
    } else {
        net = NULL;
    }

    switch (eventID) {
    case VIR_NETWORK_EVENT_ID_LIFECYCLE:
        callback = VIR_NETWORK_EVENT_CALLBACK(_network_event_lifecycle_callback);
        break;
    default:
        callback = VIR_NETWORK_EVENT_CALLBACK(_network_event_generic_callback);
        break;
    }

    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if ((RETVAL = virConnectNetworkEventRegisterAny(con, net, eventID, callback, opaque, _network_event_free)) < 0)
        _croak_error();
#line 6223 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_network_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_network_event_deregister_any)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::network_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4155 "lib/Sys/Virt.xs"
    virConnectNetworkEventDeregisterAny(con, callbackID);
#line 6253 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_storage_pool_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_storage_pool_event_register_any)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "conref, poolref, eventID, cb");
    {
	SV*	conref = ST(0)
;
	SV*	poolref = ST(1)
;
	int	eventID = (int)SvIV(ST(2))
;
	SV*	cb = ST(3)
;
#line 4165 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
    virStoragePoolPtr pool;
    virConnectStoragePoolEventGenericCallback callback;
#line 6280 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 4170 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    if (SvROK(poolref)) {
        pool = (virStoragePoolPtr)SvIV((SV*)SvRV(poolref));
    } else {
        pool = NULL;
    }

    switch (eventID) {
    case VIR_STORAGE_POOL_EVENT_ID_LIFECYCLE:
        callback = VIR_STORAGE_POOL_EVENT_CALLBACK(_storage_pool_event_lifecycle_callback);
        break;
    case VIR_STORAGE_POOL_EVENT_ID_REFRESH:
        callback = VIR_STORAGE_POOL_EVENT_CALLBACK(_storage_pool_event_generic_callback);
        break;
    default:
        callback = VIR_STORAGE_POOL_EVENT_CALLBACK(_storage_pool_event_generic_callback);
        break;
    }

    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if ((RETVAL = virConnectStoragePoolEventRegisterAny(con, pool, eventID, callback, opaque, _storage_pool_event_free)) < 0)
        _croak_error();
#line 6310 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_storage_pool_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_storage_pool_event_deregister_any)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::storage_pool_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4205 "lib/Sys/Virt.xs"
    virConnectStoragePoolEventDeregisterAny(con, callbackID);
#line 6340 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_node_device_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_node_device_event_register_any)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "conref, devref, eventID, cb");
    {
	SV*	conref = ST(0)
;
	SV*	devref = ST(1)
;
	int	eventID = (int)SvIV(ST(2))
;
	SV*	cb = ST(3)
;
#line 4215 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
    virNodeDevicePtr dev;
    virConnectNodeDeviceEventGenericCallback callback;
#line 6367 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 4220 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    if (SvROK(devref)) {
        dev = (virNodeDevicePtr)SvIV((SV*)SvRV(devref));
    } else {
        dev = NULL;
    }

    switch (eventID) {
    case VIR_NODE_DEVICE_EVENT_ID_LIFECYCLE:
        callback = VIR_NODE_DEVICE_EVENT_CALLBACK(_node_device_event_lifecycle_callback);
        break;
    case VIR_NODE_DEVICE_EVENT_ID_UPDATE:
        callback = VIR_NODE_DEVICE_EVENT_CALLBACK(_node_device_event_generic_callback);
        break;
    default:
        callback = VIR_NODE_DEVICE_EVENT_CALLBACK(_node_device_event_generic_callback);
        break;
    }

    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if ((RETVAL = virConnectNodeDeviceEventRegisterAny(con, dev, eventID, callback, opaque, _node_device_event_free)) < 0)
        _croak_error();
#line 6397 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_node_device_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_node_device_event_deregister_any)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::node_device_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4255 "lib/Sys/Virt.xs"
    virConnectNodeDeviceEventDeregisterAny(con, callbackID);
#line 6427 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_secret_event_register_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_secret_event_register_any)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "conref, secretref, eventID, cb");
    {
	SV*	conref = ST(0)
;
	SV*	secretref = ST(1)
;
	int	eventID = (int)SvIV(ST(2))
;
	SV*	cb = ST(3)
;
#line 4265 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
    virSecretPtr secret;
    virConnectSecretEventGenericCallback callback;
#line 6454 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 4270 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    if (SvROK(secretref)) {
        secret = (virSecretPtr)SvIV((SV*)SvRV(secretref));
    } else {
        secret = NULL;
    }

    switch (eventID) {
    case VIR_SECRET_EVENT_ID_LIFECYCLE:
        callback = VIR_SECRET_EVENT_CALLBACK(_secret_event_lifecycle_callback);
        break;
    case VIR_SECRET_EVENT_ID_VALUE_CHANGED:
        callback = VIR_SECRET_EVENT_CALLBACK(_secret_event_generic_callback);
        break;
    default:
        callback = VIR_SECRET_EVENT_CALLBACK(_secret_event_generic_callback);
        break;
    }

    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if ((RETVAL = virConnectSecretEventRegisterAny(con, secret, eventID, callback, opaque, _secret_event_free)) < 0)
        _croak_error();
#line 6484 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt_secret_event_deregister_any); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_secret_event_deregister_any)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, callbackID");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;
	int	callbackID = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::secret_event_deregister_any() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4305 "lib/Sys/Virt.xs"
    virConnectSecretEventDeregisterAny(con, callbackID);
#line 6514 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_register_close_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_register_close_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "conref, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	conref = ST(0)
;
	SV*	cb = ST(1)
;
#line 4313 "lib/Sys/Virt.xs"
    AV *opaque;
    virConnectPtr con;
#line 6537 "lib/Sys/Virt.c"
#line 4316 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(conref));
    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(conref);
    av_push(opaque, conref);
    av_push(opaque, cb);
    if (virConnectRegisterCloseCallback(con, _close_callback,
                                        opaque, _close_callback_free) < 0)
        _croak_error();
#line 6548 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_unregister_close_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_unregister_close_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	con;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::unregister_close_callback() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4331 "lib/Sys/Virt.xs"
    virConnectUnregisterCloseCallback(con, _close_callback);
#line 6575 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_interface_change_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_interface_change_begin)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::interface_change_begin() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4339 "lib/Sys/Virt.xs"
    if (virInterfaceChangeBegin(conn, flags) < 0)
        _croak_error();
#line 6611 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_interface_change_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_interface_change_commit)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::interface_change_commit() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4348 "lib/Sys/Virt.xs"
    if (virInterfaceChangeCommit(conn, flags) < 0)
        _croak_error();
#line 6647 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_interface_change_rollback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_interface_change_rollback)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "conn, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virConnectPtr	conn;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        conn = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::interface_change_rollback() -- conn is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4357 "lib/Sys/Virt.xs"
    if (virInterfaceChangeRollback(conn, flags) < 0)
        _croak_error();
#line 6683 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "con_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	con_rv = ST(0)
;
#line 4365 "lib/Sys/Virt.xs"
    virConnectPtr con;
#line 6703 "lib/Sys/Virt.c"
#line 4367 "lib/Sys/Virt.xs"
    con = (virConnectPtr)SvIV((SV*)SvRV(con_rv));
    if (con) {
        virConnectClose(con);
        sv_setiv((SV*)SvRV(con_rv), 0);
    }
#line 6710 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain__create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__create)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_create() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4383 "lib/Sys/Virt.xs"
    if (flags) {
        if (!(RETVAL = virDomainCreateXML(con, xml, flags)))
            _croak_error();
    } else {
        if (!(RETVAL = virDomainCreateLinux(con, xml, 0)))
            _croak_error();
    }
#line 6752 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__create_with_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__create_with_files)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, xml, fdssv, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	SV *	fdssv = ST(2)
;
	unsigned int	flags;
#line 4401 "lib/Sys/Virt.xs"
    AV *fdsav;
    unsigned int nfds;
    int *fds;
    int i;
#line 6782 "lib/Sys/Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_create_with_files() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4406 "lib/Sys/Virt.xs"
    if (!SvROK(fdssv))
        return;
    fdsav = (AV*)SvRV(fdssv);
    nfds = av_len(fdsav) + 1;
    Newx(fds, nfds, int);

    for (i = 0 ; i < nfds ; i++) {
        SV **fd = av_fetch(fdsav, i, 0);
        fds[i] = SvIV(*fd);
    }

    if (!(RETVAL = virDomainCreateXMLWithFiles(con, xml, nfds, fds, flags))) {
        Safefree(fds);
        _croak_error();
    }

    Safefree(fds);
#line 6817 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4433 "lib/Sys/Virt.xs"
    if (flags) {
        if (!(RETVAL = virDomainDefineXMLFlags(con, xml, flags)))
            _croak_error();
    } else {
        if (!(RETVAL = virDomainDefineXML(con, xml)))
            _croak_error();
    }
#line 6864 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_id)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, id");
    {
	virConnectPtr	con;
	int	id = (int)SvIV(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_id() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4449 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainLookupByID(con, id)))
        _croak_error();
#line 6898 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4460 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainLookupByName(con, name)))
        _croak_error();
#line 6932 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4471 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainLookupByUUID(con, uuid)))
        _croak_error();
#line 6966 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4482 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainLookupByUUIDString(con, uuid)))
        _croak_error();
#line 7000 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_id() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4492 "lib/Sys/Virt.xs"
    RETVAL = virDomainGetID(dom);
#line 7032 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 4501 "lib/Sys/Virt.xs"
    unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 7050 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_uuid() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4503 "lib/Sys/Virt.xs"
    if ((virDomainGetUUID(dom, rawuuid)) < 0)
        _croak_error();

    RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 7065 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 4515 "lib/Sys/Virt.xs"
    char uuid[VIR_UUID_STRING_BUFLEN];
#line 7083 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_uuid_string() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4517 "lib/Sys/Virt.xs"
    if ((virDomainGetUUIDString(dom, uuid)) < 0)
        _croak_error();

    RETVAL = newSVpv(uuid, 0);
#line 7098 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4529 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainGetName(dom)))
        _croak_error();
#line 7127 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_hostname); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_hostname)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_hostname() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4540 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainGetHostname(dom, flags)))
        _croak_error();
#line 7165 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_metadata)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 4)
       croak_xs_usage(cv,  "dom, type, uri=&PL_sv_undef, flags=0");
    {
	virDomainPtr	dom;
	int	type = (int)SvIV(ST(1))
;
	SV *	uri;
	unsigned int	flags;
#line 4553 "lib/Sys/Virt.xs"
    const char *uristr = NULL;
#line 7188 "lib/Sys/Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_metadata() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(2)
;
	}

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4555 "lib/Sys/Virt.xs"
    if (SvOK(uri))
        uristr = SvPV_nolen(uri);

    if (!(RETVAL = virDomainGetMetadata(dom, type, uristr, flags)))
        _croak_error();
#line 7219 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_metadata)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 6)
       croak_xs_usage(cv,  "dom, type, metadata=&PL_sv_undef, key=&PL_sv_undef, uri=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	type = (int)SvIV(ST(1))
;
	SV *	metadata;
	SV *	key;
	SV *	uri;
	unsigned int	flags;
#line 4573 "lib/Sys/Virt.xs"
    const char *metadatastr = NULL;
    const char *keystr = NULL;
    const char *uristr = NULL;
#line 7248 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_metadata() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    metadata = &PL_sv_undef;
	else {
	    metadata = ST(2)
;
	}

	if (items < 4)
	    key = &PL_sv_undef;
	else {
	    key = ST(3)
;
	}

	if (items < 5)
	    uri = &PL_sv_undef;
	else {
	    uri = ST(4)
;
	}

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 4577 "lib/Sys/Virt.xs"
    if (SvOK(metadata))
        metadatastr = SvPV_nolen(metadata);
    if (SvOK(key))
        keystr = SvPV_nolen(key);
    if (SvOK(uri))
        uristr = SvPV_nolen(uri);

    if (virDomainSetMetadata(dom, type, metadatastr, keystr, uristr, flags) < 0)
        _croak_error();
#line 7295 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::is_active() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4593 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainIsActive(dom)) < 0)
        _croak_error();
#line 7323 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::is_persistent() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4603 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainIsPersistent(dom)) < 0)
        _croak_error();
#line 7352 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_is_updated); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_is_updated)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::is_updated() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4613 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainIsUpdated(dom)) < 0)
        _croak_error();
#line 7381 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_suspend); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_suspend)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::suspend() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4623 "lib/Sys/Virt.xs"
    if ((virDomainSuspend(dom)) < 0)
        _croak_error();
#line 7410 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_resume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_resume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::resume() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4631 "lib/Sys/Virt.xs"
    if ((virDomainResume(dom)) < 0)
        _croak_error();
#line 7438 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pm_wakeup); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pm_wakeup)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pm_wakeup() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4640 "lib/Sys/Virt.xs"
    if ((virDomainPMWakeup(dom, flags)) < 0)
        _croak_error();
#line 7474 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_save)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 5)
       croak_xs_usage(cv,  "dom, tosv=&PL_sv_undef, dxmlsv=&PL_sv_undef, params_sv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	tosv;
	SV *	dxmlsv;
	SV *	params_sv;
	unsigned int	flags;
#line 4653 "lib/Sys/Virt.xs"
    const char *to = NULL;
    const char *dxml = NULL;
    HV *params_hv = NULL;
    virTypedParameterPtr params;
    int nparams;
#line 7501 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    tosv = &PL_sv_undef;
	else {
	    tosv = ST(1)
;
	}

	if (items < 3)
	    dxmlsv = &PL_sv_undef;
	else {
	    dxmlsv = ST(2)
;
	}

	if (items < 4)
	    params_sv = &PL_sv_undef;
	else {
	    params_sv = ST(3)
;
	}

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 4659 "lib/Sys/Virt.xs"
    if (!SvOK(tosv) && !SvOK(params_sv))
        croak("Either $to or $params parameter must be supplied");

    if (SvOK(dxmlsv))
        dxml = SvPV_nolen(dxmlsv);

    if (SvOK(tosv))
        to = SvPV_nolen(tosv);

    if (SvOK(params_sv)) {
        params_hv = (HV*)SvRV(params_sv);
    }

    if (params_hv) {
        nparams = 2;

        /* If parameters were supplied using the old way, we'll convert them
         * to the new style libvirt API, i.e.
         * dom->save(filename, dxml, {FOO => bar}, flags) becomes
         * dom->save({SAVE_PARAM_FILE => file,
         *            SAVE_PARAM_DXML => dxml,
         *            FOO => bar}, flags)
         */
        if (to)
            hv_store(params_hv,
                     VIR_DOMAIN_SAVE_PARAM_FILE,
                     strlen(VIR_DOMAIN_SAVE_PARAM_FILE),
                     tosv, 0);
        if (dxml)
            hv_store(params_hv,
                     VIR_DOMAIN_SAVE_PARAM_DXML,
                     strlen(VIR_DOMAIN_SAVE_PARAM_DXML),
                     dxmlsv, 0);

        Newx(params, nparams, virTypedParameter);
        strncpy(params[0].field, VIR_DOMAIN_SAVE_PARAM_FILE,
                VIR_TYPED_PARAM_FIELD_LENGTH);
        params[0].type = VIR_TYPED_PARAM_STRING;

        strncpy(params[1].field, VIR_DOMAIN_SAVE_PARAM_DXML,
                VIR_TYPED_PARAM_FIELD_LENGTH);
        params[1].type = VIR_TYPED_PARAM_STRING;

        nparams = vir_typed_param_from_hv(params_hv, params, nparams);

        if ((virDomainSaveParams(dom, params, nparams, flags)) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }
        vir_typed_param_safe_free(params, nparams);
    } else {
        if (dxml || flags) {
            if ((virDomainSaveFlags(dom, to, dxml, flags)) < 0)
                _croak_error();
        } else {
            if ((virDomainSave(dom, to)) < 0)
                _croak_error();
        }
    }
#line 7598 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_managed_save); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_managed_save)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::managed_save() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4725 "lib/Sys/Virt.xs"
    if ((virDomainManagedSave(dom, flags)) < 0)
        _croak_error();
#line 7634 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_has_managed_save_image); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_has_managed_save_image)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::has_managed_save_image() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4734 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainHasManagedSaveImage(dom, flags)) < 0)
        _croak_error();
#line 7670 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_managed_save_remove); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_managed_save_remove)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::managed_save_remove() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4745 "lib/Sys/Virt.xs"
    if ((virDomainManagedSaveRemove(dom, flags)) < 0)
        _croak_error();
#line 7707 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_managed_save_define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_managed_save_define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::managed_save_define_xml() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4755 "lib/Sys/Virt.xs"
    if (virDomainManagedSaveDefineXML(dom, xml, flags) < 0)
        _croak_error();
#line 7745 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_managed_save_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_managed_save_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4763 "lib/Sys/Virt.xs"
    char *xml;
#line 7763 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::managed_save_get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4765 "lib/Sys/Virt.xs"
    if (!(xml = virDomainManagedSaveGetXMLDesc(dom, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 7786 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_core_dump); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_core_dump)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, to, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::core_dump() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4780 "lib/Sys/Virt.xs"
    if (virDomainCoreDump(dom, to, flags) < 0)
        _croak_error();
#line 7825 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_core_dump_format); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_core_dump_format)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, to, format, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	to = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	format = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::core_dump_format() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4791 "lib/Sys/Virt.xs"
    if (virDomainCoreDumpWithFormat(dom, to, format, flags) < 0)
        _croak_error();
#line 7865 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 4799 "lib/Sys/Virt.xs"
    virDomainInfo info;
#line 7882 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4801 "lib/Sys/Virt.xs"
    if (virDomainGetInfo(dom, &info) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
    (void)hv_store (RETVAL, "maxMem", 6, newSViv(info.maxMem), 0);
    (void)hv_store (RETVAL, "memory", 6, newSViv(info.memory), 0);
    (void)hv_store (RETVAL, "nrVirtCpu", 9, newSViv(info.nrVirtCpu), 0);
    (void)hv_store (RETVAL, "cpuTime", 7, virt_newSVull(info.cpuTime), 0);
#line 7902 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_time)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4818 "lib/Sys/Virt.xs"
    long long secs;
    unsigned int nsecs;
#line 7926 "lib/Sys/Virt.c"
	AV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_time() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4821 "lib/Sys/Virt.xs"
    if (virDomainGetTime(dom, &secs, &nsecs, flags) < 0)
        _croak_error();

    RETVAL = (AV *)sv_2mortal((SV*)newAV());
    (void)av_push(RETVAL, virt_newSVull(secs));
    (void)av_push(RETVAL, newSViv(nsecs));
#line 7950 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_time); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_time)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, secssv, nsecs, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	secssv = ST(1)
;
	unsigned int	nsecs = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 4838 "lib/Sys/Virt.xs"
    long long secs;
#line 7979 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_time() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4840 "lib/Sys/Virt.xs"
    secs = virt_SvIVll(secssv);

    if (virDomainSetTime(dom, secs, nsecs, flags) < 0)
        _croak_error();
#line 8000 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_user_password); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_user_password)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, username, password, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	username = (const char *)SvPV_nolen(ST(1))
;
	const char *	password = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_user_password() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4853 "lib/Sys/Virt.xs"
    if (virDomainSetUserPassword(dom, username, password, flags) < 0)
        _croak_error();
#line 8040 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_rename); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_rename)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newname, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	newname = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::rename() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4862 "lib/Sys/Virt.xs"
    if (virDomainRename(dom, newname, flags) < 0)
        _croak_error();
#line 8078 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_control_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_control_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4870 "lib/Sys/Virt.xs"
    virDomainControlInfo info;
#line 8096 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_control_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4872 "lib/Sys/Virt.xs"
    if (virDomainGetControlInfo(dom, &info, flags) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
    (void)hv_store (RETVAL, "details", 7, newSViv(info.details), 0);
    (void)hv_store (RETVAL, "stateTime", 9, virt_newSVull(info.stateTime), 0);
#line 8121 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_state)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 4888 "lib/Sys/Virt.xs"
    int state;
    int reason;
#line 8147 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_state() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 4891 "lib/Sys/Virt.xs"
    if (virDomainGetState(dom, &state, &reason, flags) < 0)
        _croak_error();

    XPUSHs(sv_2mortal(newSViv(state)));
    XPUSHs(sv_2mortal(newSViv(reason)));
#line 8169 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_console); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_console)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, devname, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	SV *	devname = ST(2)
;
	unsigned int	flags;
#line 4905 "lib/Sys/Virt.xs"
    const char *devnamestr = NULL;
#line 8192 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_console() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::open_console() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4907 "lib/Sys/Virt.xs"
    if (SvOK(devname))
        devnamestr = SvPV_nolen(devname);

    if (virDomainOpenConsole(dom, devnamestr, st, flags) < 0)
        _croak_error();
#line 8222 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_channel); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_channel)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, devname, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	SV *	devname = ST(2)
;
	unsigned int	flags;
#line 4921 "lib/Sys/Virt.xs"
    const char *devnamestr = NULL;
#line 8245 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_channel() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::open_channel() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4923 "lib/Sys/Virt.xs"
    if (SvOK(devname))
        devnamestr = SvPV_nolen(devname);

    if (virDomainOpenChannel(dom, devnamestr, st, flags) < 0)
        _croak_error();
#line 8275 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_graphics); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_graphics)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, idx, fd, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	idx = (unsigned int)SvUV(ST(1))
;
	int	fd = (int)SvIV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_graphics() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4937 "lib/Sys/Virt.xs"
    if (virDomainOpenGraphics(dom, idx, fd, flags) < 0)
        _croak_error();
#line 8315 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_open_graphics_fd); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_open_graphics_fd)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, idx, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	idx = (unsigned int)SvUV(ST(1))
;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::open_graphics_fd() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4947 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainOpenGraphicsFD(dom, idx, flags)) < 0)
        _croak_error();
#line 8353 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_screenshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_screenshot)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, st, screen, flags=0");
    {
	virDomainPtr	dom;
	virStreamPtr	st;
	unsigned int	screen = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 4960 "lib/Sys/Virt.xs"
    char *mimetype;
#line 8375 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::screenshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::screenshot() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 4962 "lib/Sys/Virt.xs"
    if (!(mimetype = virDomainScreenshot(dom, st, screen, flags)))
        _croak_error();
    RETVAL = newSVpv(mimetype, 0);
    free(mimetype);
#line 8405 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_block_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_block_info)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, dev, flags=0");
    {
	virDomainPtr	dom;
	const char *	dev = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 4976 "lib/Sys/Virt.xs"
    virDomainBlockInfo info;
#line 8426 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_block_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 4978 "lib/Sys/Virt.xs"
    if (virDomainGetBlockInfo(dom, dev, &info, flags) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
    (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
    (void)hv_store (RETVAL, "physical", 8, virt_newSVull(info.physical), 0);
#line 8451 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_job_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_job_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 4993 "lib/Sys/Virt.xs"
    virDomainJobInfo info;
#line 8473 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_job_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 4995 "lib/Sys/Virt.xs"
    if (virDomainGetJobInfo(dom, &info) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
    (void)hv_store (RETVAL, "timeElapsed", 11, virt_newSVull(info.timeElapsed), 0);
    (void)hv_store (RETVAL, "timeRemaining", 13, virt_newSVull(info.timeRemaining), 0);
    (void)hv_store (RETVAL, "dataTotal", 9, virt_newSVull(info.dataTotal), 0);
    (void)hv_store (RETVAL, "dataProcessed", 13, virt_newSVull(info.dataProcessed), 0);
    (void)hv_store (RETVAL, "dataRemaining", 13, virt_newSVull(info.dataRemaining), 0);
    (void)hv_store (RETVAL, "memTotal", 8, virt_newSVull(info.memTotal), 0);
    (void)hv_store (RETVAL, "memProcessed", 12, virt_newSVull(info.memProcessed), 0);
    (void)hv_store (RETVAL, "memRemaining", 12, virt_newSVull(info.memRemaining), 0);
    (void)hv_store (RETVAL, "fileTotal", 9, virt_newSVull(info.fileTotal), 0);
    (void)hv_store (RETVAL, "fileProcessed", 13, virt_newSVull(info.fileProcessed), 0);
    (void)hv_store (RETVAL, "fileRemaining", 13, virt_newSVull(info.fileRemaining), 0);
#line 8500 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_job_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_job_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5020 "lib/Sys/Virt.xs"
    int type;
    virTypedParameterPtr params = NULL;
    int nparams = 0;
    HV *paramsHv;
    SV *typeSv;
#line 8529 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_job_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5026 "lib/Sys/Virt.xs"
    if (virDomainGetJobStats(dom, &type, &params, &nparams, flags) < 0) {
        _croak_error();
    }

    typeSv = newSViv(type);
    paramsHv = vir_typed_param_to_hv(params, nparams);
    virTypedParamsFree(params, nparams);

    EXTEND(SP, 2);
    PUSHs(newRV_noinc((SV*)typeSv));
    PUSHs(newRV_noinc((SV*)paramsHv));
#line 8557 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_abort_job); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_abort_job)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::abort_job() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5044 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainAbortJobFlags(dom, flags) < 0)
            _croak_error();
    } else {
        if (virDomainAbortJob(dom) < 0)
            _croak_error();
    }
#line 8598 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_abort_block_job); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_abort_block_job)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::abort_block_job() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5059 "lib/Sys/Virt.xs"
    if (virDomainBlockJobAbort(dom, path, flags) < 0)
        _croak_error();
#line 8636 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_block_job_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_block_job_info)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 5069 "lib/Sys/Virt.xs"
    virDomainBlockJobInfo info;
#line 8656 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_block_job_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5071 "lib/Sys/Virt.xs"
    if (virDomainGetBlockJobInfo(dom, path, &info, flags) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
    (void)hv_store (RETVAL, "bandwidth", 9, virt_newSVull(info.bandwidth), 0);
    (void)hv_store (RETVAL, "cur", 3, virt_newSVull(info.cur), 0);
    (void)hv_store (RETVAL, "end", 3, virt_newSVull(info.end), 0);
#line 8682 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_block_job_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_block_job_speed)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, path, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_block_job_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 5090 "lib/Sys/Virt.xs"
    if (virDomainBlockJobSetSpeed(dom, path, bandwidth, flags) < 0)
        _croak_error();
#line 8727 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_pull); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_pull)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, path, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_pull() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 5101 "lib/Sys/Virt.xs"
    if (virDomainBlockPull(dom, path, bandwidth, flags) < 0)
        _croak_error();
#line 8767 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_rebase); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_rebase)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, base, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	const char *	base = (const char *)SvPV_nolen(ST(2))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(3))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_rebase() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 5113 "lib/Sys/Virt.xs"
    if (virDomainBlockRebase(dom, path, base, bandwidth, flags) < 0)
        _croak_error();
#line 8809 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_copy)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, destxml, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	const char *	destxml = (const char *)SvPV_nolen(ST(2))
;
	HV *	newparams;
	unsigned long	flags;
#line 5125 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 8835 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_copy() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(3);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::block_copy",
				"newparams");
		}
	} STMT_END
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(4))
;
	}
#line 5128 "lib/Sys/Virt.xs"
    nparams = 3;
    Newx(params, nparams, virTypedParameter);

    strncpy(params[0].field, VIR_DOMAIN_BLOCK_COPY_BANDWIDTH,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[0].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(params[1].field, VIR_DOMAIN_BLOCK_COPY_GRANULARITY,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[1].type = VIR_TYPED_PARAM_UINT;

    strncpy(params[2].field, VIR_DOMAIN_BLOCK_COPY_BUF_SIZE,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[2].type = VIR_TYPED_PARAM_UINT;

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainBlockCopy(dom, path, destxml, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    vir_typed_param_safe_free(params, nparams);
#line 8889 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_commit); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_commit)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "dom, path, base, top, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	const char *	base = (const char *)SvPV_nolen(ST(2))
;
	const char *	top = (const char *)SvPV_nolen(ST(3))
;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(4))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_commit() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 5162 "lib/Sys/Virt.xs"
    if (virDomainBlockCommit(dom, path, base, top, bandwidth, flags) < 0)
        _croak_error();
#line 8933 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_disk_errors); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_disk_errors)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5171 "lib/Sys/Virt.xs"
    virDomainDiskErrorPtr errors;
    unsigned int maxerrors;
    int ret;
    int i;
#line 8956 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_disk_errors() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5176 "lib/Sys/Virt.xs"
    if ((ret = virDomainGetDiskErrors(dom, NULL, 0, 0)) < 0)
        _croak_error();
    maxerrors = ret;
    Newx(errors, maxerrors, virDomainDiskError);
    if ((ret = virDomainGetDiskErrors(dom, errors, maxerrors, flags)) < 0) {
        Safefree(errors);
        _croak_error();
    }
    EXTEND(SP, ret);
    for (i = 0 ; i < ret ; i++) {
        HV *rec = newHV();
        (void)hv_store(rec, "path", 4, newSVpv(errors[i].disk, 0), 0);
        (void)hv_store(rec, "error", 5, newSViv(errors[i].error), 0);
        PUSHs(newRV_noinc((SV *)rec));
    }

    Safefree(errors);
#line 8990 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5200 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
    char *type;
#line 9010 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5204 "lib/Sys/Virt.xs"
    if (!(type = virDomainGetSchedulerType(dom, &nparams)))
        _croak_error();

    free(type);
    Newx(params, nparams, virTypedParameter);
    if (flags) {
        if (virDomainGetSchedulerParametersFlags(dom, params, &nparams, flags) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }
    } else {
        if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }
    }
    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 9046 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_scheduler_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_scheduler_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 5232 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
    char *type;
#line 9074 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_scheduler_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_scheduler_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5236 "lib/Sys/Virt.xs"
    if (!(type = virDomainGetSchedulerType(dom, &nparams)))
        _croak_error();

    free(type);
    Newx(params, nparams, virTypedParameter);
    if (virDomainGetSchedulerParameters(dom, params, &nparams) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    nparams = vir_typed_param_from_hv(newparams, params, nparams);
    if (flags) {
        if (virDomainSetSchedulerParametersFlags(dom, params, nparams, flags) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }
    } else {
        if (virDomainSetSchedulerParameters(dom, params, nparams) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }
    }
    vir_typed_param_safe_free(params, nparams);
#line 9127 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5265 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9146 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_memory_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5268 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetMemoryParameters(dom, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);

    if (virDomainGetMemoryParameters(dom, params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 9177 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_memory_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_memory_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 5291 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9204 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_memory_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_memory_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5294 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetMemoryParameters(dom, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);

    if (virDomainGetMemoryParameters(dom, params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainSetMemoryParameters(dom, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 9253 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_numa_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_numa_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5319 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9272 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_numa_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5322 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetNumaParameters(dom, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);

    if (virDomainGetNumaParameters(dom, params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 9303 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_numa_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_numa_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 5345 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9330 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_numa_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_numa_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5348 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetNumaParameters(dom, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);

    if (virDomainGetNumaParameters(dom, params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainSetNumaParameters(dom, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 9379 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_blkio_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_blkio_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5373 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9398 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_blkio_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5376 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetBlkioParameters(dom, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virBlkioParameter);

    if (virDomainGetBlkioParameters(dom, params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 9429 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_blkio_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_blkio_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 5399 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9456 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_blkio_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_blkio_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5402 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetBlkioParameters(dom, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virBlkioParameter);

    if (virDomainGetBlkioParameters(dom, params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainSetBlkioParameters(dom, params, nparams,
                                    flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 9506 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_perf_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_perf_events)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5428 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 9525 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_perf_events() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5431 "lib/Sys/Virt.xs"
    if (virDomainGetPerfEvents(dom, &params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 9550 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_perf_events); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_perf_events)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 5448 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 9577 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_perf_events() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_perf_events",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5451 "lib/Sys/Virt.xs"
    if (virDomainGetPerfEvents(dom, &params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainSetPerfEvents(dom, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 9620 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_launch_security_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_launch_security_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5470 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 9639 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_launch_security_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5473 "lib/Sys/Virt.xs"
    if (virDomainGetLaunchSecurityInfo(dom, &params, &nparams, flags) < 0) {
        _croak_error();
    }
    RETVAL = vir_typed_param_to_hv(params, nparams);
    virTypedParamsFree(params, nparams);
#line 9662 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_launch_security_state); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_launch_security_state)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	HV *	newparams;
	unsigned int	flags;
#line 5488 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 9689 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_launch_security_state() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_launch_security_state",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5491 "lib/Sys/Virt.xs"
    nparams = 3;
    Newx(params, nparams, virTypedParameter);

    strncpy(params[0].field, VIR_DOMAIN_LAUNCH_SECURITY_SEV_SECRET,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[0].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[1].field, VIR_DOMAIN_LAUNCH_SECURITY_SEV_SECRET_HEADER,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[1].type = VIR_TYPED_PARAM_STRING;

    strncpy(params[2].field, VIR_DOMAIN_LAUNCH_SECURITY_SEV_SECRET_SET_ADDRESS,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[2].type = VIR_TYPED_PARAM_ULLONG;

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainSetLaunchSecurityState(dom, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 9742 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_guest_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_guest_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "dom, types=0, flags=0");
    {
	virDomainPtr	dom;
	int	types;
	unsigned int	flags;
#line 5521 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 9762 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_guest_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    types = 0;
	else {
	    types = (int)SvIV(ST(1))
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5524 "lib/Sys/Virt.xs"
    if (virDomainGetGuestInfo(dom, types, &params, &nparams, flags) < 0) {
        _croak_error();
    }
    RETVAL = vir_typed_param_to_hv(params, nparams);
    virTypedParamsFree(params, nparams);
#line 9792 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_max_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_max_memory)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5537 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainGetMaxMemory(dom)))
        _croak_error();
#line 9825 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_max_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_max_memory)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dom, val");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_max_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5548 "lib/Sys/Virt.xs"
    if (virDomainSetMaxMemory(dom, val) < 0)
        _croak_error();
#line 9856 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_memory); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_memory)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, val, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	val = (unsigned long)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_memory() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5558 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainSetMemoryFlags(dom, val, flags) < 0)
            _croak_error();
    } else {
        if (virDomainSetMemory(dom, val) < 0)
            _croak_error();
    }
#line 9899 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_memory_stats_period); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_memory_stats_period)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, val, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	val = (int)SvIV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_memory_stats_period() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5573 "lib/Sys/Virt.xs"
    if (virDomainSetMemoryStatsPeriod(dom, val, flags) < 0)
        _croak_error();
#line 9937 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_max_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_max_vcpus)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_max_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5581 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainGetMaxVcpus(dom)))
        _croak_error();
#line 9965 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_vcpus)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, num, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	num = (int)SvIV(ST(1))
;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 5593 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainSetVcpusFlags(dom, num, flags) < 0)
            _croak_error();
    } else {
        if (virDomainSetVcpus(dom, num) < 0)
            _croak_error();
    }
#line 10009 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_vcpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_vcpu)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, cpumap, state, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	cpumap = (const char *)SvPV_nolen(ST(1))
;
	int	state = (int)SvIV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_vcpu() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 5608 "lib/Sys/Virt.xs"
    if (virDomainSetVcpu(dom, cpumap, state, flags) < 0)
        _croak_error();
#line 10049 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_vcpus)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 5616 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainGetVcpusFlags(dom, flags)) < 0)
        _croak_error();
#line 10085 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_guest_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_guest_vcpus)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, cpumap, state, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	cpumap = (const char *)SvPV_nolen(ST(1))
;
	int	state = (int)SvIV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_guest_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 5629 "lib/Sys/Virt.xs"
    if (virDomainSetGuestVcpus(dom, cpumap, state, flags) < 0)
        _croak_error();
#line 10126 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_guest_vcpus); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_guest_vcpus)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5638 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    unsigned int nparams = 0;
#line 10145 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_guest_vcpus() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5641 "lib/Sys/Virt.xs"
    if (virDomainGetGuestVcpus(dom, &params, &nparams, flags) < 0) {
        _croak_error();
    }
    RETVAL = vir_typed_param_to_hv(params, nparams);
    virTypedParamsFree(params, nparams);
#line 10168 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dom, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5655 "lib/Sys/Virt.xs"
    if (virDomainSetAutostart(dom, autostart) < 0)
        _croak_error();
#line 10203 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 5663 "lib/Sys/Virt.xs"
    int autostart;
#line 10220 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_autostart() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5665 "lib/Sys/Virt.xs"
    if (virDomainGetAutostart(dom, &autostart) < 0)
        _croak_error();
    RETVAL = autostart;
#line 10235 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_scheduler_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 5676 "lib/Sys/Virt.xs"
    int nparams;
#line 10253 "lib/Sys/Virt.c"
	char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_scheduler_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5678 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainGetSchedulerType(dom, &nparams)) == NULL)
        _croak_error();
#line 10267 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_os_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_os_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 5688 "lib/Sys/Virt.xs"
    char *type;
#line 10286 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_os_type() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 5690 "lib/Sys/Virt.xs"
    if (!(type = virDomainGetOSType(dom)))
        _croak_error();

    RETVAL = newSVpv(type, 0);
    free(type);
#line 10302 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5704 "lib/Sys/Virt.xs"
    char *xml;
#line 10321 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5706 "lib/Sys/Virt.xs"
    if (!(xml = virDomainGetXMLDesc(dom, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 10344 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_shutdown); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_shutdown)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::shutdown() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5720 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainShutdownFlags(dom, flags) < 0)
            _croak_error();
    } else {
        if (virDomainShutdown(dom) < 0)
            _croak_error();
    }
#line 10386 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_reboot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_reboot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::reboot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5734 "lib/Sys/Virt.xs"
    if (virDomainReboot(dom, flags) < 0)
        _croak_error();
#line 10422 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pm_suspend_for_duration); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pm_suspend_for_duration)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, target, duration, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	target = (unsigned int)SvUV(ST(1))
;
	SV *	duration = ST(2)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pm_suspend_for_duration() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 5745 "lib/Sys/Virt.xs"
    if (virDomainPMSuspendForDuration(dom, target, virt_SvIVull(duration), flags) < 0)
        _croak_error();
#line 10462 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_reset)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::reset() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5754 "lib/Sys/Virt.xs"
    if (virDomainReset(dom, flags) < 0)
        _croak_error();
#line 10498 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_inject_nmi); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_inject_nmi)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::inject_nmi() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5763 "lib/Sys/Virt.xs"
    if (virDomainInjectNMI(dom, flags) < 0)
        _croak_error();
#line 10534 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_undefine)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::undefine() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5772 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainUndefineFlags(dom, flags) < 0)
            _croak_error();
    } else {
        if (virDomainUndefine(dom) < 0)
            _croak_error();
    }
#line 10575 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_create)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::create() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5786 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainCreateWithFlags(dom, flags) < 0)
            _croak_error();
    } else {
        if (virDomainCreate(dom) < 0)
            _croak_error();
    }
#line 10616 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_create_with_files); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_create_with_files)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, fdssv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	fdssv = ST(1)
;
	unsigned int	flags;
#line 5802 "lib/Sys/Virt.xs"
    AV *fdsav;
    unsigned int nfds;
    int *fds;
    int i;
#line 10641 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::create_with_files() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5807 "lib/Sys/Virt.xs"
    if (!SvROK(fdssv))
        return;
    fdsav = (AV*)SvRV(fdssv);
    nfds = av_len(fdsav) + 1;
    Newx(fds, nfds, int);

    for (i = 0 ; i < nfds ; i++) {
        SV **fd = av_fetch(fdsav, i, 0);
        fds[i] = SvIV(*fd);
    }

    if (virDomainCreateWithFiles(dom, nfds, fds, flags) < 0) {
        Safefree(fds);
        _croak_error();
    }

    Safefree(fds);
#line 10675 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain__migrate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__migrate)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, destcon, newparams, flags=0");
    {
	virDomainPtr	dom;
	virConnectPtr	destcon;
	HV *	newparams;
	unsigned long	flags;
#line 5833 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 10696 "lib/Sys/Virt.c"
	virDomainPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_migrate() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        destcon = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::Domain::_migrate() -- destcon is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::_migrate",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}
#line 5836 "lib/Sys/Virt.xs"
    migrate_parse_params(&params, &nparams, newparams);

    /* No need to support virDomainMigrate/virDomainMigrate2, since
     * virDomainMigrate3 takes care to call the older APIs internally
     * if it is possible todo so
     */
    if ((RETVAL = virDomainMigrate3(dom, destcon, params, nparams, flags)) == NULL) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 10747 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Domain", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain__migrate_to_uri); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain__migrate_to_uri)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, desturi, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	desturi = (const char *)SvPV_nolen(ST(1))
;
	HV *	newparams;
	unsigned long	flags;
#line 5858 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 10776 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::_migrate_to_uri() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::_migrate_to_uri",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned long)SvUV(ST(3))
;
	}
#line 5861 "lib/Sys/Virt.xs"
    migrate_parse_params(&params, &nparams, newparams);

    /* No need to support virDomainMigrateToURI/virDomainMigrateToURI2, since
     * virDomainMigrate3 takes care to call the older APIs internally
     * if it is possible todo so
     */
    if (virDomainMigrateToURI3(dom, desturi, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 10818 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_downtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_downtime)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, downtime, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	downtime = ST(1)
;
	unsigned int	flags;
#line 5880 "lib/Sys/Virt.xs"
    unsigned long long downtimeVal;
#line 10840 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_set_max_downtime() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5882 "lib/Sys/Virt.xs"
    downtimeVal = virt_SvIVull(downtime);
    if (virDomainMigrateSetMaxDowntime(dom, downtimeVal, flags) < 0)
        _croak_error();
#line 10860 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_max_downtime); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_max_downtime)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5892 "lib/Sys/Virt.xs"
    unsigned long long downtime;
#line 10878 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_get_max_downtime() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5894 "lib/Sys/Virt.xs"
    if (virDomainMigrateGetMaxDowntime(dom, &downtime, flags) < 0)
        _croak_error();

    RETVAL = virt_newSVull(downtime);
#line 10900 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_max_speed)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, bandwidth, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned long	bandwidth = (unsigned long)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_set_max_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5908 "lib/Sys/Virt.xs"
    if (virDomainMigrateSetMaxSpeed(dom, bandwidth, flags) < 0)
        _croak_error();
#line 10939 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_max_speed); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_max_speed)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5917 "lib/Sys/Virt.xs"
    unsigned long speed;
#line 10957 "lib/Sys/Virt.c"
	unsigned long	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_get_max_speed() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5919 "lib/Sys/Virt.xs"
    if (virDomainMigrateGetMaxSpeed(dom, &speed, flags) < 0)
        _croak_error();

    RETVAL = speed;
#line 10980 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHu((UV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_compression_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_set_compression_cache)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, cacheSizeSv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	cacheSizeSv = ST(1)
;
	unsigned int	flags;
#line 5933 "lib/Sys/Virt.xs"
    unsigned long long cacheSize;
#line 11003 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_set_compression_cache() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5935 "lib/Sys/Virt.xs"
    cacheSize = virt_SvIVull(cacheSizeSv);
    if (virDomainMigrateSetCompressionCache(dom, cacheSize, flags) < 0)
        _croak_error();
#line 11023 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_compression_cache); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_get_compression_cache)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 5945 "lib/Sys/Virt.xs"
    unsigned long long cacheSize;
#line 11041 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_get_compression_cache() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5947 "lib/Sys/Virt.xs"
    if (virDomainMigrateGetCompressionCache(dom, &cacheSize, flags) < 0)
        _croak_error();

    RETVAL = virt_newSVull(cacheSize);
#line 11063 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_migrate_start_post_copy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_migrate_start_post_copy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::migrate_start_post_copy() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 5960 "lib/Sys/Virt.xs"
    if (virDomainMigrateStartPostCopy(dom, flags) < 0)
        _croak_error();
#line 11100 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_attach_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_attach_device)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::attach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5970 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainAttachDeviceFlags(dom, xml, flags) < 0)
            _croak_error();
    } else {
        if (virDomainAttachDevice(dom, xml) < 0)
            _croak_error();
    }
#line 11143 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_detach_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_detach_device)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::detach_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 5985 "lib/Sys/Virt.xs"
    if (flags) {
        if (virDomainDetachDeviceFlags(dom, xml, flags) < 0)
            _croak_error();
    } else {
        if (virDomainDetachDevice(dom, xml) < 0)
            _croak_error();
    }
#line 11186 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_detach_device_alias); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_detach_device_alias)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, alias, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	alias = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::detach_device_alias() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6000 "lib/Sys/Virt.xs"
    if (virDomainDetachDeviceAlias(dom, alias, flags) < 0)
        _croak_error();
#line 11224 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_update_device); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_update_device)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::update_device() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6010 "lib/Sys/Virt.xs"
    if (virDomainUpdateDeviceFlags(dom, xml, flags) < 0)
        _croak_error();
#line 11262 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_block_iotune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_block_iotune)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, disk, flags=0");
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 6020 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 11283 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_block_iotune() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6023 "lib/Sys/Virt.xs"
    nparams = 0;
    RETVAL = NULL;
    if (virDomainGetBlockIoTune(dom, disk, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);
    if (virDomainGetBlockIoTune(dom, disk, params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 11314 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_block_iotune); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_block_iotune)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, disk, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1))
;
	HV *	newparams;
	unsigned int	flags;
#line 6047 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 11343 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_block_iotune() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_block_iotune",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6050 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetBlockIoTune(dom, disk, NULL, &nparams, 0) < 0)
        _croak_error();
    Newx(params, nparams, virTypedParameter);

    if (virDomainGetBlockIoTune(dom, disk, params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);
    if (virDomainSetBlockIoTune(dom, disk, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 11390 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_interface_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_interface_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, intf, flags=0");
    {
	virDomainPtr	dom;
	const char *	intf = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 6074 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 11411 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_interface_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6077 "lib/Sys/Virt.xs"
    nparams = 0;
    RETVAL = NULL;
    if (virDomainGetInterfaceParameters(dom, intf, NULL, &nparams, 0) < 0)
        _croak_error();

    Newx(params, nparams, virTypedParameter);
    if (virDomainGetInterfaceParameters(dom, intf, params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 11442 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_set_interface_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_interface_parameters)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, intf, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	intf = (const char *)SvPV_nolen(ST(1))
;
	HV *	newparams;
	unsigned int	flags;
#line 6101 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    int nparams;
#line 11471 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_interface_parameters() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_interface_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6104 "lib/Sys/Virt.xs"
    nparams = 0;
    if (virDomainGetInterfaceParameters(dom, intf, NULL, &nparams, 0) < 0)
        _croak_error();
    Newx(params, nparams, virTypedParameter);

    if (virDomainGetInterfaceParameters(dom, intf, params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);
    if (virDomainSetInterfaceParameters(dom, intf, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 11518 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_stats)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, path, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 6128 "lib/Sys/Virt.xs"
    virDomainBlockStatsStruct stats;
    virTypedParameterPtr params;
    int nparams;
    unsigned int i;
    const char *field;
#line 11542 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6134 "lib/Sys/Virt.xs"
    nparams = 0;
    RETVAL = NULL;
    if (virDomainBlockStatsFlags(dom, path, NULL, &nparams, 0) < 0) {
        virErrorPtr err = virGetLastError();
        if (err && err->code == VIR_ERR_NO_SUPPORT && !flags) {
            if (virDomainBlockStats(dom, path, &stats, sizeof(stats)) < 0)
                _croak_error();

            RETVAL = (HV *)sv_2mortal((SV*)newHV());
            (void)hv_store (RETVAL, "rd_req", 6, virt_newSVll(stats.rd_req), 0);
            (void)hv_store (RETVAL, "rd_bytes", 8, virt_newSVll(stats.rd_bytes), 0);
            (void)hv_store (RETVAL, "wr_req", 6, virt_newSVll(stats.wr_req), 0);
            (void)hv_store (RETVAL, "wr_bytes", 8, virt_newSVll(stats.wr_bytes), 0);
            (void)hv_store (RETVAL, "errs", 4, virt_newSVll(stats.errs), 0);
        } else {
            _croak_error();
        }
    } else {
        Newx(params, nparams, virTypedParameter);

        if (virDomainBlockStatsFlags(dom, path, params, &nparams, flags) < 0) {
            vir_typed_param_safe_free(params, nparams);
            _croak_error();
        }

        RETVAL = vir_typed_param_to_hv(params, nparams);
        for (i = 0 ; i < nparams ; i++) {
            field = NULL;
            /* For back compat with previous hash above */
            if (strcmp(params[i].field, "rd_operations") == 0)
                field = "rd_req";
            else if (strcmp(params[i].field, "wr_operations") == 0)
                field = "wr_req";
            else if (strcmp(params[i].field, "flush_operations") == 0)
                field = "flush_reqs";
            if (field) {
                SV *val = hv_delete(RETVAL, params[i].field, strlen(params[i].field), 0);
                SvREFCNT_inc(val);
                (void)hv_store(RETVAL, field, strlen(field), val, 0);
            }
        }
        vir_typed_param_safe_free(params, nparams);
    }
#line 11603 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_interface_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_interface_stats)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "dom, path");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
#line 6186 "lib/Sys/Virt.xs"
    virDomainInterfaceStatsStruct stats;
#line 11627 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::interface_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6188 "lib/Sys/Virt.xs"
    if (virDomainInterfaceStats(dom, path, &stats, sizeof(stats)) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "rx_bytes", 8, virt_newSVll(stats.rx_bytes), 0);
    (void)hv_store (RETVAL, "rx_packets", 10, virt_newSVll(stats.rx_packets), 0);
    (void)hv_store (RETVAL, "rx_errs", 7, virt_newSVll(stats.rx_errs), 0);
    (void)hv_store (RETVAL, "rx_drop", 7, virt_newSVll(stats.rx_drop), 0);
    (void)hv_store (RETVAL, "tx_bytes", 8, virt_newSVll(stats.tx_bytes), 0);
    (void)hv_store (RETVAL, "tx_packets", 10, virt_newSVll(stats.tx_packets), 0);
    (void)hv_store (RETVAL, "tx_errs", 7, virt_newSVll(stats.tx_errs), 0);
    (void)hv_store (RETVAL, "tx_drop", 7, virt_newSVll(stats.tx_drop), 0);
#line 11650 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_memory_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_memory_stats)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6209 "lib/Sys/Virt.xs"
    virDomainMemoryStatPtr stats;
    int i, got;
#line 11674 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::memory_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6212 "lib/Sys/Virt.xs"
    Newx(stats, VIR_DOMAIN_MEMORY_STAT_NR, virDomainMemoryStatStruct);
    if ((got = virDomainMemoryStats(dom, stats, VIR_DOMAIN_MEMORY_STAT_NR, flags)) < 0) {
        Safefree(stats);
        _croak_error();
    }
    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    for (i = 0 ; i < got ; i++) {
        switch (stats[i].tag) {
        case VIR_DOMAIN_MEMORY_STAT_SWAP_IN:
            (void)hv_store (RETVAL, "swap_in", 7, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_SWAP_OUT:
            (void)hv_store (RETVAL, "swap_out", 8, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_MAJOR_FAULT:
            (void)hv_store (RETVAL, "major_fault", 11, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_MINOR_FAULT:
            (void)hv_store (RETVAL, "minor_fault", 11, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_UNUSED:
            (void)hv_store (RETVAL, "unused", 6, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_AVAILABLE:
            (void)hv_store (RETVAL, "available", 9, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_ACTUAL_BALLOON:
            (void)hv_store (RETVAL, "actual_balloon", 14, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_RSS:
            (void)hv_store (RETVAL, "rss", 3, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_LAST_UPDATE:
            (void)hv_store (RETVAL, "last_update", 11, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_USABLE:
            (void)hv_store (RETVAL, "usable", 6, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_DISK_CACHES:
            (void)hv_store (RETVAL, "disk_caches", 11, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_HUGETLB_PGALLOC:
            (void)hv_store (RETVAL, "hugetlb_pgalloc", 15, virt_newSVll(stats[i].val), 0);
            break;

        case VIR_DOMAIN_MEMORY_STAT_HUGETLB_PGFAIL:
            (void)hv_store (RETVAL, "hugetlb_pgfail", 14, virt_newSVll(stats[i].val), 0);
            break;
        }
    }
    Safefree(stats);
#line 11754 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_send_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_send_key)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, codeset, holdtime, keycodesSV, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	codeset = (unsigned int)SvUV(ST(1))
;
	unsigned int	holdtime = (unsigned int)SvUV(ST(2))
;
	SV *	keycodesSV = ST(3)
;
	unsigned int	flags;
#line 6286 "lib/Sys/Virt.xs"
    AV *keycodesAV;
    unsigned int *keycodes;
    int nkeycodes;
    int i;
#line 11788 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::send_key() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 6291 "lib/Sys/Virt.xs"
    if (!SvROK(keycodesSV))
        return;
    keycodesAV = (AV*)SvRV(keycodesSV);
    nkeycodes = av_len(keycodesAV) + 1;
    Newx(keycodes, nkeycodes, unsigned int);

    for (i = 0 ; i < nkeycodes ; i++) {
        SV **code = av_fetch(keycodesAV, i, 0);
        keycodes[i] = SvIV(*code);
    }

    if (virDomainSendKey(dom, codeset, holdtime, keycodes, nkeycodes, flags) < 0) {
        Safefree(keycodes);
        _croak_error();
    }

    Safefree(keycodes);
#line 11822 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_resize)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, disk, size, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	disk = (const char *)SvPV_nolen(ST(1))
;
	SV *	size = ST(2)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_resize() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6317 "lib/Sys/Virt.xs"
    if (virDomainBlockResize(dom, disk, virt_SvIVull(size), flags) < 0)
        _croak_error();
#line 11862 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_block_peek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_block_peek)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "dom, path, offset, size, flags=0");
    {
	virDomainPtr	dom;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	offset = (unsigned int)SvUV(ST(2))
;
	size_t	size = (size_t)SvUV(ST(3))
;
	unsigned int	flags;
#line 6329 "lib/Sys/Virt.xs"
    char *buf;
#line 11886 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::block_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 6331 "lib/Sys/Virt.xs"
    Newx(buf, size, char);
    if (virDomainBlockPeek(dom, path, offset, size, buf, flags) < 0) {
        Safefree(buf);
        _croak_error();
    }
    RETVAL = newSVpvn(buf, size);
#line 11910 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_memory_peek); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_memory_peek)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, offset, size, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	offset = (unsigned int)SvUV(ST(1))
;
	size_t	size = (size_t)SvUV(ST(2))
;
	unsigned int	flags;
#line 6348 "lib/Sys/Virt.xs"
    char *buf;
#line 11933 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::memory_peek() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6350 "lib/Sys/Virt.xs"
    Newx(buf, size, char);
    if (virDomainMemoryPeek(dom, offset, size, buf, flags) < 0) {
        Safefree(buf);
        _croak_error();
    }
    RETVAL = newSVpvn(buf, size);
#line 11957 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_security_label); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_security_label)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    {
	virDomainPtr	dom;
#line 6364 "lib/Sys/Virt.xs"
    virSecurityLabel seclabel;
#line 11975 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_security_label() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6366 "lib/Sys/Virt.xs"
    if (virDomainGetSecurityLabel(dom, &seclabel) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "label", 5, newSVpv(seclabel.label, 0), 0);
    (void)hv_store (RETVAL, "enforcing", 9, newSViv(seclabel.enforcing), 0);
#line 11992 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_security_label_list); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_security_label_list)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
#line 6380 "lib/Sys/Virt.xs"
    virSecurityLabelPtr seclabels;
    int nlabels;
    int i;
#line 12018 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_security_label_list() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 6384 "lib/Sys/Virt.xs"
    if ((nlabels = virDomainGetSecurityLabelList(dom, &seclabels)) < 0)
        _croak_error();

    EXTEND(SP, nlabels);
    for (i = 0 ; i < nlabels ; i++) {
        HV *rec = (HV *)sv_2mortal((SV*)newHV());
        (void)hv_store (rec, "label", 5, newSVpv(seclabels[i].label, 0), 0);
        (void)hv_store (rec, "enforcing", 9, newSViv(seclabels[i].enforcing), 0);
        PUSHs(newRV_noinc((SV*)rec));
    }
    free(seclabels);
#line 12039 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_cpu_stats); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_cpu_stats)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, start_cpu, ncpus, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	start_cpu = (int)SvIV(ST(1))
;
	unsigned int	ncpus = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 6404 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    unsigned int nparams;
    int ret;
    int i;
#line 12066 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_cpu_stats() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6409 "lib/Sys/Virt.xs"
    if ((ret = virDomainGetCPUStats(dom, NULL, 0, 0, 1, 0)) < 0)
        _croak_error();
    nparams = ret;

    if (ncpus == 0) {
        if ((ret = virDomainGetCPUStats(dom, NULL, 0, 0, 0, 0)) < 0)
            _croak_error();
        ncpus = ret;
    }

    Newx(params, ncpus * nparams, virTypedParameter);
    if ((ret = virDomainGetCPUStats(dom, params, nparams, start_cpu, ncpus, flags)) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    EXTEND(SP, ret);
    for (i = 0 ; i < ret ; i++) {
        HV *rec = vir_typed_param_to_hv(params + (i * nparams), nparams);
        PUSHs(newRV_noinc((SV *)rec));
    }

    vir_typed_param_safe_free(params, nparams);
#line 12106 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_vcpu_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_vcpu_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6439 "lib/Sys/Virt.xs"
    virVcpuInfoPtr info;
    unsigned char *cpumaps;
    size_t maplen;
    virNodeInfo nodeinfo;
    virDomainInfo dominfo;
    int nvCpus;
    int i;
#line 12132 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_vcpu_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6447 "lib/Sys/Virt.xs"
    if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0)
        _croak_error();
    if (virDomainGetInfo(dom, &dominfo) < 0)
        _croak_error();

    maplen = VIR_CPU_MAPLEN(VIR_NODEINFO_MAXCPUS(nodeinfo));
    Newx(cpumaps, dominfo.nrVirtCpu * maplen, unsigned char);
    if (!flags) {
        Newx(info, dominfo.nrVirtCpu, virVcpuInfo);
        if ((nvCpus = virDomainGetVcpus(dom, info, dominfo.nrVirtCpu, cpumaps, maplen)) < 0) {
            virErrorPtr err = virGetLastError();
            Safefree(info);
            info = NULL;
            if (err && err->code == VIR_ERR_OPERATION_INVALID) {
                if ((nvCpus = virDomainGetVcpuPinInfo(dom, dominfo.nrVirtCpu, cpumaps, maplen, flags)) < 0) {
                    Safefree(cpumaps);
                    _croak_error();
                }
            } else {
                Safefree(cpumaps);
                _croak_error();
            }
        }
    } else {
        info = NULL;
        if ((nvCpus = virDomainGetVcpuPinInfo(dom, dominfo.nrVirtCpu, cpumaps, maplen, flags)) < 0) {
            Safefree(cpumaps);
            _croak_error();
        }
    }

    EXTEND(SP, nvCpus);
    for (i = 0 ; i < nvCpus ; i++) {
        HV *rec = newHV();
        (void)hv_store(rec, "number", 6, newSViv(i), 0);
        if (info) {
            (void)hv_store(rec, "state", 5, newSViv(info[i].state), 0);
            (void)hv_store(rec, "cpuTime", 7, virt_newSVull(info[i].cpuTime), 0);
            (void)hv_store(rec, "cpu", 3, newSViv(info[i].cpu), 0);
        } else {
            (void)hv_store(rec, "state", 5, newSViv(0), 0);
            (void)hv_store(rec, "cpuTime", 7, virt_newSVull(0), 0);
            (void)hv_store(rec, "cpu", 3, newSViv(0), 0);
        }
        (void)hv_store(rec, "affinity", 8, newSVpvn((char*)cpumaps + (i *maplen), maplen), 0);
        PUSHs(newRV_noinc((SV *)rec));
    }

    if (info)
        Safefree(info);
    Safefree(cpumaps);
#line 12200 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pin_vcpu); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pin_vcpu)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, vcpu, mask, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	vcpu = (unsigned int)SvUV(ST(1))
;
	SV *	mask = ST(2)
;
	unsigned int	flags;
#line 6507 "lib/Sys/Virt.xs"
    STRLEN masklen;
    unsigned char *maps;
#line 12225 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pin_vcpu() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6510 "lib/Sys/Virt.xs"
    maps = (unsigned char *)SvPV(mask, masklen);
    if (flags) {
        if (virDomainPinVcpuFlags(dom, vcpu, maps, masklen, flags) < 0)
            _croak_error();
    } else {
        if (virDomainPinVcpu(dom, vcpu, maps, masklen) < 0)
            _croak_error();
    }
#line 12250 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pin_emulator); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pin_emulator)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, mask, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	mask = ST(1)
;
	unsigned int	flags;
#line 6526 "lib/Sys/Virt.xs"
    STRLEN masklen;
    unsigned char *maps;
#line 12273 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pin_emulator() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6529 "lib/Sys/Virt.xs"
    maps = (unsigned char *)SvPV(mask, masklen);
    if (virDomainPinEmulator(dom, maps, masklen, flags) < 0)
        _croak_error();
#line 12293 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_emulator_pin_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_emulator_pin_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6539 "lib/Sys/Virt.xs"
    unsigned char *cpumaps;
    int maplen;
    virNodeInfo nodeinfo;
    int nCpus;
#line 12314 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_emulator_pin_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6544 "lib/Sys/Virt.xs"
    if (virNodeGetInfo(virDomainGetConnect(dom), &nodeinfo) < 0)
        _croak_error();

    nCpus = VIR_NODEINFO_MAXCPUS(nodeinfo);
    maplen = VIR_CPU_MAPLEN(nCpus);
    Newx(cpumaps, maplen, unsigned char);
    if ((virDomainGetEmulatorPinInfo(dom, cpumaps, maplen, flags)) < 0) {
        Safefree(cpumaps);
        _croak_error();
    }
    RETVAL = newSVpvn((char*)cpumaps, maplen);
    Safefree(cpumaps);
#line 12344 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_get_iothread_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_iothread_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6565 "lib/Sys/Virt.xs"
    virDomainIOThreadInfoPtr *iothrinfo;
    int niothreads;
    int i;
#line 12367 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_iothread_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6569 "lib/Sys/Virt.xs"
    if ((niothreads = virDomainGetIOThreadInfo(dom, &iothrinfo,
                                               flags)) < 0)
        _croak_error();

    EXTEND(SP, niothreads);
    for (i = 0 ; i < niothreads ; i++) {
        HV *rec = newHV();
        (void)hv_store(rec, "number", 6,
                       newSViv(iothrinfo[i]->iothread_id), 0);
        (void)hv_store(rec, "affinity", 8,
                       newSVpvn((char*)iothrinfo[i]->cpumap,
                                iothrinfo[i]->cpumaplen), 0);
        PUSHs(newRV_noinc((SV *)rec));
    }

    for (i = 0 ; i < niothreads ; i++) {
        virDomainIOThreadInfoFree(iothrinfo[i]);
    }
    free(iothrinfo);
#line 12403 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_pin_iothread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_pin_iothread)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, iothread_id, mask, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	iothread_id = (unsigned int)SvUV(ST(1))
;
	SV *	mask = ST(2)
;
	unsigned int	flags;
#line 6597 "lib/Sys/Virt.xs"
    STRLEN masklen;
    unsigned char *maps;
#line 12428 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::pin_iothread() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6600 "lib/Sys/Virt.xs"
    maps = (unsigned char *)SvPV(mask, masklen);
    if (virDomainPinIOThread(dom, iothread_id, maps, masklen, flags) < 0)
        _croak_error();
#line 12448 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_add_iothread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_add_iothread)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, iothread_id, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	iothread_id = (unsigned int)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::add_iothread() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6611 "lib/Sys/Virt.xs"
    if (virDomainAddIOThread(dom, iothread_id, flags) < 0)
        _croak_error();
#line 12486 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_del_iothread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_del_iothread)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, iothread_id, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	iothread_id = (unsigned int)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::del_iothread() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6621 "lib/Sys/Virt.xs"
    if (virDomainDelIOThread(dom, iothread_id, flags) < 0)
        _croak_error();
#line 12524 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_iothread); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_iothread)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, iothread_id, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	iothread_id = (unsigned int)SvUV(ST(1))
;
	HV *	newparams;
	unsigned int	flags;
#line 6632 "lib/Sys/Virt.xs"
    virTypedParameterPtr params;
    size_t nparams;
#line 12548 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_iothread() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(2);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::Domain::set_iothread",
				"newparams");
		}
	} STMT_END
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6635 "lib/Sys/Virt.xs"
    nparams = 5;
    Newx(params, nparams, virTypedParameter);

    strncpy(params[0].field, VIR_DOMAIN_IOTHREAD_POLL_MAX_NS,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[0].type = VIR_TYPED_PARAM_ULLONG;

    strncpy(params[1].field, VIR_DOMAIN_IOTHREAD_POLL_GROW,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[1].type = VIR_TYPED_PARAM_UINT;

    strncpy(params[2].field, VIR_DOMAIN_IOTHREAD_POLL_SHRINK,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[2].type = VIR_TYPED_PARAM_UINT;

    strncpy(params[3].field, VIR_DOMAIN_IOTHREAD_THREAD_POOL_MIN,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[3].type = VIR_TYPED_PARAM_INT;

    strncpy(params[4].field, VIR_DOMAIN_IOTHREAD_THREAD_POOL_MAX,
            VIR_TYPED_PARAM_FIELD_LENGTH);
    params[4].type = VIR_TYPED_PARAM_INT;

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virDomainSetIOThreadParams(dom, iothread_id,
                                   params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    vir_typed_param_safe_free(params, nparams);
#line 12611 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_num_of_snapshots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_num_of_snapshots)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::num_of_snapshots() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6674 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainSnapshotNum(dom, flags)) < 0)
        _croak_error();
#line 12647 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_list_snapshot_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_list_snapshot_names)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	maxnames = (int)SvIV(ST(1))
;
	unsigned int	flags;
#line 6686 "lib/Sys/Virt.xs"
    char **names;
    int nsnap;
    int i;
#line 12672 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::list_snapshot_names() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6690 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nsnap = virDomainSnapshotListNames(dom, names, maxnames, flags)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nsnap);
    for (i = 0 ; i < nsnap ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 12700 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_list_all_snapshots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_list_all_snapshots)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6708 "lib/Sys/Virt.xs"
    virDomainSnapshotPtr *domsss;
    int i, ndomss;
    SV *domssrv;
#line 12722 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::list_all_snapshots() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6712 "lib/Sys/Virt.xs"
    if ((ndomss = virDomainListAllSnapshots(dom, &domsss, flags)) < 0)
        _croak_error();

    EXTEND(SP, ndomss);
    for (i = 0 ; i < ndomss ; i++) {
        domssrv = sv_newmortal();
        sv_setref_pv(domssrv, "Sys::Virt::DomainSnapshot", domsss[i]);
        PUSHs(domssrv);
    }
    free(domsss);
#line 12749 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_list_all_checkpoints); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_list_all_checkpoints)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6729 "lib/Sys/Virt.xs"
    virDomainCheckpointPtr *domcps;
    int i, ndomcp;
    SV *domcprv;
#line 12771 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::list_all_checkpoints() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6733 "lib/Sys/Virt.xs"
    if ((ndomcp = virDomainListAllCheckpoints(dom, &domcps, flags)) < 0)
        _croak_error();

    EXTEND(SP, ndomcp);
    for (i = 0 ; i < ndomcp ; i++) {
        domcprv = sv_newmortal();
        sv_setref_pv(domcprv, "Sys::Virt::DomainCheckpoint", domcps[i]);
        PUSHs(domcprv);
    }
    free(domcps);
#line 12798 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_has_current_snapshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_has_current_snapshot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::has_current_snapshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6750 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainHasCurrentSnapshot(dom, flags)) < 0)
        _croak_error();
#line 12834 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_current_snapshot); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_current_snapshot)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::current_snapshot() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6761 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainSnapshotCurrent(dom, flags)))
        _croak_error();
#line 12870 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainSnapshot", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_fs_trim); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_fs_trim)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, mountPoint, minimumsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	mountPoint = (const char *)SvPV_nolen(ST(1))
;
	SV *	minimumsv = ST(2)
;
	unsigned int	flags;
#line 6774 "lib/Sys/Virt.xs"
    unsigned long long minimum;
#line 12899 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::fs_trim() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6776 "lib/Sys/Virt.xs"
    minimum = virt_SvIVull(minimumsv);
    if (virDomainFSTrim(dom, mountPoint, minimum, flags) < 0)
        _croak_error();
#line 12919 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_fs_freeze); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_fs_freeze)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, mountPointsSV, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	mountPointsSV = ST(1)
;
	unsigned int	flags;
#line 6787 "lib/Sys/Virt.xs"
    AV *mountPointsAV;
    const char **mountPoints;
    unsigned int nMountPoints;
    unsigned int i;
#line 12944 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::fs_freeze() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6792 "lib/Sys/Virt.xs"
    mountPointsAV = (AV*)SvRV(mountPointsSV);
    nMountPoints = av_len(mountPointsAV) + 1;
    if (nMountPoints) {
        Newx(mountPoints, nMountPoints, const char *);
        for (i = 0 ; i < nMountPoints ; i++) {
            SV **mountPoint = av_fetch(mountPointsAV, i, 0);
            mountPoints[i] = SvPV_nolen(*mountPoint);
        }
    } else {
        mountPoints = NULL;
    }

    if (virDomainFSFreeze(dom, mountPoints, nMountPoints, flags) < 0) {
        Safefree(mountPoints);
        _croak_error();
    }

    Safefree(mountPoints);
#line 12979 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_fs_thaw); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_fs_thaw)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, mountPointsSV, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	mountPointsSV = ST(1)
;
	unsigned int	flags;
#line 6818 "lib/Sys/Virt.xs"
    AV *mountPointsAV;
    const char **mountPoints;
    unsigned int nMountPoints;
    unsigned int i;
#line 13004 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::fs_thaw() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6823 "lib/Sys/Virt.xs"
    mountPointsAV = (AV*)SvRV(mountPointsSV);
    nMountPoints = av_len(mountPointsAV) + 1;
    if (nMountPoints) {
        Newx(mountPoints, nMountPoints, const char *);
        for (i = 0 ; i < nMountPoints ; i++) {
            SV **mountPoint = av_fetch(mountPointsAV, i, 0);
            mountPoints[i] = SvPV_nolen(*mountPoint);
        }
    } else {
        mountPoints = NULL;
    }
    if (virDomainFSThaw(dom, mountPoints, nMountPoints, flags) < 0) {
        Safefree(mountPoints);
        _croak_error();
    }

    Safefree(mountPoints);
#line 13038 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_fs_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_fs_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6846 "lib/Sys/Virt.xs"
    virDomainFSInfoPtr *info;
    int ninfo;
    size_t i, j;
#line 13060 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_fs_info() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6851 "lib/Sys/Virt.xs"
    if ((ninfo = virDomainGetFSInfo(dom, &info, flags)) < 0)
        _croak_error();

    EXTEND(SP, ninfo);
    for (i = 0 ; i < ninfo ; i++) {
        HV *hv = newHV();
        AV *av = newAV();

        (void)hv_store(hv, "mountpoint", 10, newSVpv(info[i]->mountpoint, 0), 0);
        (void)hv_store(hv, "name", 4, newSVpv(info[i]->name, 0), 0);
        (void)hv_store(hv, "fstype", 6, newSVpv(info[i]->fstype, 0), 0);

        for (j = 0; j < info[i]->ndevAlias; j++)
            av_push(av, newSVpv(info[i]->devAlias[j], 0));

        (void)hv_store(hv, "devalias", 8, newRV_noinc((SV*)av), 0);

        virDomainFSInfoFree(info[i]);

        PUSHs(newRV_noinc((SV*)hv));
    }
    free(info);
#line 13099 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_interface_addresses); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_interface_addresses)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, src, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	src = (unsigned int)SvUV(ST(1))
;
	unsigned int	flags;
#line 6880 "lib/Sys/Virt.xs"
    virDomainInterfacePtr *info;
    int ninfo;
    size_t i, j;
#line 13123 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_interface_addresses() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6884 "lib/Sys/Virt.xs"
    if ((ninfo = virDomainInterfaceAddresses(dom, &info, src, flags)) < 0)
        _croak_error();

    EXTEND(SP, ninfo);
    for (i = 0; i < ninfo; i++) {
        HV *hv = newHV();
        AV *av = newAV();

        (void)hv_store(hv, "name", 4, newSVpv(info[i]->name, 0), 0);
        if (info[i]->hwaddr) {
            (void)hv_store(hv, "hwaddr", 6, newSVpv(info[i]->hwaddr, 0), 0);
        }

        for (j = 0; j < info[i]->naddrs; j++) {
            HV *subhv = newHV();

            (void)hv_store(subhv, "type", 4, newSViv(info[i]->addrs[j].type), 0);
            (void)hv_store(subhv, "addr", 4, newSVpv(info[i]->addrs[j].addr, 0), 0);
            (void)hv_store(subhv, "prefix", 6, newSViv(info[i]->addrs[j].prefix), 0);
            av_push(av, newRV_noinc((SV*)subhv));
        }
        (void)hv_store(hv, "addrs", 5, newRV_noinc((SV*)av), 0);

        virDomainInterfaceFree(info[i]);

        PUSHs(newRV_noinc((SV*)hv));
    }
    free(info);
#line 13168 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_send_process_signal); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_send_process_signal)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, pidsv, signum, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	SV *	pidsv = ST(1)
;
	unsigned int	signum = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;
#line 6920 "lib/Sys/Virt.xs"
    long long pid;
#line 13192 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::send_process_signal() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6922 "lib/Sys/Virt.xs"
    pid = virt_SvIVull(pidsv);
    if (virDomainSendProcessSignal(dom, pid, signum, flags) < 0)
        _croak_error();
#line 13212 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_block_threshold); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_block_threshold)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, dev, thresholdsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	dev = (const char *)SvPV_nolen(ST(1))
;
	SV *	thresholdsv = ST(2)
;
	unsigned int	flags;
#line 6933 "lib/Sys/Virt.xs"
    unsigned long long threshold;
#line 13236 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_block_threshold() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6935 "lib/Sys/Virt.xs"
    threshold = virt_SvIVull(thresholdsv);
    if (virDomainSetBlockThreshold(dom, dev, threshold, flags) < 0)
        _croak_error();
#line 13256 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_lifecycle_action); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_lifecycle_action)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, type, action, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	type = (unsigned int)SvUV(ST(1))
;
	unsigned int	action = (unsigned int)SvUV(ST(2))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_lifecycle_action() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6946 "lib/Sys/Virt.xs"
    if (virDomainSetLifecycleAction(dom, type, action, flags) < 0)
        _croak_error();
#line 13296 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_set_agent_response_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_set_agent_response_timeout)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, timeout, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	timeout = (int)SvIV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::set_agent_response_timeout() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 6955 "lib/Sys/Virt.xs"
    if (virDomainAgentSetResponseTimeout(dom, timeout, flags) < 0)
        _croak_error();
#line 13334 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_backup_begin); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_backup_begin)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, backupxmlsv, checkpointxmlsv, flags=0");
    {
	virDomainPtr	dom;
	SV *	backupxmlsv = ST(1)
;
	SV *	checkpointxmlsv = ST(2)
;
	unsigned int	flags;
#line 6965 "lib/Sys/Virt.xs"
    const char *backupxml = NULL;
    const char *checkpointxml = NULL;
#line 13357 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::backup_begin() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 6968 "lib/Sys/Virt.xs"
    if (SvOK(backupxmlsv))
        backupxml = SvPV_nolen(backupxmlsv);
    if (SvOK(checkpointxmlsv))
        checkpointxml = SvPV_nolen(checkpointxmlsv);
    if (virDomainBackupBegin(dom, backupxml, checkpointxml, flags) < 0)
        _croak_error();
#line 13380 "lib/Sys/Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Domain_backup_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_backup_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags=0");
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 6980 "lib/Sys/Virt.xs"
    char *xml;
#line 13397 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::backup_get_xml_description() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 6982 "lib/Sys/Virt.xs"
    if (!(xml = virDomainBackupGetXMLDesc(dom, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 13420 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Domain_authorized_ssh_keys_get); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_authorized_ssh_keys_get)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, user, flags = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	user = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
#line 6996 "lib/Sys/Virt.xs"
    int ret;
    char **keys = NULL;
    unsigned int i;
#line 13445 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::authorized_ssh_keys_get() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7000 "lib/Sys/Virt.xs"
    if ((ret = virDomainAuthorizedSSHKeysGet(dom, user, &keys, flags)) < 0)
        _croak_error();

    EXTEND(SP, ret);
    for (i = 0 ; i < ret ; i++) {
        PUSHs(sv_2mortal(newSVpv(keys[i], 0)));
        free(keys[i]);
    }
    free(keys);
#line 13471 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_authorized_ssh_keys_set); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_authorized_ssh_keys_set)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, user, keysSV, flags = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	user = (const char *)SvPV_nolen(ST(1))
;
	SV *	keysSV = ST(2)
;
	unsigned int	flags;
#line 7017 "lib/Sys/Virt.xs"
    AV *keysAV;
    const char **keys;
    unsigned int nkeys;
    unsigned int i;
#line 13498 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::authorized_ssh_keys_set() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 7022 "lib/Sys/Virt.xs"
    keysAV = (AV*)SvRV(keysSV);
    nkeys = av_len(keysAV) + 1;
    if (nkeys) {
        Newx(keys, nkeys, const char *);
        for (i = 0 ; i < nkeys ; i++) {
            SV **mountPoint = av_fetch(keysAV, i, 0);
            keys[i] = SvPV_nolen(*mountPoint);
        }
    } else {
        keys = NULL;
    }

    if (virDomainAuthorizedSSHKeysSet(dom, user, keys, nkeys, flags) < 0) {
        Safefree(keys);
        _croak_error();
    }

    Safefree(keys);
#line 13533 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_get_messages); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_get_messages)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom, flags = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	unsigned int	flags;
#line 7046 "lib/Sys/Virt.xs"
    int ret;
    char **msgs = NULL;
    unsigned int i;
#line 13555 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::get_messages() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7050 "lib/Sys/Virt.xs"
    if ((ret = virDomainGetMessages(dom, &msgs, flags)) < 0)
        _croak_error();

    EXTEND(SP, ret);
    for (i = 0 ; i < ret ; i++) {
        PUSHs(sv_2mortal(newSVpv(msgs[i], 0)));
        free(msgs[i]);
    }
    free(msgs);
#line 13581 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_start_dirty_rate_calc); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_start_dirty_rate_calc)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, secs, flags = 0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	int	secs = (int)SvIV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::start_dirty_rate_calc() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7066 "lib/Sys/Virt.xs"
    if ((virDomainStartDirtyRateCalc(dom, secs, flags) < 0))
        _croak_error();
#line 13619 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_fd_associate); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_fd_associate)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "dom, name, fdssv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainPtr	dom;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	SV *	fdssv = ST(2)
;
	unsigned int	flags;
#line 7077 "lib/Sys/Virt.xs"
    AV *fdsav;
    unsigned int nfds;
    int *fds;
    int i;
#line 13646 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Domain::fd_associate() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 7082 "lib/Sys/Virt.xs"
    if (!SvROK(fdssv))
        return;
    fdsav = (AV*)SvRV(fdssv);
    nfds = av_len(fdsav) + 1;
    Newx(fds, nfds, int);

    for (i = 0 ; i < nfds ; i++) {
        SV **fd = av_fetch(fdsav, i, 0);
        fds[i] = SvIV(*fd);
    }

    if (virDomainFDAssociate(dom, name, nfds, fds, flags) < 0) {
        Safefree(fds);
        _croak_error();
    }

    Safefree(fds);
#line 13680 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_destroy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dom_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0)
;
	unsigned int	flags;
#line 7105 "lib/Sys/Virt.xs"
    virDomainPtr dom;
#line 13701 "lib/Sys/Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7107 "lib/Sys/Virt.xs"
    dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
    if (flags) {
        if (virDomainDestroyFlags(dom, flags) < 0)
            _croak_error();
    } else {
        if (virDomainDestroy(dom) < 0)
            _croak_error();
    }
#line 13718 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Domain_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Domain_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dom_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dom_rv = ST(0)
;
#line 7121 "lib/Sys/Virt.xs"
    virDomainPtr dom;
#line 13738 "lib/Sys/Virt.c"
#line 7123 "lib/Sys/Virt.xs"
    dom = (virDomainPtr)SvIV((SV*)SvRV(dom_rv));
    if (dom) {
        virDomainFree(dom);
        sv_setiv((SV*)SvRV(dom_rv), 0);
    }
#line 13745 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7139 "lib/Sys/Virt.xs"
    if (flags) {
        if (!(RETVAL = virNetworkCreateXMLFlags(con, xml, flags)))
            _croak_error();
    } else {
        if (!(RETVAL = virNetworkCreateXML(con, xml)))
            _croak_error();
    }
#line 13787 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Network", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7156 "lib/Sys/Virt.xs"
    if (flags) {
        if (!(RETVAL = virNetworkDefineXMLFlags(con, xml, flags)))
            _croak_error();
    } else {
        if (!(RETVAL = virNetworkDefineXML(con, xml)))
            _croak_error();
    }
#line 13834 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Network", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7172 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkLookupByName(con, name)))
        _croak_error();
#line 13868 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Network", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7183 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkLookupByUUID(con, uuid)))
        _croak_error();
#line 13902 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Network", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7194 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkLookupByUUIDString(con, uuid)))
        _croak_error();

#line 13937 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Network", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 7205 "lib/Sys/Virt.xs"
    unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 13959 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7207 "lib/Sys/Virt.xs"
    if ((virNetworkGetUUID(net, rawuuid)) < 0)
        _croak_error();

    RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 13974 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 7219 "lib/Sys/Virt.xs"
    char uuid[VIR_UUID_STRING_BUFLEN];
#line 13992 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7221 "lib/Sys/Virt.xs"
    if ((virNetworkGetUUIDString(net, uuid)) < 0)
        _croak_error();

    RETVAL = newSVpv(uuid, 0);
#line 14007 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7233 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkGetName(net)))
        _croak_error();
#line 14036 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::is_active() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7243 "lib/Sys/Virt.xs"
    if ((RETVAL = virNetworkIsActive(net)) < 0)
        _croak_error();
#line 14066 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::is_persistent() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7253 "lib/Sys/Virt.xs"
    if ((RETVAL = virNetworkIsPersistent(net)) < 0)
        _croak_error();
#line 14095 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_bridge_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_bridge_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 7263 "lib/Sys/Virt.xs"
    char *name;
#line 14113 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_bridge_name() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7265 "lib/Sys/Virt.xs"
    if (!(name = virNetworkGetBridgeName(net)))
        _croak_error();

    RETVAL = newSVpv(name, 0);
    free(name);
#line 14129 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "net, flags=0");
    {
	virNetworkPtr	net;
	unsigned int	flags;
#line 7279 "lib/Sys/Virt.xs"
    char *xml;
#line 14148 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_xml_description() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7281 "lib/Sys/Virt.xs"
    if (!(xml = virNetworkGetXMLDesc(net, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 14171 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::undefine() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7294 "lib/Sys/Virt.xs"
    if (virNetworkUndefine(net) < 0)
        _croak_error();
#line 14200 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::create() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7302 "lib/Sys/Virt.xs"
    if (virNetworkCreate(net) < 0)
        _croak_error();
#line 14228 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_update); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_update)
{
    dVAR; dXSARGS;
    if (items < 5 || items > 6)
       croak_xs_usage(cv,  "net, command, section, parentIndex, xml, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	unsigned int	command = (unsigned int)SvUV(ST(1))
;
	unsigned int	section = (unsigned int)SvUV(ST(2))
;
	int	parentIndex = (int)SvIV(ST(3))
;
	const char *	xml = (const char *)SvPV_nolen(ST(4))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::update() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 6)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(5))
;
	}
#line 7315 "lib/Sys/Virt.xs"
    if (virNetworkUpdate(net, command, section, parentIndex, xml, flags) < 0)
        _croak_error();
#line 14272 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "net, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::set_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7323 "lib/Sys/Virt.xs"
    if (virNetworkSetAutostart(net, autostart) < 0)
        _croak_error();
#line 14302 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net");
    {
	virNetworkPtr	net;
#line 7331 "lib/Sys/Virt.xs"
    int autostart;
#line 14319 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_autostart() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7333 "lib/Sys/Virt.xs"
    if (virNetworkGetAutostart(net, &autostart) < 0)
        _croak_error();

    RETVAL = autostart;
#line 14335 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Network_get_dhcp_leases); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_get_dhcp_leases)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 3)
       croak_xs_usage(cv,  "net, macsv=&PL_sv_undef, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	SV *	macsv;
	unsigned int	flags;
#line 7347 "lib/Sys/Virt.xs"
    virNetworkDHCPLeasePtr *leases = NULL;
    int nleases;
    const char *mac = NULL;
    int i;
#line 14360 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::get_dhcp_leases() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    macsv = &PL_sv_undef;
	else {
	    macsv = ST(1)
;
	}

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7352 "lib/Sys/Virt.xs"
    if (SvOK(macsv))
        mac = SvPV_nolen(macsv);

    if ((nleases = virNetworkGetDHCPLeases(net, mac, &leases, flags)) < 0)
        _croak_error();

    EXTEND(SP, nleases);
    for (i = 0 ; i < nleases ; i++) {
        HV *hv = newHV();

        (void)hv_store(hv, "iface", 5, newSVpv(leases[i]->iface, 0), 0);
        (void)hv_store(hv, "expirytime", 10, virt_newSVll(leases[i]->expirytime), 0);
        (void)hv_store(hv, "type", 4, newSViv(leases[i]->type), 0);
        (void)hv_store(hv, "mac", 3, newSVpv(leases[i]->mac, 0), 0);
        (void)hv_store(hv, "iaid", 4, newSVpv(leases[i]->iaid, 0), 0);
        (void)hv_store(hv, "ipaddr", 6, newSVpv(leases[i]->ipaddr, 0), 0);
        (void)hv_store(hv, "prefix", 6, newSViv(leases[i]->prefix), 0);
        (void)hv_store(hv, "hostname", 8, newSVpv(leases[i]->hostname, 0), 0);
        (void)hv_store(hv, "clientid", 8, newSVpv(leases[i]->clientid, 0), 0);

        virNetworkDHCPLeaseFree(leases[i]);

        PUSHs(newRV_noinc((SV*)hv));
    }
    free(leases);
#line 14409 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_list_all_ports); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_list_all_ports)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "net, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPtr	net;
	unsigned int	flags;
#line 7384 "lib/Sys/Virt.xs"
    virNetworkPortPtr *ports;
    int i, nport;
    SV *portrv;
#line 14431 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Network::list_all_ports() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7388 "lib/Sys/Virt.xs"
    if ((nport = virNetworkListAllPorts(net, &ports, flags)) < 0)
        _croak_error();

    EXTEND(SP, nport);
    for (i = 0 ; i < nport ; i++) {
        portrv = sv_newmortal();
        sv_setref_pv(portrv, "Sys::Virt::NetworkPort", ports[i]);
        PUSHs(portrv);
    }
    free(ports);
#line 14458 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0)
;
#line 7404 "lib/Sys/Virt.xs"
    virNetworkPtr net;
#line 14478 "lib/Sys/Virt.c"
#line 7406 "lib/Sys/Virt.xs"
    net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
    if (virNetworkDestroy(net) < 0)
        _croak_error();
#line 14483 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Network_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Network_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "net_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	net_rv = ST(0)
;
#line 7415 "lib/Sys/Virt.xs"
    virNetworkPtr net;
#line 14503 "lib/Sys/Virt.c"
#line 7417 "lib/Sys/Virt.xs"
    net = (virNetworkPtr)SvIV((SV*)SvRV(net_rv));
    if (net) {
        virNetworkFree(net);
        sv_setiv((SV*)SvRV(net_rv), 0);
    }
#line 14510 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NetworkPort__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "net, xml, flags=0");
    {
	virNetworkPtr	net;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNetworkPortPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::_create_xml() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7433 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkPortCreateXML(net, xml, flags)))
        _croak_error();
#line 14547 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NetworkPort", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "net, uuid");
    {
	virNetworkPtr	net;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virNetworkPortPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::_lookup_by_uuid() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7444 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkPortLookupByUUID(net, uuid)))
        _croak_error();
#line 14581 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NetworkPort", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "net, uuid");
    {
	virNetworkPtr	net;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virNetworkPortPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        net = INT2PTR(virNetworkPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::_lookup_by_uuid_string() -- net is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7455 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNetworkPortLookupByUUIDString(net, uuid)))
        _croak_error();

#line 14616 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NetworkPort", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "port");
    {
	virNetworkPortPtr	port;
#line 7466 "lib/Sys/Virt.xs"
    unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 14638 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        port = INT2PTR(virNetworkPortPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::get_uuid() -- port is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7468 "lib/Sys/Virt.xs"
    if ((virNetworkPortGetUUID(port, rawuuid)) < 0)
        _croak_error();

    RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 14653 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "port");
    {
	virNetworkPortPtr	port;
#line 7480 "lib/Sys/Virt.xs"
    char uuid[VIR_UUID_STRING_BUFLEN];
#line 14671 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        port = INT2PTR(virNetworkPortPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::get_uuid_string() -- port is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7482 "lib/Sys/Virt.xs"
    if ((virNetworkPortGetUUIDString(port, uuid)) < 0)
        _croak_error();

    RETVAL = newSVpv(uuid, 0);
#line 14686 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "port, flags=0");
    {
	virNetworkPortPtr	port;
	unsigned int	flags;
#line 7495 "lib/Sys/Virt.xs"
    char *xml;
#line 14705 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        port = INT2PTR(virNetworkPortPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::get_xml_description() -- port is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7497 "lib/Sys/Virt.xs"
    if (!(xml = virNetworkPortGetXMLDesc(port, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 14728 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_get_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_get_parameters)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "port, flags=0");
    {
	virNetworkPortPtr	port;
	unsigned int	flags;
#line 7511 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 14748 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        port = INT2PTR(virNetworkPortPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::get_parameters() -- port is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7514 "lib/Sys/Virt.xs"
    if (virNetworkPortGetParameters(port, &params, &nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    RETVAL = vir_typed_param_to_hv(params, nparams);
    vir_typed_param_safe_free(params, nparams);
#line 14773 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_set_parameters); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_set_parameters)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "port, newparams, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPortPtr	port;
	HV *	newparams;
	unsigned int	flags;
#line 7531 "lib/Sys/Virt.xs"
    virTypedParameterPtr params = NULL;
    int nparams = 0;
#line 14800 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        port = INT2PTR(virNetworkPortPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::set_parameters() -- port is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	STMT_START {
		SV* const xsub_tmp_sv = ST(1);
		SvGETMAGIC(xsub_tmp_sv);
		if (SvROK(xsub_tmp_sv) && SvTYPE(SvRV(xsub_tmp_sv)) == SVt_PVHV){
		    newparams = (HV*)SvRV(xsub_tmp_sv);
		}
		else{
		    Perl_croak_nocontext("%s: %s is not a HASH reference",
				"Sys::Virt::NetworkPort::set_parameters",
				"newparams");
		}
	} STMT_END
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7534 "lib/Sys/Virt.xs"
    if (virNetworkPortGetParameters(port, &params, &nparams, 0) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }

    nparams = vir_typed_param_from_hv(newparams, params, nparams);

    if (virNetworkPortSetParameters(port, params, nparams, flags) < 0) {
        vir_typed_param_safe_free(params, nparams);
        _croak_error();
    }
    vir_typed_param_safe_free(params, nparams);
#line 14843 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "port, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNetworkPortPtr	port;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        port = INT2PTR(virNetworkPortPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NetworkPort::delete() -- port is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7553 "lib/Sys/Virt.xs"
    if (virNetworkPortDelete(port, flags) < 0)
        _croak_error();
#line 14879 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NetworkPort_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NetworkPort_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "port_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	port_rv = ST(0)
;
#line 7561 "lib/Sys/Virt.xs"
    virNetworkPortPtr port;
#line 14899 "lib/Sys/Virt.c"
#line 7563 "lib/Sys/Virt.xs"
    port = (virNetworkPortPtr)SvIV((SV*)SvRV(port_rv));
    if (port) {
        virNetworkPortFree(port);
        sv_setiv((SV*)SvRV(port_rv), 0);
    }
#line 14906 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__create_xml)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, xml");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7578 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolCreateXML(con, xml, 0)))
        _croak_error();

#line 14936 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7591 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolDefineXML(con, xml, flags)))
        _croak_error();
#line 14978 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7602 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolLookupByName(con, name)))
        _croak_error();
#line 15012 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7613 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolLookupByUUID(con, uuid)))
        _croak_error();
#line 15046 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7624 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolLookupByUUIDString(con, uuid)))
        _croak_error();
#line 15080 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_volume); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_volume)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_volume() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7634 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolLookupByVolume(vol)))
        _croak_error();
#line 15112 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_target_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool__lookup_by_target_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, path");
    {
	virConnectPtr	con;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	virStoragePoolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::_lookup_by_target_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7645 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolLookupByTargetPath(con, path)))
        _croak_error();
#line 15146 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StoragePool", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 7655 "lib/Sys/Virt.xs"
    unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 15168 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7657 "lib/Sys/Virt.xs"
    if ((virStoragePoolGetUUID(pool, rawuuid)) < 0)
        _croak_error();

    RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 15183 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 7669 "lib/Sys/Virt.xs"
    char uuid[VIR_UUID_STRING_BUFLEN];
#line 15201 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_uuid_string() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7671 "lib/Sys/Virt.xs"
    if ((virStoragePoolGetUUIDString(pool, uuid)) < 0)
        _croak_error();

    RETVAL = newSVpv(uuid, 0);
#line 15216 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7683 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStoragePoolGetName(pool)))
        _croak_error();
#line 15245 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::is_active() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7693 "lib/Sys/Virt.xs"
    if ((RETVAL = virStoragePoolIsActive(pool)) < 0)
        _croak_error();
#line 15275 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::is_persistent() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7703 "lib/Sys/Virt.xs"
    if ((RETVAL = virStoragePoolIsPersistent(pool)) < 0)
        _croak_error();
#line 15304 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    {
	virStoragePoolPtr	pool;
	unsigned int	flags;
#line 7714 "lib/Sys/Virt.xs"
    char *xml;
#line 15323 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_xml_description() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7716 "lib/Sys/Virt.xs"
    if (!(xml = virStoragePoolGetXMLDesc(pool, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 15346 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::undefine() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7729 "lib/Sys/Virt.xs"
    if (virStoragePoolUndefine(pool) < 0)
        _croak_error();
#line 15375 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_create)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::create() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7737 "lib/Sys/Virt.xs"
    if (virStoragePoolCreate(pool, 0) < 0)
        _croak_error();
#line 15403 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_refresh); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_refresh)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::refresh() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 7746 "lib/Sys/Virt.xs"
    if (virStoragePoolRefresh(pool, flags) < 0)
        _croak_error();
#line 15439 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_build); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_build)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::build() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 7755 "lib/Sys/Virt.xs"
    if (virStoragePoolBuild(pool, flags) < 0)
        _croak_error();
#line 15475 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::delete() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(1))
;
	}
#line 7764 "lib/Sys/Virt.xs"
    if (virStoragePoolDelete(pool, flags) < 0)
        _croak_error();
#line 15511 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pool, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::set_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7773 "lib/Sys/Virt.xs"
    if (virStoragePoolSetAutostart(pool, autostart) < 0)
        _croak_error();
#line 15541 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 7781 "lib/Sys/Virt.xs"
    int autostart;
#line 15558 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_autostart() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7783 "lib/Sys/Virt.xs"
    if (virStoragePoolGetAutostart(pool, &autostart) < 0)
        _croak_error();

    RETVAL = autostart;
#line 15574 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_get_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_get_info)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
#line 7795 "lib/Sys/Virt.xs"
    virStoragePoolInfo info;
#line 15592 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::get_info() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7797 "lib/Sys/Virt.xs"
    if (virStoragePoolGetInfo(pool, &info) < 0)
        _croak_error();

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "state", 5, newSViv(info.state), 0);
    (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
    (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
    (void)hv_store (RETVAL, "available", 9, virt_newSVull(info.available), 0);
#line 15611 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0)
;
#line 7813 "lib/Sys/Virt.xs"
    virStoragePoolPtr pool;
#line 15636 "lib/Sys/Virt.c"
#line 7815 "lib/Sys/Virt.xs"
    pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
    if (virStoragePoolDestroy(pool) < 0)
        _croak_error();
#line 15641 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_num_of_storage_volumes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_num_of_storage_volumes)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool");
    {
	virStoragePoolPtr	pool;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::num_of_storage_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7824 "lib/Sys/Virt.xs"
    if ((RETVAL = virStoragePoolNumOfVolumes(pool)) < 0)
        _croak_error();
#line 15669 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StoragePool_list_storage_vol_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_list_storage_vol_names)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pool, maxnames");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	int	maxnames = (int)SvIV(ST(1))
;
#line 7835 "lib/Sys/Virt.xs"
    char **names;
    int i, nnet;
#line 15692 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::list_storage_vol_names() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7838 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nnet = virStoragePoolListVolumes(pool, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 15713 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_list_all_volumes); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_list_all_volumes)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "pool, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStoragePoolPtr	pool;
	unsigned int	flags;
#line 7856 "lib/Sys/Virt.xs"
    virStorageVolPtr *vols;
    int i, nvolss;
    SV *volssrv;
#line 15735 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StoragePool::list_all_volumes() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7860 "lib/Sys/Virt.xs"
    if ((nvolss = virStoragePoolListAllVolumes(pool, &vols, flags)) < 0)
        _croak_error();

    EXTEND(SP, nvolss);
    for (i = 0 ; i < nvolss ; i++) {
        volssrv = sv_newmortal();
        sv_setref_pv(volssrv, "Sys::Virt::StorageVol", vols[i]);
        PUSHs(volssrv);
    }
    free(vols);
#line 15762 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StoragePool_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StoragePool_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "pool_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	pool_rv = ST(0)
;
#line 7878 "lib/Sys/Virt.xs"
    virStoragePoolPtr pool;
#line 15782 "lib/Sys/Virt.c"
#line 7880 "lib/Sys/Virt.xs"
    pool = (virStoragePoolPtr)SvIV((SV*)SvRV(pool_rv));
    if (pool) {
        virStoragePoolFree(pool);
        sv_setiv((SV*)SvRV(pool_rv), 0);
    }
#line 15789 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "pool, xml, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(2))
;
	}
#line 7896 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolCreateXML(pool, xml, flags)))
        _croak_error();
#line 15826 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StorageVol", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml_from); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__create_xml_from)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "pool, xml, clone, flags=0");
    {
	virStoragePoolPtr	pool;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	clone;
	int	flags;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(2)) && (SvTYPE(SvRV(ST(2))) == SVt_PVMG))
        clone = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(2) )));
    else {
        warn( "Sys::Virt::StorageVol::_create_xml_from() -- clone is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (int)SvIV(ST(3))
;
	}
#line 7909 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolCreateXMLFrom(pool, xml, clone, flags)))
        _croak_error();
#line 15877 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StorageVol", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "pool, name");
    {
	virStoragePoolPtr	pool;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        pool = INT2PTR(virStoragePoolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_name() -- pool is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7920 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolLookupByName(pool, name)))
        _croak_error();
#line 15911 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StorageVol", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_key)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, key");
    {
	virConnectPtr	con;
	const char *	key = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_key() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7931 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolLookupByKey(con, key)))
        _croak_error();
#line 15945 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StorageVol", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol__lookup_by_path)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, path");
    {
	virConnectPtr	con;
	const char *	path = (const char *)SvPV_nolen(ST(1))
;
	virStorageVolPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::_lookup_by_path() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7942 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolLookupByPath(con, path)))
        _croak_error();
#line 15979 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::StorageVol", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_name() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7952 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolGetName(vol)))
        _croak_error();
#line 16012 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_key); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_key)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_key() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7962 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolGetKey(vol)))
        _croak_error();
#line 16042 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_path); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_path)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol");
    {
	virStorageVolPtr	vol;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_path() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 7972 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStorageVolGetPath(vol)))
        _croak_error();
#line 16072 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_resize); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_resize)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "vol, capacity, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	SV *	capacity = ST(1)
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::resize() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 7984 "lib/Sys/Virt.xs"
    if (virStorageVolResize(vol, virt_SvIVull(capacity), flags) < 0)
        _croak_error();
#line 16112 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    {
	virStorageVolPtr	vol;
	unsigned int	flags;
#line 7993 "lib/Sys/Virt.xs"
    char *xml;
#line 16130 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_xml_description() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 7995 "lib/Sys/Virt.xs"
    if (!(xml = virStorageVolGetXMLDesc(vol, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 16153 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::delete() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8009 "lib/Sys/Virt.xs"
    if (virStorageVolDelete(vol, flags) < 0)
        _croak_error();
#line 16190 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_wipe); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_wipe)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::wipe() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8018 "lib/Sys/Virt.xs"
    if (virStorageVolWipe(vol, flags) < 0)
        _croak_error();
#line 16226 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_wipe_pattern); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_wipe_pattern)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "vol, algorithm, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	unsigned int	algorithm = (unsigned int)SvUV(ST(1))
;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::wipe_pattern() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8028 "lib/Sys/Virt.xs"
    if (virStorageVolWipePattern(vol, algorithm, flags) < 0)
        _croak_error();
#line 16264 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_get_info); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_get_info)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "vol, flags=0");
    {
	virStorageVolPtr	vol;
	unsigned int	flags;
#line 8037 "lib/Sys/Virt.xs"
    virStorageVolInfo info;
#line 16282 "lib/Sys/Virt.c"
	HV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::get_info() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8039 "lib/Sys/Virt.xs"
    if (flags != 0) {
        if (virStorageVolGetInfoFlags(vol, &info, flags) < 0)
            _croak_error();
    } else {
        if (virStorageVolGetInfo(vol, &info) < 0)
            _croak_error();
    }

    RETVAL = (HV *)sv_2mortal((SV*)newHV());
    (void)hv_store (RETVAL, "type", 4, newSViv(info.type), 0);
    (void)hv_store (RETVAL, "capacity", 8, virt_newSVull(info.capacity), 0);
    (void)hv_store (RETVAL, "allocation", 10, virt_newSVull(info.allocation), 0);
#line 16312 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = newRV((SV*)RETVAL);
	    RETVALSV = sv_2mortal(RETVALSV);
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__StorageVol_download); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_download)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "vol, st, offsetsv, lengthsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	virStreamPtr	st;
	SV *	offsetsv = ST(2)
;
	SV *	lengthsv = ST(3)
;
	unsigned int	flags;
#line 8063 "lib/Sys/Virt.xs"
    unsigned long long offset;
    unsigned long long length;
#line 16343 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::download() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::StorageVol::download() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 8066 "lib/Sys/Virt.xs"
    offset = virt_SvIVull(offsetsv);
    length = virt_SvIVull(lengthsv);

    if (virStorageVolDownload(vol, st, offset, length, flags) < 0)
        _croak_error();
#line 16373 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_upload); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_upload)
{
    dVAR; dXSARGS;
    if (items < 4 || items > 5)
       croak_xs_usage(cv,  "vol, st, offsetsv, lengthsv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStorageVolPtr	vol;
	virStreamPtr	st;
	SV *	offsetsv = ST(2)
;
	SV *	lengthsv = ST(3)
;
	unsigned int	flags;
#line 8081 "lib/Sys/Virt.xs"
    unsigned long long offset;
    unsigned long long length;
#line 16399 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        vol = INT2PTR(virStorageVolPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::StorageVol::upload() -- vol is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

    if (sv_isobject(ST(1)) && (SvTYPE(SvRV(ST(1))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(1) )));
    else {
        warn( "Sys::Virt::StorageVol::upload() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 5)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(4))
;
	}
#line 8084 "lib/Sys/Virt.xs"
    offset = virt_SvIVull(offsetsv);
    length = virt_SvIVull(lengthsv);

    if (virStorageVolUpload(vol, st, offset, length, flags) < 0)
        _croak_error();
#line 16429 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__StorageVol_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__StorageVol_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "vol_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	vol_rv = ST(0)
;
#line 8095 "lib/Sys/Virt.xs"
    virStorageVolPtr vol;
#line 16449 "lib/Sys/Virt.c"
#line 8097 "lib/Sys/Virt.xs"
    vol = (virStorageVolPtr)SvIV((SV*)SvRV(vol_rv));
    if (vol) {
        virStorageVolFree(vol);
        sv_setiv((SV*)SvRV(vol_rv), 0);
    }
#line 16456 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8113 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNodeDeviceCreateXML(con, xml, flags)))
        _croak_error();
#line 16493 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NodeDevice", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8125 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNodeDeviceDefineXML(con, xml, flags)))
        _croak_error();
#line 16535 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NodeDevice", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8136 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNodeDeviceLookupByName(con, name)))
        _croak_error();
#line 16569 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NodeDevice", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_scsihost_by_wwn); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice__lookup_scsihost_by_wwn)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "con, wwnn, wwpn, flags=0");
    {
	virConnectPtr	con;
	const char *	wwnn = (const char *)SvPV_nolen(ST(1))
;
	const char *	wwpn = (const char *)SvPV_nolen(ST(2))
;
	unsigned int	flags;
	virNodeDevicePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::_lookup_scsihost_by_wwn() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 8149 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNodeDeviceLookupSCSIHostByWWN(con, wwnn, wwpn, flags)))
        _croak_error();
#line 16613 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NodeDevice", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_name() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8159 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNodeDeviceGetName(dev)))
        _croak_error();
#line 16646 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_parent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    {
	virNodeDevicePtr	dev;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_parent() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8169 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNodeDeviceGetParent(dev))) {
        if (virGetLastError() != NULL)
            _croak_error();
    }
#line 16678 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, flags=0");
    {
	virNodeDevicePtr	dev;
	unsigned int	flags;
#line 8182 "lib/Sys/Virt.xs"
    char *xml;
#line 16698 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_xml_description() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8184 "lib/Sys/Virt.xs"
    if (!(xml = virNodeDeviceGetXMLDesc(dev, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 16721 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_dettach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_dettach)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dev, driversv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
	SV *	driversv = ST(1)
;
	unsigned int	flags;
#line 8199 "lib/Sys/Virt.xs"
    const char *driver = NULL;
    STRLEN len;
#line 16745 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::dettach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8202 "lib/Sys/Virt.xs"
    if (SvOK(driversv)) {
        driver = SvPV(driversv, len);
    }

    if (flags || driver) {
        if (virNodeDeviceDetachFlags(dev, driver, flags) < 0)
            _croak_error();
    } else {
        if (virNodeDeviceDettach(dev) < 0)
            _croak_error();
    }
#line 16773 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_reattach); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_reattach)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::reattach() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8219 "lib/Sys/Virt.xs"
    if (virNodeDeviceReAttach(dev) < 0)
        _croak_error();
#line 16801 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_reset); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_reset)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::reset() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8227 "lib/Sys/Virt.xs"
    if (virNodeDeviceReset(dev) < 0)
        _croak_error();
#line 16829 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_create)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::create() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8236 "lib/Sys/Virt.xs"
    if (virNodeDeviceCreate(dev, flags) < 0)
        _croak_error();
#line 16865 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_undefine)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "dev, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::undefine() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8245 "lib/Sys/Virt.xs"
    if (virNodeDeviceUndefine(dev, flags) < 0)
        _croak_error();
#line 16901 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_list_capabilities); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_list_capabilities)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	dev;
#line 8253 "lib/Sys/Virt.xs"
    int maxnames;
    char **names;
    int i, nnet;
#line 16922 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::list_capabilities() -- dev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8257 "lib/Sys/Virt.xs"
    if ((maxnames = virNodeDeviceNumOfCaps(dev)) < 0)
        _croak_error();

    Newx(names, maxnames, char *);
    if ((nnet = virNodeDeviceListCaps(dev, names, maxnames)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nnet);
    for (i = 0 ; i < nnet ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 16946 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_set_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_set_autostart)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "nodedev, autostart");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNodeDevicePtr	nodedev;
	int	autostart = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        nodedev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::set_autostart() -- nodedev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8278 "lib/Sys/Virt.xs"
    if (virNodeDeviceSetAutostart(nodedev, autostart) < 0)
        _croak_error();
#line 16976 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_get_autostart); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_get_autostart)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nodedev");
    {
	virNodeDevicePtr	nodedev;
#line 8286 "lib/Sys/Virt.xs"
    int autostart;
#line 16993 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        nodedev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::get_autostart() -- nodedev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8288 "lib/Sys/Virt.xs"
    if (virNodeDeviceGetAutostart(nodedev, &autostart) < 0)
        _croak_error();
    RETVAL = autostart;
#line 17008 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nodedev");
    {
	virNodeDevicePtr	nodedev;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        nodedev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::is_active() -- nodedev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8299 "lib/Sys/Virt.xs"
    if ((RETVAL = virNodeDeviceIsActive(nodedev)) < 0)
        _croak_error();
#line 17037 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_is_persistent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_is_persistent)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "nodedev");
    {
	virNodeDevicePtr	nodedev;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        nodedev = INT2PTR(virNodeDevicePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NodeDevice::is_persistent() -- nodedev is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8309 "lib/Sys/Virt.xs"
    if ((RETVAL = virNodeDeviceIsPersistent(nodedev)) < 0)
        _croak_error();
#line 17066 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_destroy)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0)
;
#line 8319 "lib/Sys/Virt.xs"
    virNodeDevicePtr dev;
#line 17087 "lib/Sys/Virt.c"
#line 8321 "lib/Sys/Virt.xs"
    dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
    if (virNodeDeviceDestroy(dev) < 0)
        _croak_error();
#line 17092 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NodeDevice_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NodeDevice_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "dev_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	dev_rv = ST(0)
;
#line 8330 "lib/Sys/Virt.xs"
    virNodeDevicePtr dev;
#line 17112 "lib/Sys/Virt.c"
#line 8332 "lib/Sys/Virt.xs"
    dev = (virNodeDevicePtr)SvIV((SV*)SvRV(dev_rv));
    if (dev) {
        virNodeDeviceFree(dev);
        sv_setiv((SV*)SvRV(dev_rv), 0);
    }
#line 17119 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags = 0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8347 "lib/Sys/Virt.xs"
    if (!(RETVAL = virInterfaceDefineXML(con, xml, flags)))
        _croak_error();
#line 17156 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Interface", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8358 "lib/Sys/Virt.xs"
    if (!(RETVAL = virInterfaceLookupByName(con, name)))
        _croak_error();
#line 17190 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Interface", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface__lookup_by_mac)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, mac");
    {
	virConnectPtr	con;
	const char *	mac = (const char *)SvPV_nolen(ST(1))
;
	virInterfacePtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::_lookup_by_mac() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8369 "lib/Sys/Virt.xs"
    if (!(RETVAL = virInterfaceLookupByMACString(con, mac)))
        _croak_error();
#line 17224 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Interface", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_get_mac); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_get_mac)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::get_mac() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8379 "lib/Sys/Virt.xs"
    if (!(RETVAL = virInterfaceGetMACString(iface)))
        _croak_error();
#line 17257 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::get_name() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8389 "lib/Sys/Virt.xs"
    if (!(RETVAL = virInterfaceGetName(iface)))
        _croak_error();
#line 17287 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_is_active); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_is_active)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    {
	virInterfacePtr	iface;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::is_active() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8399 "lib/Sys/Virt.xs"
    if ((RETVAL = virInterfaceIsActive(iface)) < 0)
        _croak_error();
#line 17317 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    {
	virInterfacePtr	iface;
	unsigned int	flags;
#line 8410 "lib/Sys/Virt.xs"
    char *xml;
#line 17336 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::get_xml_description() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8412 "lib/Sys/Virt.xs"
    if (!(xml = virInterfaceGetXMLDesc(iface, flags)))
        _croak_error();
    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 17358 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Interface_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::undefine() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8424 "lib/Sys/Virt.xs"
    if (virInterfaceUndefine(iface) < 0)
        _croak_error();
#line 17387 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface_create); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_create)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virInterfacePtr	iface;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        iface = INT2PTR(virInterfacePtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Interface::create() -- iface is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8433 "lib/Sys/Virt.xs"
    if (virInterfaceCreate(iface, flags) < 0)
        _croak_error();
#line 17423 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface_destroy); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_destroy)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "iface_rv, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0)
;
	unsigned int	flags;
#line 8442 "lib/Sys/Virt.xs"
    virInterfacePtr iface;
#line 17444 "lib/Sys/Virt.c"

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8444 "lib/Sys/Virt.xs"
    iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
    if (virInterfaceDestroy(iface, flags) < 0)
        _croak_error();
#line 17456 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Interface_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Interface_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "iface_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	iface_rv = ST(0)
;
#line 8453 "lib/Sys/Virt.xs"
    virInterfacePtr iface;
#line 17476 "lib/Sys/Virt.c"
#line 8455 "lib/Sys/Virt.xs"
    iface = (virInterfacePtr)SvIV((SV*)SvRV(iface_rv));
    if (iface) {
        virInterfaceFree(iface);
        sv_setiv((SV*)SvRV(iface_rv), 0);
    }
#line 17483 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Secret__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8471 "lib/Sys/Virt.xs"
    if (!(RETVAL = virSecretDefineXML(con, xml, flags)))
        _croak_error();
#line 17520 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Secret", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_usage); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_usage)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "con, usageType, usageID");
    {
	virConnectPtr	con;
	int	usageType = (int)SvIV(ST(1))
;
	const char *	usageID = (const char *)SvPV_nolen(ST(2))
;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_usage() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8483 "lib/Sys/Virt.xs"
    if (!(RETVAL = virSecretLookupByUsage(con, usageType, usageID))) {
        _croak_error();
    }
#line 17557 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Secret", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8495 "lib/Sys/Virt.xs"
    if (!(RETVAL = virSecretLookupByUUID(con, uuid)))
        _croak_error();
#line 17591 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Secret", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virSecretPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8506 "lib/Sys/Virt.xs"
    if (!(RETVAL = virSecretLookupByUUIDString(con, uuid)))
        _croak_error();
#line 17625 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Secret", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
#line 8516 "lib/Sys/Virt.xs"
    unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 17647 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_uuid() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8518 "lib/Sys/Virt.xs"
    if ((virSecretGetUUID(sec, rawuuid)) < 0)
        _croak_error();

    RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 17662 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
#line 8530 "lib/Sys/Virt.xs"
    char uuid[VIR_UUID_STRING_BUFLEN];
#line 17680 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_uuid_string() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8532 "lib/Sys/Virt.xs"
    if ((virSecretGetUUIDString(sec, uuid)) < 0)
        _croak_error();

    RETVAL = newSVpv(uuid, 0);
#line 17695 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_usage_id); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_usage_id)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_usage_id() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8544 "lib/Sys/Virt.xs"
    if (!(RETVAL = virSecretGetUsageID(sec)))
        _croak_error();
#line 17724 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_usage_type); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_usage_type)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    {
	virSecretPtr	sec;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_usage_type() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8554 "lib/Sys/Virt.xs"
    if (!(RETVAL = virSecretGetUsageType(sec)))
        _croak_error();
#line 17754 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sec, flags=0");
    {
	virSecretPtr	sec;
	unsigned int	flags;
#line 8565 "lib/Sys/Virt.xs"
    char *xml;
#line 17773 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_xml_description() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8567 "lib/Sys/Virt.xs"
    if (!(xml = virSecretGetXMLDesc(sec, flags)))
        _croak_error();
    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 17795 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virSecretPtr	sec;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::undefine() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8579 "lib/Sys/Virt.xs"
    if (virSecretUndefine(sec) < 0)
        _croak_error();
#line 17824 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Secret_set_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_set_value)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "sec, value, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virSecretPtr	sec;
	SV *	value = ST(1)
;
	unsigned int	flags;
#line 8589 "lib/Sys/Virt.xs"
    unsigned char *bytes;
    STRLEN len;
#line 17847 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::set_value() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8592 "lib/Sys/Virt.xs"
    bytes = (unsigned char *)SvPV(value, len);
    if (virSecretSetValue(sec, bytes, len, flags) < 0)
        _croak_error();
#line 17867 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Secret_get_value); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_get_value)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "sec, flags=0");
    {
	virSecretPtr	sec;
	unsigned int	flags;
#line 8602 "lib/Sys/Virt.xs"
    unsigned char *bytes;
    size_t len;
#line 17886 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        sec = INT2PTR(virSecretPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Secret::get_value() -- sec is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8605 "lib/Sys/Virt.xs"
    if ((bytes = virSecretGetValue(sec, &len, flags)) == NULL)
        _croak_error();

    RETVAL = newSVpv((char*)bytes, len);
#line 17908 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Secret_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Secret_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "sec_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	sec_rv = ST(0)
;
#line 8618 "lib/Sys/Virt.xs"
    virSecretPtr sec;
#line 17929 "lib/Sys/Virt.c"
#line 8620 "lib/Sys/Virt.xs"
    sec = (virSecretPtr)SvIV((SV*)SvRV(sec_rv));
    if (sec) {
        virSecretFree(sec);
        sv_setiv((SV*)SvRV(sec_rv), 0);
    }
#line 17936 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NWFilter__define_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__define_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_define_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8636 "lib/Sys/Virt.xs"
    if (flags) {
        if (!(RETVAL = virNWFilterDefineXMLFlags(con, xml, flags)))
            _croak_error();
    } else {
        if (!(RETVAL = virNWFilterDefineXML(con, xml)))
            _croak_error();
    }
#line 17978 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NWFilter", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_name() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8652 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterLookupByName(con, name)))
        _croak_error();
#line 18012 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NWFilter", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const unsigned char *	uuid = (const unsigned char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_uuid() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8663 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterLookupByUUID(con, uuid)))
        _croak_error();
#line 18046 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NWFilter", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter__lookup_by_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, uuid");
    {
	virConnectPtr	con;
	const char *	uuid = (const char *)SvPV_nolen(ST(1))
;
	virNWFilterPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::_lookup_by_uuid_string() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8674 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterLookupByUUIDString(con, uuid)))
        _croak_error();
#line 18080 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NWFilter", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
#line 8684 "lib/Sys/Virt.xs"
    unsigned char rawuuid[VIR_UUID_BUFLEN];
#line 18102 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_uuid() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8686 "lib/Sys/Virt.xs"
    if ((virNWFilterGetUUID(filter, rawuuid)) < 0)
        _croak_error();

    RETVAL = newSVpv((char*)rawuuid, sizeof(rawuuid));
#line 18117 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid_string); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_uuid_string)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
#line 8698 "lib/Sys/Virt.xs"
    char uuid[VIR_UUID_STRING_BUFLEN];
#line 18135 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_uuid_string() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8700 "lib/Sys/Virt.xs"
    if ((virNWFilterGetUUIDString(filter, uuid)) < 0)
        _croak_error();

    RETVAL = newSVpv(uuid, 0);
#line 18150 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    {
	virNWFilterPtr	filter;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_name() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8712 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterGetName(filter)))
        _croak_error();
#line 18179 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "filter, flags=0");
    {
	virNWFilterPtr	filter;
	unsigned int	flags;
#line 8723 "lib/Sys/Virt.xs"
    char *xml;
#line 18199 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::get_xml_description() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8725 "lib/Sys/Virt.xs"
    if (!(xml = virNWFilterGetXMLDesc(filter, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 18222 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilter_undefine); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_undefine)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNWFilterPtr	filter;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        filter = INT2PTR(virNWFilterPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilter::undefine() -- filter is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8738 "lib/Sys/Virt.xs"
    if (virNWFilterUndefine(filter) < 0)
        _croak_error();
#line 18251 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NWFilter_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilter_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "filter_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	filter_rv = ST(0)
;
#line 8745 "lib/Sys/Virt.xs"
    virNWFilterPtr filter;
#line 18271 "lib/Sys/Virt.c"
#line 8747 "lib/Sys/Virt.xs"
    filter = (virNWFilterPtr)SvIV((SV*)SvRV(filter_rv));
    if (filter) {
        virNWFilterFree(filter);
        sv_setiv((SV*)SvRV(filter_rv), 0);
    }
#line 18278 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "con, xml, flags=0");
    {
	virConnectPtr	con;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virNWFilterBindingPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilterBinding::_create_xml() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8763 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterBindingCreateXML(con, xml, flags)))
        _croak_error();
#line 18315 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NWFilterBinding", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding__lookup_by_port_dev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding__lookup_by_port_dev)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "con, name");
    {
	virConnectPtr	con;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	virNWFilterBindingPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilterBinding::_lookup_by_port_dev() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8774 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterBindingLookupByPortDev(con, name)))
        _croak_error();
#line 18349 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::NWFilterBinding", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding_get_port_dev); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding_get_port_dev)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "binding");
    {
	virNWFilterBindingPtr	binding;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        binding = INT2PTR(virNWFilterBindingPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilterBinding::get_port_dev() -- binding is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8784 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterBindingGetPortDev(binding)))
        _croak_error();
#line 18382 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding_get_filter_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding_get_filter_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "binding");
    {
	virNWFilterBindingPtr	binding;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        binding = INT2PTR(virNWFilterBindingPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilterBinding::get_filter_name() -- binding is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8794 "lib/Sys/Virt.xs"
    if (!(RETVAL = virNWFilterBindingGetFilterName(binding)))
        _croak_error();
#line 18412 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "binding, flags=0");
    {
	virNWFilterBindingPtr	binding;
	unsigned int	flags;
#line 8805 "lib/Sys/Virt.xs"
    char *xml;
#line 18432 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        binding = INT2PTR(virNWFilterBindingPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilterBinding::get_xml_description() -- binding is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8807 "lib/Sys/Virt.xs"
    if (!(xml = virNWFilterBindingGetXMLDesc(binding, flags)))
        _croak_error();

    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 18455 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding_delete)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "binding");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virNWFilterBindingPtr	binding;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        binding = INT2PTR(virNWFilterBindingPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::NWFilterBinding::delete() -- binding is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8820 "lib/Sys/Virt.xs"
    if (virNWFilterBindingDelete(binding) < 0)
        _croak_error();
#line 18484 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__NWFilterBinding_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__NWFilterBinding_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "binding_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	binding_rv = ST(0)
;
#line 8827 "lib/Sys/Virt.xs"
    virNWFilterBindingPtr binding;
#line 18504 "lib/Sys/Virt.c"
#line 8829 "lib/Sys/Virt.xs"
    binding = (virNWFilterBindingPtr)SvIV((SV*)SvRV(binding_rv));
    if (binding) {
        virNWFilterBindingFree(binding);
        sv_setiv((SV*)SvRV(binding_rv), 0);
    }
#line 18511 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::_create_xml() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8845 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainSnapshotCreateXML(dom, xml, flags)))
        _croak_error();
#line 18548 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainSnapshot", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, name, flags=0");
    {
	virDomainPtr	dom;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::_lookup_by_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8857 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainSnapshotLookupByName(dom, name, flags)))
        _croak_error();
#line 18590 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainSnapshot", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "domss");
    {
	virDomainSnapshotPtr	domss;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_name() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 8867 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainSnapshotGetName(domss)))
        _croak_error();
#line 18623 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
#line 8878 "lib/Sys/Virt.xs"
    char *xml;
#line 18643 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_xml_description() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8880 "lib/Sys/Virt.xs"
    if (!(xml = virDomainSnapshotGetXMLDesc(domss, flags)))
        _croak_error();
    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 18665 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_revert_to); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_revert_to)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::revert_to() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8893 "lib/Sys/Virt.xs"
    if (virDomainRevertToSnapshot(domss, flags) < 0)
        _croak_error();
#line 18702 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::delete() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8902 "lib/Sys/Virt.xs"
    if (virDomainSnapshotDelete(domss, flags) < 0)
        _croak_error();
#line 18738 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_get_parent)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	virDomainSnapshotPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::get_parent() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8911 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainSnapshotGetParent(domss, flags)))
        _croak_error();
#line 18773 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainSnapshot", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::num_of_child_snapshots() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8922 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainSnapshotNumChildren(domss, flags)) < 0)
        _croak_error();
#line 18814 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_is_current); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_is_current)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::is_current() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8933 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainSnapshotIsCurrent(domss, flags)) < 0)
        _croak_error();
#line 18851 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_has_metadata); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_has_metadata)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::has_metadata() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8944 "lib/Sys/Virt.xs"
    if ((RETVAL = virDomainSnapshotHasMetadata(domss, flags)) < 0)
        _croak_error();
#line 18888 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "domss, maxnames, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	int	maxnames = (int)SvIV(ST(1))
;
	unsigned int	flags;
#line 8956 "lib/Sys/Virt.xs"
    char **names;
    int nsnap;
    int i;
#line 18913 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::list_child_snapshot_names() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 8960 "lib/Sys/Virt.xs"
    Newx(names, maxnames, char *);
    if ((nsnap = virDomainSnapshotListChildrenNames(domss, names, maxnames, flags)) < 0) {
        Safefree(names);
        _croak_error();
    }
    EXTEND(SP, nsnap);
    for (i = 0 ; i < nsnap ; i++) {
        PUSHs(sv_2mortal(newSVpv(names[i], 0)));
        free(names[i]);
    }
    Safefree(names);
#line 18941 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_all_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_list_all_children)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domss, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainSnapshotPtr	domss;
	unsigned int	flags;
#line 8978 "lib/Sys/Virt.xs"
    virDomainSnapshotPtr *domsss;
    int i, ndomss;
    SV *domssrv;
#line 18963 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domss = INT2PTR(virDomainSnapshotPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainSnapshot::list_all_children() -- domss is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 8982 "lib/Sys/Virt.xs"
    if ((ndomss = virDomainSnapshotListAllChildren(domss, &domsss, flags)) < 0)
        _croak_error();

    EXTEND(SP, ndomss);
    for (i = 0 ; i < ndomss ; i++) {
        domssrv = sv_newmortal();
        sv_setref_pv(domssrv, "Sys::Virt::DomainSnapshot", domsss[i]);
        PUSHs(domssrv);
    }
    free(domsss);
#line 18990 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainSnapshot_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainSnapshot_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "domss_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	domss_rv = ST(0)
;
#line 8998 "lib/Sys/Virt.xs"
    virDomainSnapshotPtr domss;
#line 19010 "lib/Sys/Virt.c"
#line 9000 "lib/Sys/Virt.xs"
    domss = (virDomainSnapshotPtr)SvIV((SV*)SvRV(domss_rv));
    if (domss) {
        virDomainSnapshotFree(domss);
        sv_setiv((SV*)SvRV(domss_rv), 0);
    }
#line 19017 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint__create_xml); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint__create_xml)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, xml, flags=0");
    {
	virDomainPtr	dom;
	const char *	xml = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainCheckpointPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::_create_xml() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 9016 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainCheckpointCreateXML(dom, xml, flags)))
        _croak_error();
#line 19054 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainCheckpoint", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint__lookup_by_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint__lookup_by_name)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "dom, name, flags=0");
    {
	virDomainPtr	dom;
	const char *	name = (const char *)SvPV_nolen(ST(1))
;
	unsigned int	flags;
	virDomainCheckpointPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        dom = INT2PTR(virDomainPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::_lookup_by_name() -- dom is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 9028 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainCheckpointLookupByName(dom, name, flags)))
        _croak_error();
#line 19096 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainCheckpoint", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_get_name); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_get_name)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "domcp");
    {
	virDomainCheckpointPtr	domcp;
	const char *	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domcp = INT2PTR(virDomainCheckpointPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::get_name() -- domcp is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 9038 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainCheckpointGetName(domcp)))
        _croak_error();
#line 19129 "lib/Sys/Virt.c"
	sv_setpv(TARG, RETVAL);
	XSprePUSH;
	PUSHTARG;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_get_xml_description); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_get_xml_description)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domcp, flags=0");
    {
	virDomainCheckpointPtr	domcp;
	unsigned int	flags;
#line 9049 "lib/Sys/Virt.xs"
    char *xml;
#line 19149 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domcp = INT2PTR(virDomainCheckpointPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::get_xml_description() -- domcp is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 9051 "lib/Sys/Virt.xs"
    if (!(xml = virDomainCheckpointGetXMLDesc(domcp, flags)))
        _croak_error();
    RETVAL = newSVpv(xml, 0);
    free(xml);
#line 19171 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_delete); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_delete)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domcp, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainCheckpointPtr	domcp;
	unsigned int	flags;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domcp = INT2PTR(virDomainCheckpointPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::delete() -- domcp is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 9064 "lib/Sys/Virt.xs"
    if (virDomainCheckpointDelete(domcp, flags) < 0)
        _croak_error();
#line 19208 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_get_parent); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_get_parent)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domcp, flags=0");
    {
	virDomainCheckpointPtr	domcp;
	unsigned int	flags;
	virDomainCheckpointPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domcp = INT2PTR(virDomainCheckpointPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::get_parent() -- domcp is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 9073 "lib/Sys/Virt.xs"
    if (!(RETVAL = virDomainCheckpointGetParent(domcp, flags)))
        _croak_error();
#line 19243 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::DomainCheckpoint", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_list_all_children); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_list_all_children)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "domcp, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virDomainCheckpointPtr	domcp;
	unsigned int	flags;
#line 9084 "lib/Sys/Virt.xs"
    virDomainCheckpointPtr *domcps;
    int i, ndomcp;
    SV *domcprv;
#line 19270 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        domcp = INT2PTR(virDomainCheckpointPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::DomainCheckpoint::list_all_children() -- domcp is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 9088 "lib/Sys/Virt.xs"
    if ((ndomcp = virDomainCheckpointListAllChildren(domcp, &domcps, flags)) < 0)
        _croak_error();

    EXTEND(SP, ndomcp);
    for (i = 0 ; i < ndomcp ; i++) {
        domcprv = sv_newmortal();
        sv_setref_pv(domcprv, "Sys::Virt::DomainCheckpoint", domcps[i]);
        PUSHs(domcprv);
    }
    free(domcps);
#line 19297 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__DomainCheckpoint_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "domcp_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	domcp_rv = ST(0)
;
#line 9104 "lib/Sys/Virt.xs"
    virDomainCheckpointPtr domcp;
#line 19317 "lib/Sys/Virt.c"
#line 9106 "lib/Sys/Virt.xs"
    domcp = (virDomainCheckpointPtr)SvIV((SV*)SvRV(domcp_rv));
    if (domcp) {
        virDomainCheckpointFree(domcp);
        sv_setiv((SV*)SvRV(domcp_rv), 0);
    }
#line 19324 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__register_impl); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__register_impl)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9122 "lib/Sys/Virt.xs"
    virEventRegisterImpl(_event_add_handle,
                         _event_update_handle,
                         _event_remove_handle,
                         _event_add_timeout,
                         _event_update_timeout,
                         _event_remove_timeout);
#line 19347 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_register_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_register_default)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9133 "lib/Sys/Virt.xs"
    virEventRegisterDefaultImpl();
#line 19365 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_run_default); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_run_default)
{
    dVAR; dXSARGS;
    if (items != 0)
       croak_xs_usage(cv,  "");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
#line 9139 "lib/Sys/Virt.xs"
    virEventRunDefaultImpl();
#line 19383 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_add_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_add_handle)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "fd, events, coderef");
    {
	int	fd = (int)SvIV(ST(0))
;
	int	events = (int)SvIV(ST(1))
;
	SV *	coderef = ST(2)
;
#line 9148 "lib/Sys/Virt.xs"
    int watch;
#line 19405 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 9150 "lib/Sys/Virt.xs"
    SvREFCNT_inc(coderef);

    if ((watch = virEventAddHandle(fd, events, _event_handle_helper, coderef, _event_cb_free)) < 0) {
        SvREFCNT_dec(coderef);
        _croak_error();
    }
    RETVAL = watch;
#line 19416 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Event_update_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_update_handle)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "watch, events");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0))
;
	int	events = (int)SvIV(ST(1))
;
#line 9166 "lib/Sys/Virt.xs"
    virEventUpdateHandle(watch, events);
#line 19439 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_remove_handle); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_remove_handle)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "watch");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0))
;
#line 9173 "lib/Sys/Virt.xs"
    if (virEventRemoveHandle(watch) < 0)
        _croak_error();
#line 19460 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_add_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_add_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "frequency, coderef");
    {
	int	frequency = (int)SvIV(ST(0))
;
	SV *	coderef = ST(1)
;
#line 9182 "lib/Sys/Virt.xs"
    int timer;
#line 19480 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;
#line 9184 "lib/Sys/Virt.xs"
    SvREFCNT_inc(coderef);

    if ((timer = virEventAddTimeout(frequency, _event_timeout_helper, coderef, _event_cb_free)) < 0) {
        SvREFCNT_dec(coderef);
        _croak_error();
    }
    RETVAL = timer;
#line 19491 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Event_update_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_update_timeout)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "timer, frequency");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0))
;
	int	frequency = (int)SvIV(ST(1))
;
#line 9200 "lib/Sys/Virt.xs"
    virEventUpdateTimeout(timer, frequency);
#line 19514 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event_remove_timeout); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event_remove_timeout)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "timer");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0))
;
#line 9207 "lib/Sys/Virt.xs"
    if (virEventRemoveTimeout(timer) < 0)
        _croak_error();
#line 19535 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__run_handle_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__run_handle_callback_helper)
{
    dVAR; dXSARGS;
    if (items != 5)
       croak_xs_usage(cv,  "watch, fd, event, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	watch = (int)SvIV(ST(0))
;
	int	fd = (int)SvIV(ST(1))
;
	int	event = (int)SvIV(ST(2))
;
	SV *	cbref = ST(3)
;
	SV *	opaqueref = ST(4)
;
#line 9219 "lib/Sys/Virt.xs"
    virEventHandleCallback cb;
    void *opaque;
#line 19564 "lib/Sys/Virt.c"
#line 9222 "lib/Sys/Virt.xs"
    cb = (virEventHandleCallback)SvIV((SV*)SvRV(cbref));
    opaque = (void*)SvIV((SV*)SvRV(opaqueref));

    cb(watch, fd, event, opaque);
#line 19570 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__run_timeout_callback_helper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__run_timeout_callback_helper)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "timer, cbref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	int	timer = (int)SvIV(ST(0))
;
	SV *	cbref = ST(1)
;
	SV *	opaqueref = ST(2)
;
#line 9234 "lib/Sys/Virt.xs"
    virEventTimeoutCallback cb;
    void *opaque;
#line 19595 "lib/Sys/Virt.c"
#line 9237 "lib/Sys/Virt.xs"
    cb = (virEventTimeoutCallback)SvIV((SV*)SvRV(cbref));
    opaque = (void*)SvIV((SV*)SvRV(opaqueref));

    cb(timer, opaque);
#line 19601 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Event__free_callback_opaque_helper); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Event__free_callback_opaque_helper)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "ffref, opaqueref");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	ffref = ST(0)
;
	SV *	opaqueref = ST(1)
;
#line 9248 "lib/Sys/Virt.xs"
    virFreeCallback ff;
    void *opaque;
#line 19624 "lib/Sys/Virt.c"
#line 9251 "lib/Sys/Virt.xs"
    opaque = SvOK(opaqueref) ? (void*)SvIV((SV*)SvRV(opaqueref)) : NULL;
    ff = SvOK(ffref) ? (virFreeCallback)SvIV((SV*)SvRV(ffref)) : NULL;

    if (opaque != NULL && ff != NULL)
        ff(opaque);
#line 19631 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream__new_obj); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream__new_obj)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "con, flags=0");
    {
	virConnectPtr	con;
	unsigned int	flags;
	virStreamPtr	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        con = INT2PTR(virConnectPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::_new_obj() -- con is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 9266 "lib/Sys/Virt.xs"
    if (!(RETVAL = virStreamNew(con, flags)))
        _croak_error();
#line 19666 "lib/Sys/Virt.c"
	{
	    SV * RETVALSV;
	    RETVALSV = sv_newmortal();
	    sv_setref_pv( RETVALSV, "Sys::Virt::Stream", (void*)RETVAL );
	    ST(0) = RETVALSV;
	}
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_send); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_send)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "st, data, nbytes");
    {
	virStreamPtr	st;
	SV *	data = ST(1)
;
	size_t	nbytes = (size_t)SvUV(ST(2))
;
#line 9278 "lib/Sys/Virt.xs"
    const char *rawdata;
    STRLEN len;
#line 19693 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::send() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 9281 "lib/Sys/Virt.xs"
    if (SvOK(data)) {
        rawdata = SvPV(data, len);
        if (nbytes > len)
            nbytes = len;
    } else {
        rawdata = "";
        nbytes = 0;
    }

    if ((RETVAL = virStreamSend(st, rawdata, nbytes)) < 0 &&
        RETVAL != -2)
    _croak_error();
#line 19717 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_recv); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_recv)
{
    dVAR; dXSARGS;
    if (items < 3 || items > 4)
       croak_xs_usage(cv,  "st, data, nbytes, flags=0");
    {
	virStreamPtr	st;
	SV *	data = ST(1)
;
	size_t	nbytes = (size_t)SvUV(ST(2))
;
	unsigned int	flags;
#line 9304 "lib/Sys/Virt.xs"
    char *rawdata;
#line 19740 "lib/Sys/Virt.c"
	int	RETVAL;
	dXSTARG;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::recv() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 4)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(3))
;
	}
#line 9306 "lib/Sys/Virt.xs"
    Newx(rawdata, nbytes, char);
    if (flags)
        RETVAL = virStreamRecvFlags(st, rawdata, nbytes, flags);
    else
        RETVAL = virStreamRecv(st, rawdata, nbytes);

    if (RETVAL < 0 && RETVAL != -2 && RETVAL != -3) {
        Safefree(rawdata);
        _croak_error();
    }
    if (RETVAL > 0) {
        sv_setpvn(data, rawdata, RETVAL);
    }
    Safefree(rawdata);
#line 19773 "lib/Sys/Virt.c"
	XSprePUSH;
	PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_recv_hole); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_recv_hole)
{
    dVAR; dXSARGS;
    if (items < 1 || items > 2)
       croak_xs_usage(cv,  "st, flags=0");
    {
	virStreamPtr	st;
	unsigned int	flags;
#line 9329 "lib/Sys/Virt.xs"
    long long length;
#line 19792 "lib/Sys/Virt.c"
	SV *	RETVAL;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::recv_hole() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 2)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(1))
;
	}
#line 9331 "lib/Sys/Virt.xs"
    if (virStreamRecvHole(st, &length, flags) < 0)
        _croak_error();

    RETVAL = virt_newSVll(length);
#line 19814 "lib/Sys/Virt.c"
	RETVAL = sv_2mortal(RETVAL);
	ST(0) = RETVAL;
    }
    XSRETURN(1);
}


XS_EUPXS(XS_Sys__Virt__Stream_send_hole); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_send_hole)
{
    dVAR; dXSARGS;
    if (items < 2 || items > 3)
       croak_xs_usage(cv,  "st, lengthSV, flags=0");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;
	SV *	lengthSV = ST(1)
;
	unsigned int	flags;
#line 9345 "lib/Sys/Virt.xs"
    long long length;
#line 19837 "lib/Sys/Virt.c"

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::send_hole() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;

	if (items < 3)
	    flags = 0;
	else {
	    flags = (unsigned int)SvUV(ST(2))
;
	}
#line 9347 "lib/Sys/Virt.xs"
    length = virt_SvIVll(lengthSV);
    if (virStreamSendHole(st, length, flags) < 0)
        _croak_error();
#line 19857 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_send_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_send_all)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "stref, handler");
    {
	SV *	stref = ST(0)
;
	SV *	handler = ST(1)
;
#line 9357 "lib/Sys/Virt.xs"
    AV *opaque;
    virStreamPtr st;
#line 19878 "lib/Sys/Virt.c"
#line 9360 "lib/Sys/Virt.xs"
    st = (virStreamPtr)SvIV((SV*)SvRV(stref));

    opaque = newAV();
    SvREFCNT_inc(handler);
    SvREFCNT_inc(stref);
    av_push(opaque, stref);
    av_push(opaque, handler);

    if (virStreamSendAll(st, _stream_send_all_source, opaque) < 0)
        _croak_error();

    SvREFCNT_dec(opaque);
#line 19892 "lib/Sys/Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Stream_recv_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_recv_all)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "stref, handler");
    {
	SV *	stref = ST(0)
;
	SV *	handler = ST(1)
;
#line 9379 "lib/Sys/Virt.xs"
    AV *opaque;
    virStreamPtr st;
#line 19912 "lib/Sys/Virt.c"
#line 9382 "lib/Sys/Virt.xs"
    st = (virStreamPtr)SvIV((SV*)SvRV(stref));

    opaque = newAV();
    SvREFCNT_inc(handler);
    SvREFCNT_inc(stref);
    av_push(opaque, stref);
    av_push(opaque, handler);

    if (virStreamRecvAll(st, _stream_recv_all_sink, opaque) < 0)
        _croak_error();

    SvREFCNT_dec(opaque);
#line 19926 "lib/Sys/Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Stream_sparse_recv_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_sparse_recv_all)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stref, handler, hole_handler");
    {
	SV *	stref = ST(0)
;
	SV *	handler = ST(1)
;
	SV *	hole_handler = ST(2)
;
#line 9402 "lib/Sys/Virt.xs"
    AV *opaque;
    virStreamPtr st;
#line 19948 "lib/Sys/Virt.c"
#line 9405 "lib/Sys/Virt.xs"
    st = (virStreamPtr)SvIV((SV*)SvRV(stref));

    opaque = newAV();
    SvREFCNT_inc(stref);
    SvREFCNT_inc(handler);
    SvREFCNT_inc(hole_handler);
    av_push(opaque, stref);
    av_push(opaque, handler);
    av_push(opaque, hole_handler);

    if (virStreamSparseRecvAll(st,
                               _stream_recv_all_sink,
                               _stream_sparse_recv_hole_handler,
                               opaque) < 0)
        _croak_error();

    SvREFCNT_dec(opaque);
#line 19967 "lib/Sys/Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Stream_sparse_send_all); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_sparse_send_all)
{
    dVAR; dXSARGS;
    if (items != 4)
       croak_xs_usage(cv,  "stref, handler, hole_handler, skip_handler");
    {
	SV *	stref = ST(0)
;
	SV *	handler = ST(1)
;
	SV *	hole_handler = ST(2)
;
	SV *	skip_handler = ST(3)
;
#line 9430 "lib/Sys/Virt.xs"
    AV *opaque;
    virStreamPtr st;
#line 19991 "lib/Sys/Virt.c"
#line 9433 "lib/Sys/Virt.xs"
    st = (virStreamPtr)SvIV((SV*)SvRV(stref));

    opaque = newAV();
    SvREFCNT_inc(stref);
    SvREFCNT_inc(handler);
    SvREFCNT_inc(hole_handler);
    SvREFCNT_inc(skip_handler);
    av_push(opaque, stref);
    av_push(opaque, handler);
    av_push(opaque, hole_handler);
    av_push(opaque, skip_handler);

    if (virStreamSparseSendAll(st,
                               _stream_send_all_source,
                               _stream_sparse_send_all_hole_handler,
                               _stream_sparse_send_all_skip_handler,
                               opaque) < 0)
        _croak_error();

    SvREFCNT_dec(opaque);
#line 20013 "lib/Sys/Virt.c"
    }
    XSRETURN_EMPTY;
}


XS_EUPXS(XS_Sys__Virt__Stream_add_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_add_callback)
{
    dVAR; dXSARGS;
    if (items != 3)
       croak_xs_usage(cv,  "stref, events, cb");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV*	stref = ST(0)
;
	int	events = (int)SvIV(ST(1))
;
	SV*	cb = ST(2)
;
#line 9460 "lib/Sys/Virt.xs"
    AV *opaque;
    virStreamPtr st;
#line 20037 "lib/Sys/Virt.c"
#line 9463 "lib/Sys/Virt.xs"
    st = (virStreamPtr)SvIV((SV*)SvRV(stref));

    opaque = newAV();
    SvREFCNT_inc(cb);
    SvREFCNT_inc(stref);
    av_push(opaque, stref);
    av_push(opaque, cb);
    if (virStreamEventAddCallback(st, events, _stream_event_callback, opaque, _stream_event_free) < 0)
        _croak_error();
#line 20048 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_update_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_update_callback)
{
    dVAR; dXSARGS;
    if (items != 2)
       croak_xs_usage(cv,  "st, events");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;
	int	events = (int)SvIV(ST(1))
;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::update_callback() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 9479 "lib/Sys/Virt.xs"
    if (virStreamEventUpdateCallback(st, events) < 0)
        _croak_error();
#line 20078 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_remove_callback); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_remove_callback)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::remove_callback() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 9487 "lib/Sys/Virt.xs"
    if (virStreamEventRemoveCallback(st) < 0)
        _croak_error();
#line 20106 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_finish); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_finish)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::finish() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 9495 "lib/Sys/Virt.xs"
    if (virStreamFinish(st) < 0)
        _croak_error();
#line 20134 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_abort); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_abort)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	virStreamPtr	st;

    if (sv_isobject(ST(0)) && (SvTYPE(SvRV(ST(0))) == SVt_PVMG))
        st = INT2PTR(virStreamPtr, SvIV((SV*)SvRV( ST(0) )));
    else {
        warn( "Sys::Virt::Stream::abort() -- st is not a blessed SV reference" );
        XSRETURN_UNDEF;
    }
;
#line 9503 "lib/Sys/Virt.xs"
    if (virStreamAbort(st) < 0)
        _croak_error();
#line 20162 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}


XS_EUPXS(XS_Sys__Virt__Stream_DESTROY); /* prototype to pass -Wmissing-prototypes */
XS_EUPXS(XS_Sys__Virt__Stream_DESTROY)
{
    dVAR; dXSARGS;
    if (items != 1)
       croak_xs_usage(cv,  "st_rv");
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	SV *	st_rv = ST(0)
;
#line 9511 "lib/Sys/Virt.xs"
    virStreamPtr st;
#line 20182 "lib/Sys/Virt.c"
#line 9513 "lib/Sys/Virt.xs"
    st = (virStreamPtr)SvIV((SV*)SvRV(st_rv));
    if (st) {
        virStreamFree(st);
        sv_setiv((SV*)SvRV(st_rv), 0);
    }
#line 20189 "lib/Sys/Virt.c"
	PUTBACK;
	return;
    }
}

#ifdef __cplusplus
extern "C"
#endif
XS_EXTERNAL(boot_Sys__Virt); /* prototype to pass -Wmissing-prototypes */
XS_EXTERNAL(boot_Sys__Virt)
{
#if PERL_VERSION_LE(5, 21, 5)
    dVAR; dXSARGS;
#else
    dVAR; dXSBOOTARGSXSAPIVERCHK;
#endif
#if PERL_VERSION_LE(5, 8, 999) /* PERL_VERSION_LT is 5.33+ */
    char* file = __FILE__;
#else
    const char* file = __FILE__;
#endif

    PERL_UNUSED_VAR(file);

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
#if PERL_VERSION_LE(5, 21, 5)
    XS_VERSION_BOOTCHECK;
#  ifdef XS_APIVERSION_BOOTCHECK
    XS_APIVERSION_BOOTCHECK;
#  endif
#endif

        (void)newXSproto_portable("Sys::Virt::_open", XS_Sys__Virt__open, file, "$$");
        (void)newXSproto_portable("Sys::Virt::_open_auth", XS_Sys__Virt__open_auth, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::restore_domain", XS_Sys__Virt_restore_domain, file, "$;$$$$");
        (void)newXSproto_portable("Sys::Virt::get_save_image_xml_description", XS_Sys__Virt_get_save_image_xml_description, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::define_save_image_xml", XS_Sys__Virt_define_save_image_xml, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::_get_library_version", XS_Sys__Virt__get_library_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::_get_conn_version", XS_Sys__Virt__get_conn_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::_get_conn_library_version", XS_Sys__Virt__get_conn_library_version, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_encrypted", XS_Sys__Virt_is_encrypted, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_secure", XS_Sys__Virt_is_secure, file, "$");
        (void)newXSproto_portable("Sys::Virt::is_alive", XS_Sys__Virt_is_alive, file, "$");
        (void)newXSproto_portable("Sys::Virt::set_keep_alive", XS_Sys__Virt_set_keep_alive, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::get_type", XS_Sys__Virt_get_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_uri", XS_Sys__Virt_get_uri, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_sysinfo", XS_Sys__Virt_get_sysinfo, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_info", XS_Sys__Virt_get_node_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_security_model", XS_Sys__Virt_get_node_security_model, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_sev_info", XS_Sys__Virt_get_node_sev_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_cpu_map", XS_Sys__Virt_get_node_cpu_map, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_free_memory", XS_Sys__Virt_get_node_free_memory, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_node_cells_free_memory", XS_Sys__Virt_get_node_cells_free_memory, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::get_node_free_pages", XS_Sys__Virt_get_node_free_pages, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::node_alloc_pages", XS_Sys__Virt_node_alloc_pages, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::get_node_cpu_stats", XS_Sys__Virt_get_node_cpu_stats, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::get_node_memory_stats", XS_Sys__Virt_get_node_memory_stats, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::get_node_memory_parameters", XS_Sys__Virt_get_node_memory_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::set_node_memory_parameters", XS_Sys__Virt_set_node_memory_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::set_identity", XS_Sys__Virt_set_identity, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::node_suspend_for_duration", XS_Sys__Virt_node_suspend_for_duration, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::find_storage_pool_sources", XS_Sys__Virt_find_storage_pool_sources, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::get_capabilities", XS_Sys__Virt_get_capabilities, file, "$");
        (void)newXSproto_portable("Sys::Virt::get_domain_capabilities", XS_Sys__Virt_get_domain_capabilities, file, "$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::get_storage_pool_capabilities", XS_Sys__Virt_get_storage_pool_capabilities, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::compare_cpu", XS_Sys__Virt_compare_cpu, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::compare_hypervisor_cpu", XS_Sys__Virt_compare_hypervisor_cpu, file, "$$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::baseline_cpu", XS_Sys__Virt_baseline_cpu, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::baseline_hypervisor_cpu", XS_Sys__Virt_baseline_hypervisor_cpu, file, "$$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::get_cpu_model_names", XS_Sys__Virt_get_cpu_model_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::get_max_vcpus", XS_Sys__Virt_get_max_vcpus, file, "$$");
        (void)newXSproto_portable("Sys::Virt::get_hostname", XS_Sys__Virt_get_hostname, file, "$");
        (void)newXSproto_portable("Sys::Virt::num_of_domains", XS_Sys__Virt_num_of_domains, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_domain_ids", XS_Sys__Virt_list_domain_ids, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_domains", XS_Sys__Virt_num_of_defined_domains, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_domain_names", XS_Sys__Virt_list_defined_domain_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::list_all_domains", XS_Sys__Virt_list_all_domains, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_interfaces", XS_Sys__Virt_list_all_interfaces, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_nwfilters", XS_Sys__Virt_list_all_nwfilters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_nwfilter_bindings", XS_Sys__Virt_list_all_nwfilter_bindings, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_networks", XS_Sys__Virt_list_all_networks, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_node_devices", XS_Sys__Virt_list_all_node_devices, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_secrets", XS_Sys__Virt_list_all_secrets, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::list_all_storage_pools", XS_Sys__Virt_list_all_storage_pools, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::num_of_networks", XS_Sys__Virt_num_of_networks, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_network_names", XS_Sys__Virt_list_network_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_networks", XS_Sys__Virt_num_of_defined_networks, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_network_names", XS_Sys__Virt_list_defined_network_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_storage_pools", XS_Sys__Virt_num_of_storage_pools, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_storage_pool_names", XS_Sys__Virt_list_storage_pool_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_storage_pools", XS_Sys__Virt_num_of_defined_storage_pools, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_storage_pool_names", XS_Sys__Virt_list_defined_storage_pool_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_node_devices", XS_Sys__Virt_num_of_node_devices, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::list_node_device_names", XS_Sys__Virt_list_node_device_names, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::num_of_interfaces", XS_Sys__Virt_num_of_interfaces, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_interface_names", XS_Sys__Virt_list_interface_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_defined_interfaces", XS_Sys__Virt_num_of_defined_interfaces, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_defined_interface_names", XS_Sys__Virt_list_defined_interface_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_secrets", XS_Sys__Virt_num_of_secrets, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_secret_uuids", XS_Sys__Virt_list_secret_uuids, file, "$$");
        (void)newXSproto_portable("Sys::Virt::num_of_nwfilters", XS_Sys__Virt_num_of_nwfilters, file, "$");
        (void)newXSproto_portable("Sys::Virt::list_nwfilter_names", XS_Sys__Virt_list_nwfilter_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::get_all_domain_stats", XS_Sys__Virt_get_all_domain_stats, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::domain_xml_from_native", XS_Sys__Virt_domain_xml_from_native, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::domain_xml_to_native", XS_Sys__Virt_domain_xml_to_native, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::domain_event_register", XS_Sys__Virt_domain_event_register, file, "$$");
        (void)newXSproto_portable("Sys::Virt::domain_event_deregister", XS_Sys__Virt_domain_event_deregister, file, "$");
        (void)newXSproto_portable("Sys::Virt::domain_event_register_any", XS_Sys__Virt_domain_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::domain_event_deregister_any", XS_Sys__Virt_domain_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::network_event_register_any", XS_Sys__Virt_network_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::network_event_deregister_any", XS_Sys__Virt_network_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::storage_pool_event_register_any", XS_Sys__Virt_storage_pool_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::storage_pool_event_deregister_any", XS_Sys__Virt_storage_pool_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::node_device_event_register_any", XS_Sys__Virt_node_device_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::node_device_event_deregister_any", XS_Sys__Virt_node_device_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::secret_event_register_any", XS_Sys__Virt_secret_event_register_any, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::secret_event_deregister_any", XS_Sys__Virt_secret_event_deregister_any, file, "$$");
        (void)newXSproto_portable("Sys::Virt::register_close_callback", XS_Sys__Virt_register_close_callback, file, "$$");
        (void)newXSproto_portable("Sys::Virt::unregister_close_callback", XS_Sys__Virt_unregister_close_callback, file, "$");
        (void)newXSproto_portable("Sys::Virt::interface_change_begin", XS_Sys__Virt_interface_change_begin, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::interface_change_commit", XS_Sys__Virt_interface_change_commit, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::interface_change_rollback", XS_Sys__Virt_interface_change_rollback, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DESTROY", XS_Sys__Virt_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::_create", XS_Sys__Virt__Domain__create, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_create_with_files", XS_Sys__Virt__Domain__create_with_files, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_define_xml", XS_Sys__Virt__Domain__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_id", XS_Sys__Virt__Domain__lookup_by_id, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_name", XS_Sys__Virt__Domain__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_uuid", XS_Sys__Virt__Domain__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::_lookup_by_uuid_string", XS_Sys__Virt__Domain__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_id", XS_Sys__Virt__Domain_get_id, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_uuid", XS_Sys__Virt__Domain_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_uuid_string", XS_Sys__Virt__Domain_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_name", XS_Sys__Virt__Domain_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_hostname", XS_Sys__Virt__Domain_get_hostname, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_metadata", XS_Sys__Virt__Domain_get_metadata, file, "$$;$$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_metadata", XS_Sys__Virt__Domain_set_metadata, file, "$$;$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_active", XS_Sys__Virt__Domain_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_persistent", XS_Sys__Virt__Domain_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::is_updated", XS_Sys__Virt__Domain_is_updated, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::suspend", XS_Sys__Virt__Domain_suspend, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::resume", XS_Sys__Virt__Domain_resume, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::pm_wakeup", XS_Sys__Virt__Domain_pm_wakeup, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::save", XS_Sys__Virt__Domain_save, file, "$;$$$$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save", XS_Sys__Virt__Domain_managed_save, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::has_managed_save_image", XS_Sys__Virt__Domain_has_managed_save_image, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save_remove", XS_Sys__Virt__Domain_managed_save_remove, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save_define_xml", XS_Sys__Virt__Domain_managed_save_define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::managed_save_get_xml_description", XS_Sys__Virt__Domain_managed_save_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::core_dump", XS_Sys__Virt__Domain_core_dump, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::core_dump_format", XS_Sys__Virt__Domain_core_dump_format, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_info", XS_Sys__Virt__Domain_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_time", XS_Sys__Virt__Domain_get_time, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_time", XS_Sys__Virt__Domain_set_time, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_user_password", XS_Sys__Virt__Domain_set_user_password, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::rename", XS_Sys__Virt__Domain_rename, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_control_info", XS_Sys__Virt__Domain_get_control_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_state", XS_Sys__Virt__Domain_get_state, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_console", XS_Sys__Virt__Domain_open_console, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_channel", XS_Sys__Virt__Domain_open_channel, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_graphics", XS_Sys__Virt__Domain_open_graphics, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::open_graphics_fd", XS_Sys__Virt__Domain_open_graphics_fd, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::screenshot", XS_Sys__Virt__Domain_screenshot, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_info", XS_Sys__Virt__Domain_get_block_info, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_job_info", XS_Sys__Virt__Domain_get_job_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_job_stats", XS_Sys__Virt__Domain_get_job_stats, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::abort_job", XS_Sys__Virt__Domain_abort_job, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::abort_block_job", XS_Sys__Virt__Domain_abort_block_job, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_job_info", XS_Sys__Virt__Domain_get_block_job_info, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_job_speed", XS_Sys__Virt__Domain_set_block_job_speed, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_pull", XS_Sys__Virt__Domain_block_pull, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_rebase", XS_Sys__Virt__Domain_block_rebase, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_copy", XS_Sys__Virt__Domain_block_copy, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_commit", XS_Sys__Virt__Domain_block_commit, file, "$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_disk_errors", XS_Sys__Virt__Domain_get_disk_errors, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_scheduler_parameters", XS_Sys__Virt__Domain_get_scheduler_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_scheduler_parameters", XS_Sys__Virt__Domain_set_scheduler_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_memory_parameters", XS_Sys__Virt__Domain_get_memory_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory_parameters", XS_Sys__Virt__Domain_set_memory_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_numa_parameters", XS_Sys__Virt__Domain_get_numa_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_numa_parameters", XS_Sys__Virt__Domain_set_numa_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_blkio_parameters", XS_Sys__Virt__Domain_get_blkio_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_blkio_parameters", XS_Sys__Virt__Domain_set_blkio_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_perf_events", XS_Sys__Virt__Domain_get_perf_events, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_perf_events", XS_Sys__Virt__Domain_set_perf_events, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_launch_security_info", XS_Sys__Virt__Domain_get_launch_security_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_launch_security_state", XS_Sys__Virt__Domain_set_launch_security_state, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_guest_info", XS_Sys__Virt__Domain_get_guest_info, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_max_memory", XS_Sys__Virt__Domain_get_max_memory, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_max_memory", XS_Sys__Virt__Domain_set_max_memory, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory", XS_Sys__Virt__Domain_set_memory, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_memory_stats_period", XS_Sys__Virt__Domain_set_memory_stats_period, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_max_vcpus", XS_Sys__Virt__Domain_get_max_vcpus, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_vcpus", XS_Sys__Virt__Domain_set_vcpus, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_vcpu", XS_Sys__Virt__Domain_set_vcpu, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_vcpus", XS_Sys__Virt__Domain_get_vcpus, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_guest_vcpus", XS_Sys__Virt__Domain_set_guest_vcpus, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_guest_vcpus", XS_Sys__Virt__Domain_get_guest_vcpus, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_autostart", XS_Sys__Virt__Domain_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_autostart", XS_Sys__Virt__Domain_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_scheduler_type", XS_Sys__Virt__Domain_get_scheduler_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_os_type", XS_Sys__Virt__Domain_get_os_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_xml_description", XS_Sys__Virt__Domain_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::shutdown", XS_Sys__Virt__Domain_shutdown, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::reboot", XS_Sys__Virt__Domain_reboot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pm_suspend_for_duration", XS_Sys__Virt__Domain_pm_suspend_for_duration, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::reset", XS_Sys__Virt__Domain_reset, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::inject_nmi", XS_Sys__Virt__Domain_inject_nmi, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::undefine", XS_Sys__Virt__Domain_undefine, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::create", XS_Sys__Virt__Domain_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::create_with_files", XS_Sys__Virt__Domain_create_with_files, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_migrate", XS_Sys__Virt__Domain__migrate, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::_migrate_to_uri", XS_Sys__Virt__Domain__migrate_to_uri, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_max_downtime", XS_Sys__Virt__Domain_migrate_set_max_downtime, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_get_max_downtime", XS_Sys__Virt__Domain_migrate_get_max_downtime, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_max_speed", XS_Sys__Virt__Domain_migrate_set_max_speed, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_get_max_speed", XS_Sys__Virt__Domain_migrate_get_max_speed, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_set_compression_cache", XS_Sys__Virt__Domain_migrate_set_compression_cache, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_get_compression_cache", XS_Sys__Virt__Domain_migrate_get_compression_cache, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::migrate_start_post_copy", XS_Sys__Virt__Domain_migrate_start_post_copy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::attach_device", XS_Sys__Virt__Domain_attach_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::detach_device", XS_Sys__Virt__Domain_detach_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::detach_device_alias", XS_Sys__Virt__Domain_detach_device_alias, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::update_device", XS_Sys__Virt__Domain_update_device, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_block_iotune", XS_Sys__Virt__Domain_get_block_iotune, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_iotune", XS_Sys__Virt__Domain_set_block_iotune, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_interface_parameters", XS_Sys__Virt__Domain_get_interface_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_interface_parameters", XS_Sys__Virt__Domain_set_interface_parameters, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_stats", XS_Sys__Virt__Domain_block_stats, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::interface_stats", XS_Sys__Virt__Domain_interface_stats, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Domain::memory_stats", XS_Sys__Virt__Domain_memory_stats, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::send_key", XS_Sys__Virt__Domain_send_key, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_resize", XS_Sys__Virt__Domain_block_resize, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::block_peek", XS_Sys__Virt__Domain_block_peek, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::memory_peek", XS_Sys__Virt__Domain_memory_peek, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_security_label", XS_Sys__Virt__Domain_get_security_label, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_security_label_list", XS_Sys__Virt__Domain_get_security_label_list, file, "$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_cpu_stats", XS_Sys__Virt__Domain_get_cpu_stats, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_vcpu_info", XS_Sys__Virt__Domain_get_vcpu_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pin_vcpu", XS_Sys__Virt__Domain_pin_vcpu, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pin_emulator", XS_Sys__Virt__Domain_pin_emulator, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_emulator_pin_info", XS_Sys__Virt__Domain_get_emulator_pin_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_iothread_info", XS_Sys__Virt__Domain_get_iothread_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::pin_iothread", XS_Sys__Virt__Domain_pin_iothread, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::add_iothread", XS_Sys__Virt__Domain_add_iothread, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::del_iothread", XS_Sys__Virt__Domain_del_iothread, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_iothread", XS_Sys__Virt__Domain_set_iothread, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::num_of_snapshots", XS_Sys__Virt__Domain_num_of_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::list_snapshot_names", XS_Sys__Virt__Domain_list_snapshot_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::list_all_snapshots", XS_Sys__Virt__Domain_list_all_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::list_all_checkpoints", XS_Sys__Virt__Domain_list_all_checkpoints, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::has_current_snapshot", XS_Sys__Virt__Domain_has_current_snapshot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::current_snapshot", XS_Sys__Virt__Domain_current_snapshot, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::fs_trim", XS_Sys__Virt__Domain_fs_trim, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::fs_freeze", XS_Sys__Virt__Domain_fs_freeze, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::fs_thaw", XS_Sys__Virt__Domain_fs_thaw, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_fs_info", XS_Sys__Virt__Domain_get_fs_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_interface_addresses", XS_Sys__Virt__Domain_get_interface_addresses, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::send_process_signal", XS_Sys__Virt__Domain_send_process_signal, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_block_threshold", XS_Sys__Virt__Domain_set_block_threshold, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_lifecycle_action", XS_Sys__Virt__Domain_set_lifecycle_action, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::set_agent_response_timeout", XS_Sys__Virt__Domain_set_agent_response_timeout, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::backup_begin", XS_Sys__Virt__Domain_backup_begin, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::backup_get_xml_description", XS_Sys__Virt__Domain_backup_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::authorized_ssh_keys_get", XS_Sys__Virt__Domain_authorized_ssh_keys_get, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::authorized_ssh_keys_set", XS_Sys__Virt__Domain_authorized_ssh_keys_set, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::get_messages", XS_Sys__Virt__Domain_get_messages, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::start_dirty_rate_calc", XS_Sys__Virt__Domain_start_dirty_rate_calc, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::fd_associate", XS_Sys__Virt__Domain_fd_associate, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::destroy", XS_Sys__Virt__Domain_destroy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Domain::DESTROY", XS_Sys__Virt__Domain_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::_create_xml", XS_Sys__Virt__Network__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Network::_define_xml", XS_Sys__Virt__Network__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_name", XS_Sys__Virt__Network__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_uuid", XS_Sys__Virt__Network__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::_lookup_by_uuid_string", XS_Sys__Virt__Network__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::get_uuid", XS_Sys__Virt__Network_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_uuid_string", XS_Sys__Virt__Network_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_name", XS_Sys__Virt__Network_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::is_active", XS_Sys__Virt__Network_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::is_persistent", XS_Sys__Virt__Network_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_bridge_name", XS_Sys__Virt__Network_get_bridge_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_xml_description", XS_Sys__Virt__Network_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Network::undefine", XS_Sys__Virt__Network_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::create", XS_Sys__Virt__Network_create, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::update", XS_Sys__Virt__Network_update, file, "$$$$$;$");
        (void)newXSproto_portable("Sys::Virt::Network::set_autostart", XS_Sys__Virt__Network_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Network::get_autostart", XS_Sys__Virt__Network_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::get_dhcp_leases", XS_Sys__Virt__Network_get_dhcp_leases, file, "$;$$");
        (void)newXSproto_portable("Sys::Virt::Network::list_all_ports", XS_Sys__Virt__Network_list_all_ports, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Network::destroy", XS_Sys__Virt__Network_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::Network::DESTROY", XS_Sys__Virt__Network_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::_create_xml", XS_Sys__Virt__NetworkPort__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::_lookup_by_uuid", XS_Sys__Virt__NetworkPort__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::_lookup_by_uuid_string", XS_Sys__Virt__NetworkPort__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::get_uuid", XS_Sys__Virt__NetworkPort_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::get_uuid_string", XS_Sys__Virt__NetworkPort_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::get_xml_description", XS_Sys__Virt__NetworkPort_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::get_parameters", XS_Sys__Virt__NetworkPort_get_parameters, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::set_parameters", XS_Sys__Virt__NetworkPort_set_parameters, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::delete", XS_Sys__Virt__NetworkPort_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NetworkPort::DESTROY", XS_Sys__Virt__NetworkPort_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_create_xml", XS_Sys__Virt__StoragePool__create_xml, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_define_xml", XS_Sys__Virt__StoragePool__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_name", XS_Sys__Virt__StoragePool__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_uuid", XS_Sys__Virt__StoragePool__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_uuid_string", XS_Sys__Virt__StoragePool__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_volume", XS_Sys__Virt__StoragePool__lookup_by_volume, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::_lookup_by_target_path", XS_Sys__Virt__StoragePool__lookup_by_target_path, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_uuid", XS_Sys__Virt__StoragePool_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_uuid_string", XS_Sys__Virt__StoragePool_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_name", XS_Sys__Virt__StoragePool_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::is_active", XS_Sys__Virt__StoragePool_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::is_persistent", XS_Sys__Virt__StoragePool_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_xml_description", XS_Sys__Virt__StoragePool_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::undefine", XS_Sys__Virt__StoragePool_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::create", XS_Sys__Virt__StoragePool_create, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::refresh", XS_Sys__Virt__StoragePool_refresh, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::build", XS_Sys__Virt__StoragePool_build, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::delete", XS_Sys__Virt__StoragePool_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::set_autostart", XS_Sys__Virt__StoragePool_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_autostart", XS_Sys__Virt__StoragePool_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::get_info", XS_Sys__Virt__StoragePool_get_info, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::destroy", XS_Sys__Virt__StoragePool_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::num_of_storage_volumes", XS_Sys__Virt__StoragePool_num_of_storage_volumes, file, "$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::list_storage_vol_names", XS_Sys__Virt__StoragePool_list_storage_vol_names, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::list_all_volumes", XS_Sys__Virt__StoragePool_list_all_volumes, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StoragePool::DESTROY", XS_Sys__Virt__StoragePool_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_create_xml", XS_Sys__Virt__StorageVol__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_create_xml_from", XS_Sys__Virt__StorageVol__create_xml_from, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_name", XS_Sys__Virt__StorageVol__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_key", XS_Sys__Virt__StorageVol__lookup_by_key, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::_lookup_by_path", XS_Sys__Virt__StorageVol__lookup_by_path, file, "$$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_name", XS_Sys__Virt__StorageVol_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_key", XS_Sys__Virt__StorageVol_get_key, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_path", XS_Sys__Virt__StorageVol_get_path, file, "$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::resize", XS_Sys__Virt__StorageVol_resize, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_xml_description", XS_Sys__Virt__StorageVol_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::delete", XS_Sys__Virt__StorageVol_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::wipe", XS_Sys__Virt__StorageVol_wipe, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::wipe_pattern", XS_Sys__Virt__StorageVol_wipe_pattern, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::get_info", XS_Sys__Virt__StorageVol_get_info, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::download", XS_Sys__Virt__StorageVol_download, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::upload", XS_Sys__Virt__StorageVol_upload, file, "$$$$;$");
        (void)newXSproto_portable("Sys::Virt::StorageVol::DESTROY", XS_Sys__Virt__StorageVol_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_create_xml", XS_Sys__Virt__NodeDevice__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_define_xml", XS_Sys__Virt__NodeDevice__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_lookup_by_name", XS_Sys__Virt__NodeDevice__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::_lookup_scsihost_by_wwn", XS_Sys__Virt__NodeDevice__lookup_scsihost_by_wwn, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_name", XS_Sys__Virt__NodeDevice_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_parent", XS_Sys__Virt__NodeDevice_get_parent, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_xml_description", XS_Sys__Virt__NodeDevice_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::dettach", XS_Sys__Virt__NodeDevice_dettach, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::reattach", XS_Sys__Virt__NodeDevice_reattach, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::reset", XS_Sys__Virt__NodeDevice_reset, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::create", XS_Sys__Virt__NodeDevice_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::undefine", XS_Sys__Virt__NodeDevice_undefine, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::list_capabilities", XS_Sys__Virt__NodeDevice_list_capabilities, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::set_autostart", XS_Sys__Virt__NodeDevice_set_autostart, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::get_autostart", XS_Sys__Virt__NodeDevice_get_autostart, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::is_active", XS_Sys__Virt__NodeDevice_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::is_persistent", XS_Sys__Virt__NodeDevice_is_persistent, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::destroy", XS_Sys__Virt__NodeDevice_destroy, file, "$");
        (void)newXSproto_portable("Sys::Virt::NodeDevice::DESTROY", XS_Sys__Virt__NodeDevice_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::_define_xml", XS_Sys__Virt__Interface__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::_lookup_by_name", XS_Sys__Virt__Interface__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Interface::_lookup_by_mac", XS_Sys__Virt__Interface__lookup_by_mac, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_mac", XS_Sys__Virt__Interface_get_mac, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_name", XS_Sys__Virt__Interface_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::is_active", XS_Sys__Virt__Interface_is_active, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::get_xml_description", XS_Sys__Virt__Interface_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::undefine", XS_Sys__Virt__Interface_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Interface::create", XS_Sys__Virt__Interface_create, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::destroy", XS_Sys__Virt__Interface_destroy, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Interface::DESTROY", XS_Sys__Virt__Interface_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::_define_xml", XS_Sys__Virt__Secret__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_usage", XS_Sys__Virt__Secret__lookup_by_usage, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_uuid", XS_Sys__Virt__Secret__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Secret::_lookup_by_uuid_string", XS_Sys__Virt__Secret__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_uuid", XS_Sys__Virt__Secret_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_uuid_string", XS_Sys__Virt__Secret_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_usage_id", XS_Sys__Virt__Secret_get_usage_id, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_usage_type", XS_Sys__Virt__Secret_get_usage_type, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_xml_description", XS_Sys__Virt__Secret_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::undefine", XS_Sys__Virt__Secret_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::Secret::set_value", XS_Sys__Virt__Secret_set_value, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::get_value", XS_Sys__Virt__Secret_get_value, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Secret::DESTROY", XS_Sys__Virt__Secret_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_define_xml", XS_Sys__Virt__NWFilter__define_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_name", XS_Sys__Virt__NWFilter__lookup_by_name, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_uuid", XS_Sys__Virt__NWFilter__lookup_by_uuid, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::_lookup_by_uuid_string", XS_Sys__Virt__NWFilter__lookup_by_uuid_string, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_uuid", XS_Sys__Virt__NWFilter_get_uuid, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_uuid_string", XS_Sys__Virt__NWFilter_get_uuid_string, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_name", XS_Sys__Virt__NWFilter_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::get_xml_description", XS_Sys__Virt__NWFilter_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::undefine", XS_Sys__Virt__NWFilter_undefine, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilter::DESTROY", XS_Sys__Virt__NWFilter_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::_create_xml", XS_Sys__Virt__NWFilterBinding__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::_lookup_by_port_dev", XS_Sys__Virt__NWFilterBinding__lookup_by_port_dev, file, "$$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::get_port_dev", XS_Sys__Virt__NWFilterBinding_get_port_dev, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::get_filter_name", XS_Sys__Virt__NWFilterBinding_get_filter_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::get_xml_description", XS_Sys__Virt__NWFilterBinding_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::delete", XS_Sys__Virt__NWFilterBinding_delete, file, "$");
        (void)newXSproto_portable("Sys::Virt::NWFilterBinding::DESTROY", XS_Sys__Virt__NWFilterBinding_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::_create_xml", XS_Sys__Virt__DomainSnapshot__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::_lookup_by_name", XS_Sys__Virt__DomainSnapshot__lookup_by_name, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_name", XS_Sys__Virt__DomainSnapshot_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_xml_description", XS_Sys__Virt__DomainSnapshot_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::revert_to", XS_Sys__Virt__DomainSnapshot_revert_to, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::delete", XS_Sys__Virt__DomainSnapshot_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::get_parent", XS_Sys__Virt__DomainSnapshot_get_parent, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::num_of_child_snapshots", XS_Sys__Virt__DomainSnapshot_num_of_child_snapshots, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::is_current", XS_Sys__Virt__DomainSnapshot_is_current, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::has_metadata", XS_Sys__Virt__DomainSnapshot_has_metadata, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::list_child_snapshot_names", XS_Sys__Virt__DomainSnapshot_list_child_snapshot_names, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::list_all_children", XS_Sys__Virt__DomainSnapshot_list_all_children, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainSnapshot::DESTROY", XS_Sys__Virt__DomainSnapshot_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::_create_xml", XS_Sys__Virt__DomainCheckpoint__create_xml, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::_lookup_by_name", XS_Sys__Virt__DomainCheckpoint__lookup_by_name, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::get_name", XS_Sys__Virt__DomainCheckpoint_get_name, file, "$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::get_xml_description", XS_Sys__Virt__DomainCheckpoint_get_xml_description, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::delete", XS_Sys__Virt__DomainCheckpoint_delete, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::get_parent", XS_Sys__Virt__DomainCheckpoint_get_parent, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::list_all_children", XS_Sys__Virt__DomainCheckpoint_list_all_children, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::DomainCheckpoint::DESTROY", XS_Sys__Virt__DomainCheckpoint_DESTROY, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::_register_impl", XS_Sys__Virt__Event__register_impl, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::register_default", XS_Sys__Virt__Event_register_default, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::run_default", XS_Sys__Virt__Event_run_default, file, "");
        (void)newXSproto_portable("Sys::Virt::Event::add_handle", XS_Sys__Virt__Event_add_handle, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Event::update_handle", XS_Sys__Virt__Event_update_handle, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::remove_handle", XS_Sys__Virt__Event_remove_handle, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::add_timeout", XS_Sys__Virt__Event_add_timeout, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::update_timeout", XS_Sys__Virt__Event_update_timeout, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Event::remove_timeout", XS_Sys__Virt__Event_remove_timeout, file, "$");
        (void)newXSproto_portable("Sys::Virt::Event::_run_handle_callback_helper", XS_Sys__Virt__Event__run_handle_callback_helper, file, "$$$$$");
        (void)newXSproto_portable("Sys::Virt::Event::_run_timeout_callback_helper", XS_Sys__Virt__Event__run_timeout_callback_helper, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Event::_free_callback_opaque_helper", XS_Sys__Virt__Event__free_callback_opaque_helper, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::_new_obj", XS_Sys__Virt__Stream__new_obj, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Stream::send", XS_Sys__Virt__Stream_send, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv", XS_Sys__Virt__Stream_recv, file, "$$$;$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv_hole", XS_Sys__Virt__Stream_recv_hole, file, "$;$");
        (void)newXSproto_portable("Sys::Virt::Stream::send_hole", XS_Sys__Virt__Stream_send_hole, file, "$$;$");
        (void)newXSproto_portable("Sys::Virt::Stream::send_all", XS_Sys__Virt__Stream_send_all, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::recv_all", XS_Sys__Virt__Stream_recv_all, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::sparse_recv_all", XS_Sys__Virt__Stream_sparse_recv_all, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::sparse_send_all", XS_Sys__Virt__Stream_sparse_send_all, file, "$$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::add_callback", XS_Sys__Virt__Stream_add_callback, file, "$$$");
        (void)newXSproto_portable("Sys::Virt::Stream::update_callback", XS_Sys__Virt__Stream_update_callback, file, "$$");
        (void)newXSproto_portable("Sys::Virt::Stream::remove_callback", XS_Sys__Virt__Stream_remove_callback, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::finish", XS_Sys__Virt__Stream_finish, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::abort", XS_Sys__Virt__Stream_abort, file, "$");
        (void)newXSproto_portable("Sys::Virt::Stream::DESTROY", XS_Sys__Virt__Stream_DESTROY, file, "$");

    /* Initialisation Section */

#line 9527 "lib/Sys/Virt.xs"
{
    HV *stash;

    virSetErrorFunc(NULL, ignoreVirErrorFunc);
    virInitialize();

    stash = gv_stashpv( "Sys::Virt", TRUE );

    REGISTER_CONSTANT(VIR_CONNECT_RO, CONNECT_RO);
    REGISTER_CONSTANT(VIR_CONNECT_NO_ALIASES, CONNECT_NO_ALIASES);

    REGISTER_CONSTANT(VIR_CRED_USERNAME, CRED_USERNAME);
    REGISTER_CONSTANT(VIR_CRED_AUTHNAME, CRED_AUTHNAME);
    REGISTER_CONSTANT(VIR_CRED_LANGUAGE, CRED_LANGUAGE);
    REGISTER_CONSTANT(VIR_CRED_CNONCE, CRED_CNONCE);
    REGISTER_CONSTANT(VIR_CRED_PASSPHRASE, CRED_PASSPHRASE);
    REGISTER_CONSTANT(VIR_CRED_ECHOPROMPT, CRED_ECHOPROMPT);
    REGISTER_CONSTANT(VIR_CRED_NOECHOPROMPT, CRED_NOECHOPROMPT);
    REGISTER_CONSTANT(VIR_CRED_REALM, CRED_REALM);
    REGISTER_CONSTANT(VIR_CRED_EXTERNAL, CRED_EXTERNAL);

    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_USER_NAME, IDENTITY_USER_NAME);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_UNIX_USER_ID, IDENTITY_UNIX_USER_ID);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_GROUP_NAME, IDENTITY_GROUP_NAME);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_UNIX_GROUP_ID, IDENTITY_UNIX_GROUP_ID);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_PROCESS_ID, IDENTITY_PROCESS_ID);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_PROCESS_TIME, IDENTITY_PROCESS_TIME);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_SASL_USER_NAME, IDENTITY_SASL_USER_NAME);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_X509_DISTINGUISHED_NAME, IDENTITY_X509_DISTINGUISHED_NAME);
    REGISTER_CONSTANT_STR(VIR_CONNECT_IDENTITY_SELINUX_CONTEXT, IDENTITY_SELINUX_CONTEXT);

    /* Don't bother with VIR_CPU_COMPARE_ERROR since we die in that case */
    REGISTER_CONSTANT(VIR_CPU_COMPARE_INCOMPATIBLE, CPU_COMPARE_INCOMPATIBLE);
    REGISTER_CONSTANT(VIR_CPU_COMPARE_IDENTICAL, CPU_COMPARE_IDENTICAL);
    REGISTER_CONSTANT(VIR_CPU_COMPARE_SUPERSET, CPU_COMPARE_SUPERSET);


    REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_MEM, NODE_SUSPEND_TARGET_MEM);
    REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_DISK, NODE_SUSPEND_TARGET_DISK);
    REGISTER_CONSTANT(VIR_NODE_SUSPEND_TARGET_HYBRID, NODE_SUSPEND_TARGET_HYBRID);


    REGISTER_CONSTANT(VIR_NODE_CPU_STATS_ALL_CPUS, NODE_CPU_STATS_ALL_CPUS);
    REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_IDLE, NODE_CPU_STATS_IDLE);
    REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_IOWAIT, NODE_CPU_STATS_IOWAIT);
    REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_KERNEL, NODE_CPU_STATS_KERNEL);
    REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_USER, NODE_CPU_STATS_USER);
    REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_INTR, NODE_CPU_STATS_INTR);
    REGISTER_CONSTANT_STR(VIR_NODE_CPU_STATS_UTILIZATION, NODE_CPU_STATS_UTILIZATION);

    REGISTER_CONSTANT(VIR_NODE_MEMORY_STATS_ALL_CELLS, NODE_MEMORY_STATS_ALL_CELLS);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_BUFFERS, NODE_MEMORY_STATS_BUFFERS);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_CACHED, NODE_MEMORY_STATS_CACHED);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_FREE, NODE_MEMORY_STATS_FREE);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_STATS_TOTAL, NODE_MEMORY_STATS_TOTAL);

    REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_CLIENT, CLOSE_REASON_CLIENT);
    REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_EOF, CLOSE_REASON_EOF);
    REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_ERROR, CLOSE_REASON_ERROR);
    REGISTER_CONSTANT(VIR_CONNECT_CLOSE_REASON_KEEPALIVE, CLOSE_REASON_KEEPALIVE);

    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_TO_SCAN, NODE_MEMORY_SHARED_PAGES_TO_SCAN);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_SLEEP_MILLISECS, NODE_MEMORY_SHARED_SLEEP_MILLISECS);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_SHARED, NODE_MEMORY_SHARED_PAGES_SHARED);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_SHARING, NODE_MEMORY_SHARED_PAGES_SHARING);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_UNSHARED, NODE_MEMORY_SHARED_PAGES_UNSHARED);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_PAGES_VOLATILE, NODE_MEMORY_SHARED_PAGES_VOLATILE);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_FULL_SCANS, NODE_MEMORY_SHARED_FULL_SCANS);
    REGISTER_CONSTANT_STR(VIR_NODE_MEMORY_SHARED_MERGE_ACROSS_NODES, NODE_MEMORY_SHARED_MERGE_ACROSS_NODES);

    REGISTER_CONSTANT(VIR_CONNECT_BASELINE_CPU_EXPAND_FEATURES, BASELINE_CPU_EXPAND_FEATURES);
    REGISTER_CONSTANT(VIR_CONNECT_BASELINE_CPU_MIGRATABLE, BASELINE_CPU_MIGRATABLE);

    REGISTER_CONSTANT(VIR_CONNECT_COMPARE_CPU_FAIL_INCOMPATIBLE, COMPARE_CPU_FAIL_INCOMPATIBLE);
    REGISTER_CONSTANT(VIR_CONNECT_COMPARE_CPU_VALIDATE_XML, COMPARE_CPU_VALIDATE_XML);

    REGISTER_CONSTANT(VIR_IP_ADDR_TYPE_IPV4, IP_ADDR_TYPE_IPV4);
    REGISTER_CONSTANT(VIR_IP_ADDR_TYPE_IPV6, IP_ADDR_TYPE_IPV6);

    REGISTER_CONSTANT(VIR_NODE_ALLOC_PAGES_ADD, NODE_ALLOC_PAGES_ADD);
    REGISTER_CONSTANT(VIR_NODE_ALLOC_PAGES_SET, NODE_ALLOC_PAGES_SET);


    REGISTER_CONSTANT_STR(VIR_NODE_SEV_CBITPOS, SEV_CBITPOS);
    REGISTER_CONSTANT_STR(VIR_NODE_SEV_CERT_CHAIN, SEV_CERT_CHAIN);
    REGISTER_CONSTANT_STR(VIR_NODE_SEV_PDH, SEV_PDH);
    REGISTER_CONSTANT_STR(VIR_NODE_SEV_REDUCED_PHYS_BITS, SEV_REDUCED_PHYS_BITS);
    REGISTER_CONSTANT_STR(VIR_NODE_SEV_MAX_GUESTS, SEV_MAX_GUESTS);
    REGISTER_CONSTANT_STR(VIR_NODE_SEV_MAX_ES_GUESTS, SEV_MAX_ES_GUESTS);
    REGISTER_CONSTANT_STR(VIR_NODE_SEV_CPU0_ID, SEV_CPU0_ID);

    stash = gv_stashpv( "Sys::Virt::Event", TRUE );

    REGISTER_CONSTANT(VIR_EVENT_HANDLE_READABLE, HANDLE_READABLE);
    REGISTER_CONSTANT(VIR_EVENT_HANDLE_WRITABLE, HANDLE_WRITABLE);
    REGISTER_CONSTANT(VIR_EVENT_HANDLE_ERROR, HANDLE_ERROR);
    REGISTER_CONSTANT(VIR_EVENT_HANDLE_HANGUP, HANDLE_HANGUP);


    stash = gv_stashpv( "Sys::Virt::Domain", TRUE );
    REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE, STATE_NOSTATE);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING, STATE_RUNNING);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED, STATE_BLOCKED);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED, STATE_PAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN, STATE_SHUTDOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF, STATE_SHUTOFF);
    REGISTER_CONSTANT(VIR_DOMAIN_CRASHED, STATE_CRASHED);
    REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED, STATE_PMSUSPENDED);

    REGISTER_CONSTANT(VIR_DUMP_CRASH, DUMP_CRASH);
    REGISTER_CONSTANT(VIR_DUMP_LIVE, DUMP_LIVE);
    REGISTER_CONSTANT(VIR_DUMP_BYPASS_CACHE, DUMP_BYPASS_CACHE);
    REGISTER_CONSTANT(VIR_DUMP_RESET, DUMP_RESET);
    REGISTER_CONSTANT(VIR_DUMP_MEMORY_ONLY, DUMP_MEMORY_ONLY);

    REGISTER_CONSTANT(VIR_DOMAIN_SAVE_BYPASS_CACHE, SAVE_BYPASS_CACHE);
    REGISTER_CONSTANT(VIR_DOMAIN_SAVE_RUNNING, SAVE_RUNNING);
    REGISTER_CONSTANT(VIR_DOMAIN_SAVE_PAUSED, SAVE_PAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_SAVE_RESET_NVRAM, SAVE_RESET_NVRAM);

    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_MANAGED_SAVE, UNDEFINE_MANAGED_SAVE);
    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_SNAPSHOTS_METADATA, UNDEFINE_SNAPSHOTS_METADATA);
    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_NVRAM, UNDEFINE_NVRAM);
    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_KEEP_NVRAM, UNDEFINE_KEEP_NVRAM);
    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_CHECKPOINTS_METADATA, UNDEFINE_CHECKPOINTS_METADATA);
    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_TPM, UNDEFINE_TPM);
    REGISTER_CONSTANT(VIR_DOMAIN_UNDEFINE_KEEP_TPM, UNDEFINE_KEEP_TPM);

    REGISTER_CONSTANT(VIR_DOMAIN_START_PAUSED, START_PAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_START_AUTODESTROY, START_AUTODESTROY);
    REGISTER_CONSTANT(VIR_DOMAIN_START_BYPASS_CACHE, START_BYPASS_CACHE);
    REGISTER_CONSTANT(VIR_DOMAIN_START_FORCE_BOOT, START_FORCE_BOOT);
    REGISTER_CONSTANT(VIR_DOMAIN_START_VALIDATE, START_VALIDATE);
    REGISTER_CONSTANT(VIR_DOMAIN_START_RESET_NVRAM, START_RESET_NVRAM);

    REGISTER_CONSTANT(VIR_DOMAIN_DEFINE_VALIDATE, DEFINE_VALIDATE);

    REGISTER_CONSTANT(VIR_DOMAIN_NOSTATE_UNKNOWN, STATE_NOSTATE_UNKNOWN);

    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_UNKNOWN, STATE_RUNNING_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_BOOTED, STATE_RUNNING_BOOTED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_MIGRATED, STATE_RUNNING_MIGRATED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_RESTORED, STATE_RUNNING_RESTORED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_FROM_SNAPSHOT, STATE_RUNNING_FROM_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_UNPAUSED, STATE_RUNNING_UNPAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_MIGRATION_CANCELED, STATE_RUNNING_MIGRATION_CANCELED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_SAVE_CANCELED, STATE_RUNNING_SAVE_CANCELED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_WAKEUP, STATE_RUNNING_WAKEUP);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_CRASHED, STATE_RUNNING_CRASHED);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_POSTCOPY, STATE_RUNNING_POSTCOPY);
    REGISTER_CONSTANT(VIR_DOMAIN_RUNNING_POSTCOPY_FAILED, STATE_RUNNING_POSTCOPY_FAILED);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCKED_UNKNOWN, STATE_BLOCKED_UNKNOWN);

    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_UNKNOWN, STATE_PAUSED_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_USER, STATE_PAUSED_USER);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_MIGRATION, STATE_PAUSED_MIGRATION);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SAVE, STATE_PAUSED_SAVE);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_DUMP, STATE_PAUSED_DUMP);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_IOERROR, STATE_PAUSED_IOERROR);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_WATCHDOG, STATE_PAUSED_WATCHDOG);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_FROM_SNAPSHOT, STATE_PAUSED_FROM_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SHUTTING_DOWN, STATE_PAUSED_SHUTTING_DOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_SNAPSHOT, STATE_PAUSED_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_CRASHED, STATE_PAUSED_CRASHED);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_STARTING_UP, STATE_PAUSED_STARTING_UP);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_POSTCOPY, STATE_PAUSED_POSTCOPY);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_POSTCOPY_FAILED, STATE_PAUSED_POSTCOPY_FAILED);
    REGISTER_CONSTANT(VIR_DOMAIN_PAUSED_API_ERROR, STATE_PAUSED_API_ERROR);

    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_UNKNOWN, STATE_SHUTDOWN_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_USER, STATE_SHUTDOWN_USER);

    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_UNKNOWN, STATE_SHUTOFF_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_SHUTDOWN, STATE_SHUTOFF_SHUTDOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_DESTROYED, STATE_SHUTOFF_DESTROYED);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_CRASHED, STATE_SHUTOFF_CRASHED);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_MIGRATED, STATE_SHUTOFF_MIGRATED);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_SAVED, STATE_SHUTOFF_SAVED);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_FAILED, STATE_SHUTOFF_FAILED);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_FROM_SNAPSHOT, STATE_SHUTOFF_FROM_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTOFF_DAEMON, STATE_SHUTOFF_DAEMON);

    REGISTER_CONSTANT(VIR_DOMAIN_CRASHED_UNKNOWN, STATE_CRASHED_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_CRASHED_PANICKED, STATE_CRASHED_PANICKED);

    REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED_UNKNOWN, STATE_PMSUSPENDED_UNKNOWN);

    REGISTER_CONSTANT(VIR_DOMAIN_PMSUSPENDED_DISK_UNKNOWN, STATE_PMSUSPENDED_DISK_UNKNOWN);

    REGISTER_CONSTANT(VIR_DOMAIN_OPEN_GRAPHICS_SKIPAUTH, OPEN_GRAPHICS_SKIPAUTH);

    REGISTER_CONSTANT(VIR_DOMAIN_CONSOLE_FORCE, OPEN_CONSOLE_FORCE);
    REGISTER_CONSTANT(VIR_DOMAIN_CONSOLE_SAFE, OPEN_CONSOLE_SAFE);

    REGISTER_CONSTANT(VIR_DOMAIN_CHANNEL_FORCE, OPEN_CHANNEL_FORCE);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_EMULATOR_PERIOD, SCHEDULER_EMULATOR_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_EMULATOR_QUOTA, SCHEDULER_EMULATOR_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_IOTHREAD_PERIOD, SCHEDULER_IOTHREAD_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_IOTHREAD_QUOTA, SCHEDULER_IOTHREAD_QUOTA);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_CPUTIME, CPU_STATS_CPUTIME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_SYSTEMTIME, CPU_STATS_SYSTEMTIME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_USERTIME, CPU_STATS_USERTIME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_CPU_STATS_VCPUTIME, CPU_STATS_VCPUTIME);


    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_ERRS, BLOCK_STATS_ERRS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_FLUSH_REQ, BLOCK_STATS_FLUSH_REQ);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_FLUSH_TOTAL_TIMES, BLOCK_STATS_FLUSH_TOTAL_TIMES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_READ_BYTES, BLOCK_STATS_READ_BYTES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_READ_REQ, BLOCK_STATS_READ_REQ);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_READ_TOTAL_TIMES, BLOCK_STATS_READ_TOTAL_TIMES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_WRITE_BYTES, BLOCK_STATS_WRITE_BYTES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_WRITE_REQ, BLOCK_STATS_WRITE_REQ);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_STATS_WRITE_TOTAL_TIMES, BLOCK_STATS_WRITE_TOTAL_TIMES);

    REGISTER_CONSTANT(VIR_MIGRATE_LIVE, MIGRATE_LIVE);
    REGISTER_CONSTANT(VIR_MIGRATE_PEER2PEER, MIGRATE_PEER2PEER);
    REGISTER_CONSTANT(VIR_MIGRATE_TUNNELLED, MIGRATE_TUNNELLED);
    REGISTER_CONSTANT(VIR_MIGRATE_PERSIST_DEST, MIGRATE_PERSIST_DEST);
    REGISTER_CONSTANT(VIR_MIGRATE_UNDEFINE_SOURCE, MIGRATE_UNDEFINE_SOURCE);
    REGISTER_CONSTANT(VIR_MIGRATE_PAUSED, MIGRATE_PAUSED);
    REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_DISK, MIGRATE_NON_SHARED_DISK);
    REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_INC, MIGRATE_NON_SHARED_INC);
    REGISTER_CONSTANT(VIR_MIGRATE_CHANGE_PROTECTION, MIGRATE_CHANGE_PROTECTION);
    REGISTER_CONSTANT(VIR_MIGRATE_UNSAFE, MIGRATE_UNSAFE);
    REGISTER_CONSTANT(VIR_MIGRATE_OFFLINE, MIGRATE_OFFLINE);
    REGISTER_CONSTANT(VIR_MIGRATE_COMPRESSED, MIGRATE_COMPRESSED);
    REGISTER_CONSTANT(VIR_MIGRATE_ABORT_ON_ERROR, MIGRATE_ABORT_ON_ERROR);
    REGISTER_CONSTANT(VIR_MIGRATE_AUTO_CONVERGE, MIGRATE_AUTO_CONVERGE);
    REGISTER_CONSTANT(VIR_MIGRATE_RDMA_PIN_ALL, MIGRATE_RDMA_PIN_ALL);
    REGISTER_CONSTANT(VIR_MIGRATE_POSTCOPY, MIGRATE_POSTCOPY);
    REGISTER_CONSTANT(VIR_MIGRATE_TLS, MIGRATE_TLS);
    REGISTER_CONSTANT(VIR_MIGRATE_PARALLEL, MIGRATE_PARALLEL);
    REGISTER_CONSTANT(VIR_MIGRATE_NON_SHARED_SYNCHRONOUS_WRITES, MIGRATE_NON_SHARED_SYNCHRONOUS_WRITES);
    REGISTER_CONSTANT(VIR_MIGRATE_POSTCOPY_RESUME, MIGRATE_POSTCOPY_RESUME);
    REGISTER_CONSTANT(VIR_MIGRATE_ZEROCOPY, MIGRATE_ZEROCOPY);

    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_BANDWIDTH, MIGRATE_PARAM_BANDWIDTH);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_DEST_NAME, MIGRATE_PARAM_DEST_NAME);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_DEST_XML, MIGRATE_PARAM_DEST_XML);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_GRAPHICS_URI, MIGRATE_PARAM_GRAPHICS_URI);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_URI, MIGRATE_PARAM_URI);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_LISTEN_ADDRESS, MIGRATE_PARAM_LISTEN_ADDRESS);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_MIGRATE_DISKS, MIGRATE_PARAM_MIGRATE_DISKS);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_DISKS_PORT, MIGRATE_PARAM_DISK_PORT);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION, MIGRATE_PARAM_COMPRESSION);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION_MT_THREADS, MIGRATE_PARAM_COMPRESSION_MT_THREADS);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION_MT_DTHREADS, MIGRATE_PARAM_COMPRESSION_MT_DTHREADS);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION_MT_LEVEL, MIGRATE_PARAM_COMPRESSION_MT_LEVEL);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION_XBZRLE_CACHE, MIGRATE_PARAM_COMPRESSION_XBZRLE_CACHE);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_PERSIST_XML, MIGRATE_PARAM_PERSIST_XML);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_AUTO_CONVERGE_INITIAL, MIGRATE_PARAM_AUTO_CONVERGE_INITIAL);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_AUTO_CONVERGE_INCREMENT, MIGRATE_PARAM_AUTO_CONVERGE_INCREMENT);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_BANDWIDTH_POSTCOPY, MIGRATE_PARAM_BANDWIDTH_POSTCOPY);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_PARALLEL_CONNECTIONS, MIGRATE_PARAM_PARALLEL_CONNECTIONS);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_TLS_DESTINATION, MIGRATE_PARAM_TLS_DESTINATION);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_DISKS_URI, MIGRATE_PARAM_DISKS_URI);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION_ZLIB_LEVEL, MIGRATE_PARAM_ZLIB_LEVEL);
    REGISTER_CONSTANT_STR(VIR_MIGRATE_PARAM_COMPRESSION_ZSTD_LEVEL, MIGRATE_PARAM_ZSTD_LEVEL);

    REGISTER_CONSTANT(VIR_DOMAIN_MIGRATE_MAX_SPEED_POSTCOPY, MIGRATE_MAX_SPEED_POSTCOPY);

    REGISTER_CONSTANT(VIR_DOMAIN_XML_SECURE, XML_SECURE);
    REGISTER_CONSTANT(VIR_DOMAIN_XML_INACTIVE, XML_INACTIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_XML_UPDATE_CPU, XML_UPDATE_CPU);
    REGISTER_CONSTANT(VIR_DOMAIN_XML_MIGRATABLE, XML_MIGRATABLE);


    REGISTER_CONSTANT(VIR_MEMORY_VIRTUAL, MEMORY_VIRTUAL);
    REGISTER_CONSTANT(VIR_MEMORY_PHYSICAL, MEMORY_PHYSICAL);


    REGISTER_CONSTANT(VIR_VCPU_OFFLINE, VCPU_OFFLINE);
    REGISTER_CONSTANT(VIR_VCPU_RUNNING, VCPU_RUNNING);
    REGISTER_CONSTANT(VIR_VCPU_BLOCKED, VCPU_BLOCKED);

    REGISTER_CONSTANT(VIR_VCPU_INFO_CPU_OFFLINE, VCPU_INFO_CPU_OFFLINE);
    REGISTER_CONSTANT(VIR_VCPU_INFO_CPU_UNAVAILABLE, VCPU_INFO_CPU_UNAVAILABLE);


    REGISTER_CONSTANT(VIR_KEYCODE_SET_LINUX, KEYCODE_SET_LINUX);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_XT, KEYCODE_SET_XT);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET1, KEYCODE_SET_ATSET1);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET2, KEYCODE_SET_ATSET2);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_ATSET3, KEYCODE_SET_ATSET3);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_OSX, KEYCODE_SET_OSX);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_XT_KBD, KEYCODE_SET_XT_KBD);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_USB, KEYCODE_SET_USB);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_WIN32, KEYCODE_SET_WIN32);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_RFB, KEYCODE_SET_RFB);
    REGISTER_CONSTANT(VIR_KEYCODE_SET_QNUM, KEYCODE_SET_QNUM);

    REGISTER_CONSTANT(VIR_DOMAIN_STATS_BALLOON, STATS_BALLOON);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_BLOCK, STATS_BLOCK);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_CPU_TOTAL, STATS_CPU_TOTAL);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_INTERFACE, STATS_INTERFACE);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_STATE, STATS_STATE);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_VCPU, STATS_VCPU);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_PERF, STATS_PERF);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_IOTHREAD, STATS_IOTHREAD);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_MEMORY, STATS_MEMORY);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_DIRTYRATE, STATS_DIRTYRATE);
    REGISTER_CONSTANT(VIR_DOMAIN_STATS_VM, STATS_VM);

    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_ACTIVE, GET_ALL_STATS_ACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_INACTIVE, GET_ALL_STATS_INACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_OTHER, GET_ALL_STATS_OTHER);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_PAUSED, GET_ALL_STATS_PAUSED);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_PERSISTENT, GET_ALL_STATS_PERSISTENT);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_RUNNING, GET_ALL_STATS_RUNNING);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_SHUTOFF, GET_ALL_STATS_SHUTOFF);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_TRANSIENT, GET_ALL_STATS_TRANSIENT);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_NOWAIT, GET_ALL_STATS_NOWAIT);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_ENFORCE_STATS, GET_ALL_STATS_ENFORCE_STATS);
    REGISTER_CONSTANT(VIR_CONNECT_GET_ALL_DOMAINS_STATS_BACKING, GET_ALL_STATS_BACKING);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED, EVENT_DEFINED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED, EVENT_UNDEFINED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED, EVENT_STARTED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED, EVENT_SUSPENDED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED, EVENT_RESUMED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED, EVENT_STOPPED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN, EVENT_SHUTDOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_PMSUSPENDED, EVENT_PMSUSPENDED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_PMSUSPENDED_DISK, EVENT_PMSUSPENDED_DISK);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_CRASHED, EVENT_CRASHED);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_ADDED, EVENT_DEFINED_ADDED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_UPDATED, EVENT_DEFINED_UPDATED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_RENAMED, EVENT_DEFINED_RENAMED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DEFINED_FROM_SNAPSHOT, EVENT_DEFINED_FROM_SNAPSHOT);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED_REMOVED, EVENT_UNDEFINED_REMOVED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_UNDEFINED_RENAMED, EVENT_UNDEFINED_RENAMED);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_BOOTED, EVENT_STARTED_BOOTED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_MIGRATED, EVENT_STARTED_MIGRATED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_RESTORED, EVENT_STARTED_RESTORED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_FROM_SNAPSHOT, EVENT_STARTED_FROM_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STARTED_WAKEUP, EVENT_STARTED_WAKEUP);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_CRASHED_PANICKED, EVENT_CRASHED_PANICKED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_CRASHED_CRASHLOADED, EVENT_CRASHED_CRASHLOADED);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_PAUSED, EVENT_SUSPENDED_PAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_MIGRATED, EVENT_SUSPENDED_MIGRATED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_IOERROR, EVENT_SUSPENDED_IOERROR);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_WATCHDOG, EVENT_SUSPENDED_WATCHDOG);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_RESTORED, EVENT_SUSPENDED_RESTORED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_FROM_SNAPSHOT, EVENT_SUSPENDED_FROM_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_API_ERROR, EVENT_SUSPENDED_API_ERROR);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_POSTCOPY, EVENT_SUSPENDED_POSTCOPY);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SUSPENDED_POSTCOPY_FAILED, EVENT_SUSPENDED_POSTCOPY_FAILED);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_UNPAUSED, EVENT_RESUMED_UNPAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_MIGRATED, EVENT_RESUMED_MIGRATED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_FROM_SNAPSHOT, EVENT_RESUMED_FROM_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_POSTCOPY, EVENT_RESUMED_POSTCOPY);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_RESUMED_POSTCOPY_FAILED, EVENT_RESUMED_POSTCOPY_FAILED);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SHUTDOWN, EVENT_STOPPED_SHUTDOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_DESTROYED, EVENT_STOPPED_DESTROYED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_CRASHED, EVENT_STOPPED_CRASHED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_MIGRATED, EVENT_STOPPED_MIGRATED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_SAVED, EVENT_STOPPED_SAVED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FAILED, EVENT_STOPPED_FAILED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_STOPPED_FROM_SNAPSHOT, EVENT_STOPPED_FROM_SNAPSHOT);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN_FINISHED, EVENT_SHUTDOWN_FINISHED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN_HOST, EVENT_SHUTDOWN_HOST);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_SHUTDOWN_GUEST, EVENT_SHUTDOWN_GUEST);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_PMSUSPENDED_MEMORY, EVENT_PMSUSPENDED_MEMORY);


    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_OK, CONTROL_OK);
    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_JOB, CONTROL_JOB);
    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_OCCUPIED, CONTROL_OCCUPIED);
    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR, CONTROL_ERROR);

    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR_REASON_NONE, CONTROL_ERROR_REASON_NONE);
    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR_REASON_UNKNOWN, CONTROL_ERROR_REASON_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR_REASON_INTERNAL, CONTROL_ERROR_REASON_INTERNAL);
    REGISTER_CONSTANT(VIR_DOMAIN_CONTROL_ERROR_REASON_MONITOR, CONTROL_ERROR_REASON_MONITOR);

    REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_CURRENT, DEVICE_MODIFY_CURRENT);
    REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_LIVE, DEVICE_MODIFY_LIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_CONFIG, DEVICE_MODIFY_CONFIG);
    REGISTER_CONSTANT(VIR_DOMAIN_DEVICE_MODIFY_FORCE, DEVICE_MODIFY_FORCE);


    REGISTER_CONSTANT(VIR_DOMAIN_MEM_CURRENT, MEM_CURRENT);
    REGISTER_CONSTANT(VIR_DOMAIN_MEM_LIVE, MEM_LIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_MEM_CONFIG, MEM_CONFIG);
    REGISTER_CONSTANT(VIR_DOMAIN_MEM_MAXIMUM, MEM_MAXIMUM);


    REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_CURRENT, AFFECT_CURRENT);
    REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_LIVE, AFFECT_LIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_AFFECT_CONFIG, AFFECT_CONFIG);


    REGISTER_CONSTANT(VIR_DOMAIN_JOB_NONE, JOB_NONE);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_BOUNDED, JOB_BOUNDED);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_UNBOUNDED, JOB_UNBOUNDED);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_COMPLETED, JOB_COMPLETED);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_FAILED, JOB_FAILED);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_CANCELLED, JOB_CANCELLED);

    REGISTER_CONSTANT(VIR_DOMAIN_JOB_STATS_COMPLETED, JOB_STATS_COMPLETED);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_STATS_KEEP_COMPLETED, JOB_STATS_KEEP_COMPLETED);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_AUTO_CONVERGE_THROTTLE, JOB_AUTO_CONVERGE_THROTTLE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_BYTES, JOB_COMPRESSION_BYTES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_CACHE, JOB_COMPRESSION_CACHE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_CACHE_MISSES, JOB_COMPRESSION_CACHE_MISSES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_OVERFLOW, JOB_COMPRESSION_OVERFLOW);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_COMPRESSION_PAGES, JOB_COMPRESSION_PAGES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DATA_PROCESSED, JOB_DATA_PROCESSED);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DATA_REMAINING, JOB_DATA_REMAINING);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DATA_TOTAL, JOB_DATA_TOTAL);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_PROCESSED, JOB_DISK_PROCESSED);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_REMAINING, JOB_DISK_REMAINING);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_TOTAL, JOB_DISK_TOTAL);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_BPS, JOB_DISK_BPS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DOWNTIME, JOB_DOWNTIME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DOWNTIME_NET, JOB_DOWNTIME_NET);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_CONSTANT, JOB_MEMORY_CONSTANT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_NORMAL, JOB_MEMORY_NORMAL);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_NORMAL_BYTES, JOB_MEMORY_NORMAL_BYTES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_PROCESSED, JOB_MEMORY_PROCESSED);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_REMAINING, JOB_MEMORY_REMAINING);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_TOTAL, JOB_MEMORY_TOTAL);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_BPS, JOB_MEMORY_BPS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_DIRTY_RATE, JOB_MEMORY_DIRTY_RATE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_PAGE_SIZE, JOB_MEMORY_PAGE_SIZE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_ITERATION, JOB_MEMORY_ITERATION);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_MEMORY_POSTCOPY_REQS, JOB_MEMORY_POSTCOPY_REQS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_SETUP_TIME, JOB_SETUP_TIME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_TIME_ELAPSED, JOB_TIME_ELAPSED);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_TIME_ELAPSED_NET, JOB_TIME_ELAPSED_NET);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_TIME_REMAINING, JOB_TIME_REMAINING);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_OPERATION, JOB_OPERATION);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_SUCCESS, JOB_SUCCESS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_TEMP_TOTAL, JOB_DISK_TEMP_TOTAL);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_DISK_TEMP_USED, JOB_DISK_TEMP_USED);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_JOB_ERRMSG, JOB_ERRMSG);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_UNKNOWN, BLOCK_JOB_TYPE_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_PULL, BLOCK_JOB_TYPE_PULL);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_COPY, BLOCK_JOB_TYPE_COPY);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_COMMIT, BLOCK_JOB_TYPE_COMMIT);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_ACTIVE_COMMIT, BLOCK_JOB_TYPE_ACTIVE_COMMIT);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_TYPE_BACKUP, BLOCK_JOB_TYPE_BACKUP);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_COMPLETED, BLOCK_JOB_COMPLETED);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_FAILED, BLOCK_JOB_FAILED);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_CANCELED, BLOCK_JOB_CANCELED);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_READY, BLOCK_JOB_READY);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_DELETE, BLOCK_COMMIT_DELETE);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_SHALLOW, BLOCK_COMMIT_SHALLOW);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_ACTIVE, BLOCK_COMMIT_ACTIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_RELATIVE, BLOCK_COMMIT_RELATIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COMMIT_BANDWIDTH_BYTES, BLOCK_COMMIT_BANDWIDTH_BYTES);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_REBOOT, EVENT_ID_REBOOT);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_RTC_CHANGE, EVENT_ID_RTC_CHANGE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_WATCHDOG, EVENT_ID_WATCHDOG);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_IO_ERROR, EVENT_ID_IO_ERROR);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_GRAPHICS, EVENT_ID_GRAPHICS);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_IO_ERROR_REASON, EVENT_ID_IO_ERROR_REASON);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_CONTROL_ERROR, EVENT_ID_CONTROL_ERROR);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BLOCK_JOB, EVENT_ID_BLOCK_JOB);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BLOCK_JOB_2, EVENT_ID_BLOCK_JOB_2);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DISK_CHANGE, EVENT_ID_DISK_CHANGE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMSUSPEND, EVENT_ID_PMSUSPEND);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMSUSPEND_DISK, EVENT_ID_PMSUSPEND_DISK);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_PMWAKEUP, EVENT_ID_PMWAKEUP);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_TRAY_CHANGE, EVENT_ID_TRAY_CHANGE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BALLOON_CHANGE, EVENT_ID_BALLOON_CHANGE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DEVICE_ADDED, EVENT_ID_DEVICE_ADDED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DEVICE_REMOVED, EVENT_ID_DEVICE_REMOVED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_TUNABLE, EVENT_ID_TUNABLE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_AGENT_LIFECYCLE, EVENT_ID_AGENT_LIFECYCLE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_MIGRATION_ITERATION, EVENT_ID_MIGRATION_ITERATION);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_JOB_COMPLETED, EVENT_ID_JOB_COMPLETED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_DEVICE_REMOVAL_FAILED, EVENT_ID_DEVICE_REMOVAL_FAILED);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_METADATA_CHANGE, EVENT_ID_METADATA_CHANGE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_BLOCK_THRESHOLD, EVENT_ID_BLOCK_THRESHOLD);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_MEMORY_FAILURE, EVENT_ID_MEMORY_FAILURE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_ID_MEMORY_DEVICE_SIZE_CHANGE, EVENT_ID_MEMORY_DEVICE_SIZE_CHANGE);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_NONE, EVENT_WATCHDOG_NONE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_PAUSE, EVENT_WATCHDOG_PAUSE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_RESET, EVENT_WATCHDOG_RESET);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_POWEROFF, EVENT_WATCHDOG_POWEROFF);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_SHUTDOWN, EVENT_WATCHDOG_SHUTDOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_DEBUG, EVENT_WATCHDOG_DEBUG);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_WATCHDOG_INJECTNMI, EVENT_WATCHDOG_INJECTNMI);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_NONE, EVENT_IO_ERROR_NONE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_PAUSE, EVENT_IO_ERROR_PAUSE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_IO_ERROR_REPORT, EVENT_IO_ERROR_REPORT);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_CONNECT, EVENT_GRAPHICS_CONNECT);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_INITIALIZE, EVENT_GRAPHICS_INITIALIZE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_DISCONNECT, EVENT_GRAPHICS_DISCONNECT);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_IPV4, EVENT_GRAPHICS_ADDRESS_IPV4);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_IPV6, EVENT_GRAPHICS_ADDRESS_IPV6);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_GRAPHICS_ADDRESS_UNIX, EVENT_GRAPHICS_ADDRESS_UNIX);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DISK_CHANGE_MISSING_ON_START, EVENT_DISK_CHANGE_MISSING_ON_START);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_DISK_DROP_MISSING_ON_START, EVENT_DISK_DROP_MISSING_ON_START);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_TRAY_CHANGE_OPEN, EVENT_TRAY_CHANGE_OPEN);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_TRAY_CHANGE_CLOSE, EVENT_TRAY_CHANGE_CLOSE);

    REGISTER_CONSTANT(VIR_CONNECT_DOMAIN_EVENT_AGENT_LIFECYCLE_STATE_CONNECTED, EVENT_AGENT_LIFECYCLE_STATE_CONNECTED);
    REGISTER_CONSTANT(VIR_CONNECT_DOMAIN_EVENT_AGENT_LIFECYCLE_STATE_DISCONNECTED, EVENT_AGENT_LIFECYCLE_STATE_DISCONNECTED);

    REGISTER_CONSTANT(VIR_CONNECT_DOMAIN_EVENT_AGENT_LIFECYCLE_REASON_CHANNEL, EVENT_AGENT_LIFECYCLE_REASON_CHANNEL);
    REGISTER_CONSTANT(VIR_CONNECT_DOMAIN_EVENT_AGENT_LIFECYCLE_REASON_DOMAIN_STARTED, EVENT_AGENT_LIFECYCLE_REASON_DOMAIN_STARTED);
    REGISTER_CONSTANT(VIR_CONNECT_DOMAIN_EVENT_AGENT_LIFECYCLE_REASON_UNKNOWN, EVENT_AGENT_LIFECYCLE_REASON_UNKNOWN);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_HARD_LIMIT, MEMORY_HARD_LIMIT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_SOFT_LIMIT, MEMORY_SOFT_LIMIT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_MIN_GUARANTEE, MEMORY_MIN_GUARANTEE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_MEMORY_SWAP_HARD_LIMIT, MEMORY_SWAP_HARD_LIMIT);
    REGISTER_CONSTANT_ULL(VIR_DOMAIN_MEMORY_PARAM_UNLIMITED, MEMORY_PARAM_UNLIMITED);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_WEIGHT, BLKIO_WEIGHT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_WEIGHT, BLKIO_DEVICE_WEIGHT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_READ_BPS, BLKIO_DEVICE_READ_BPS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_READ_IOPS, BLKIO_DEVICE_READ_IOPS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_WRITE_BPS, BLKIO_DEVICE_WRITE_BPS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLKIO_DEVICE_WRITE_IOPS, BLKIO_DEVICE_WRITE_IOPS);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_CPU_SHARES, SCHEDULER_CPU_SHARES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_VCPU_PERIOD, SCHEDULER_VCPU_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_VCPU_QUOTA, SCHEDULER_VCPU_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_GLOBAL_PERIOD, SCHEDULER_GLOBAL_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_GLOBAL_QUOTA, SCHEDULER_GLOBAL_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_WEIGHT, SCHEDULER_WEIGHT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_CAP, SCHEDULER_CAP);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_LIMIT, SCHEDULER_LIMIT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_RESERVATION, SCHEDULER_RESERVATION);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SCHEDULER_SHARES, SCHEDULER_SHARES);


    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_SWAP_IN, MEMORY_STAT_SWAP_IN);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_SWAP_OUT, MEMORY_STAT_SWAP_OUT);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_MAJOR_FAULT, MEMORY_STAT_MAJOR_FAULT);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_MINOR_FAULT, MEMORY_STAT_MINOR_FAULT);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_UNUSED, MEMORY_STAT_UNUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_AVAILABLE, MEMORY_STAT_AVAILABLE);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_ACTUAL_BALLOON, MEMORY_STAT_ACTUAL_BALLOON);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_RSS, MEMORY_STAT_RSS);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_LAST_UPDATE, MEMORY_STAT_LAST_UPDATE);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_USABLE, MEMORY_STAT_USABLE);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_DISK_CACHES, MEMORY_STAT_DISK_CACHES);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_HUGETLB_PGALLOC, MEMORY_STAT_HUGETLB_PGALLOC);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_STAT_HUGETLB_PGFAIL, MEMORY_STAT_HUGETLB_PGFAIL);


    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_BYTES_SEC, BLOCK_IOTUNE_TOTAL_BYTES_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_BYTES_SEC, BLOCK_IOTUNE_READ_BYTES_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_BYTES_SEC, BLOCK_IOTUNE_WRITE_BYTES_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_IOPS_SEC, BLOCK_IOTUNE_TOTAL_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_IOPS_SEC, BLOCK_IOTUNE_READ_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_IOPS_SEC, BLOCK_IOTUNE_WRITE_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_BYTES_SEC_MAX, BLOCK_IOTUNE_TOTAL_BYTES_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_BYTES_SEC_MAX, BLOCK_IOTUNE_READ_BYTES_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_BYTES_SEC_MAX, BLOCK_IOTUNE_WRITE_BYTES_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_IOPS_SEC_MAX, BLOCK_IOTUNE_TOTAL_IOPS_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_IOPS_SEC_MAX, BLOCK_IOTUNE_READ_IOPS_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_IOPS_SEC_MAX, BLOCK_IOTUNE_WRITE_IOPS_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_SIZE_IOPS_SEC, BLOCK_IOTUNE_SIZE_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_GROUP_NAME, BLOCK_IOTUNE_GROUP_NAME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_BYTES_SEC_MAX_LENGTH, BLOCK_IOTUNE_TOTAL_BYTES_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_BYTES_SEC_MAX_LENGTH, BLOCK_IOTUNE_READ_BYTES_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_BYTES_SEC_MAX_LENGTH, BLOCK_IOTUNE_WRITE_BYTES_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_TOTAL_IOPS_SEC_MAX_LENGTH, BLOCK_IOTUNE_TOTAL_IOPS_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_READ_IOPS_SEC_MAX_LENGTH, BLOCK_IOTUNE_READ_IOPS_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_IOTUNE_WRITE_IOPS_SEC_MAX_LENGTH, BLOCK_IOTUNE_WRITE_IOPS_SEC_MAX_LENGTH);


    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_RESIZE_BYTES, BLOCK_RESIZE_BYTES);


    REGISTER_CONSTANT_STR(VIR_DOMAIN_NUMA_NODESET, NUMA_NODESET);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_NUMA_MODE, NUMA_MODE);

    REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_STRICT, NUMATUNE_MEM_STRICT);
    REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_PREFERRED, NUMATUNE_MEM_PREFERRED);
    REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_INTERLEAVE, NUMATUNE_MEM_INTERLEAVE);
    REGISTER_CONSTANT(VIR_DOMAIN_NUMATUNE_MEM_RESTRICTIVE, NUMATUNE_MEM_RESTRICTIVE);

    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CMT, PERF_PARAM_CMT);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_MBML, PERF_PARAM_MBML);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_MBMT, PERF_PARAM_MBMT);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CACHE_MISSES, PERF_PARAM_CACHE_MISSES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CACHE_REFERENCES, PERF_PARAM_CACHE_REFERENCES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CPU_CYCLES, PERF_PARAM_CPU_CYCLES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_INSTRUCTIONS, PERF_PARAM_INSTRUCTIONS);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_BRANCH_INSTRUCTIONS, PERF_PARAM_BRANCH_INSTRUCTIONS);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_BRANCH_MISSES, PERF_PARAM_BRANCH_MISSES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_BUS_CYCLES, PERF_PARAM_BUS_CYCLES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_STALLED_CYCLES_FRONTEND, PERF_PARAM_STALLED_CYCLES_FRONTEND);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_STALLED_CYCLES_BACKEND, PERF_PARAM_STALLED_CYCLES_BACKEND);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_REF_CPU_CYCLES, PERF_PARAM_REF_CPU_CYCLES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CPU_CLOCK, PERF_PARAM_CPU_CLOCK);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_TASK_CLOCK, PERF_PARAM_TASK_CLOCK);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_PAGE_FAULTS, PERF_PARAM_PAGE_FAULTS);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CONTEXT_SWITCHES, PERF_PARAM_CONTEXT_SWITCHES);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_CPU_MIGRATIONS, PERF_PARAM_CPU_MIGRATIONS);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_PAGE_FAULTS_MIN, PERF_PARAM_PAGE_FAULTS_MIN);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_PAGE_FAULTS_MAJ, PERF_PARAM_PAGE_FAULTS_MAJ);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_ALIGNMENT_FAULTS, PERF_PARAM_ALIGNMENT_FAULTS);
    REGISTER_CONSTANT_STR(VIR_PERF_PARAM_EMULATION_FAULTS, PERF_PARAM_EMULATION_FAULTS);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_IOTHREAD_POLL_MAX_NS, IOTHREAD_PARAM_POLL_MAX_NS);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_IOTHREAD_POLL_GROW, IOTHREAD_PARAM_POLL_GROW);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_IOTHREAD_POLL_SHRINK, IOTHREAD_PARAM_POLL_SHRINK);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_IOTHREAD_THREAD_POOL_MIN, IOTHREAD_PARAM_THREAD_POOL_MIN);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_IOTHREAD_THREAD_POOL_MAX, IOTHREAD_PARAM_THREAD_POOL_MAX);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_AVERAGE, BANDWIDTH_IN_AVERAGE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_PEAK, BANDWIDTH_IN_PEAK);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_BURST, BANDWIDTH_IN_BURST);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_IN_FLOOR, BANDWIDTH_IN_FLOOR);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_AVERAGE, BANDWIDTH_OUT_AVERAGE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_PEAK, BANDWIDTH_OUT_PEAK);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BANDWIDTH_OUT_BURST, BANDWIDTH_OUT_BURST);


    REGISTER_CONSTANT(VIR_DOMAIN_VCPU_CURRENT, VCPU_CURRENT);
    REGISTER_CONSTANT(VIR_DOMAIN_VCPU_LIVE, VCPU_LIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_VCPU_CONFIG, VCPU_CONFIG);
    REGISTER_CONSTANT(VIR_DOMAIN_VCPU_MAXIMUM, VCPU_MAXIMUM);
    REGISTER_CONSTANT(VIR_DOMAIN_VCPU_GUEST, VCPU_GUEST);
    REGISTER_CONSTANT(VIR_DOMAIN_VCPU_HOTPLUGGABLE, VCPU_HOTPLUGGABLE);


    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_DEFAULT, SHUTDOWN_DEFAULT);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_ACPI_POWER_BTN, SHUTDOWN_ACPI_POWER_BTN);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_GUEST_AGENT, SHUTDOWN_GUEST_AGENT);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_INITCTL, SHUTDOWN_INITCTL);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_SIGNAL, SHUTDOWN_SIGNAL);
    REGISTER_CONSTANT(VIR_DOMAIN_SHUTDOWN_PARAVIRT, SHUTDOWN_PARAVIRT);


    REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_DEFAULT, REBOOT_DEFAULT);
    REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_ACPI_POWER_BTN, REBOOT_ACPI_POWER_BTN);
    REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_GUEST_AGENT, REBOOT_GUEST_AGENT);
    REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_INITCTL, REBOOT_INITCTL);
    REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_SIGNAL, REBOOT_SIGNAL);
    REGISTER_CONSTANT(VIR_DOMAIN_REBOOT_PARAVIRT, REBOOT_PARAVIRT);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_NOP, PROCESS_SIGNAL_NOP);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_HUP, PROCESS_SIGNAL_HUP);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_INT, PROCESS_SIGNAL_INT);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_QUIT, PROCESS_SIGNAL_QUIT);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_ILL, PROCESS_SIGNAL_ILL);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TRAP, PROCESS_SIGNAL_TRAP);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_ABRT, PROCESS_SIGNAL_ABRT);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_BUS, PROCESS_SIGNAL_BUS);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_FPE, PROCESS_SIGNAL_FPE);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_KILL, PROCESS_SIGNAL_KILL);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_USR1, PROCESS_SIGNAL_USR1);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_SEGV, PROCESS_SIGNAL_SEGV);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_USR2, PROCESS_SIGNAL_USR2);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_PIPE, PROCESS_SIGNAL_PIPE);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_ALRM, PROCESS_SIGNAL_ALRM);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TERM, PROCESS_SIGNAL_TERM);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_STKFLT, PROCESS_SIGNAL_STKFLT);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_CHLD, PROCESS_SIGNAL_CHLD);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_CONT, PROCESS_SIGNAL_CONT);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_STOP, PROCESS_SIGNAL_STOP);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TSTP, PROCESS_SIGNAL_TSTP);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TTIN, PROCESS_SIGNAL_TTIN);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_TTOU, PROCESS_SIGNAL_TTOU);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_URG, PROCESS_SIGNAL_URG);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_XCPU, PROCESS_SIGNAL_XCPU);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_XFSZ, PROCESS_SIGNAL_XFSZ);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_VTALRM, PROCESS_SIGNAL_VTALRM);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_PROF, PROCESS_SIGNAL_PROF);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_WINCH, PROCESS_SIGNAL_WINCH);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_POLL, PROCESS_SIGNAL_POLL);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_PWR, PROCESS_SIGNAL_PWR);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_SYS, PROCESS_SIGNAL_SYS);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT0, PROCESS_SIGNAL_RT0);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT1, PROCESS_SIGNAL_RT1);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT2, PROCESS_SIGNAL_RT2);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT3, PROCESS_SIGNAL_RT3);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT4, PROCESS_SIGNAL_RT4);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT5, PROCESS_SIGNAL_RT5);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT6, PROCESS_SIGNAL_RT6);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT7, PROCESS_SIGNAL_RT7);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT8, PROCESS_SIGNAL_RT8);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT9, PROCESS_SIGNAL_RT9);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT10, PROCESS_SIGNAL_RT10);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT11, PROCESS_SIGNAL_RT11);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT12, PROCESS_SIGNAL_RT12);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT13, PROCESS_SIGNAL_RT13);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT14, PROCESS_SIGNAL_RT14);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT15, PROCESS_SIGNAL_RT15);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT16, PROCESS_SIGNAL_RT16);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT17, PROCESS_SIGNAL_RT17);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT18, PROCESS_SIGNAL_RT18);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT19, PROCESS_SIGNAL_RT19);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT20, PROCESS_SIGNAL_RT20);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT21, PROCESS_SIGNAL_RT21);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT22, PROCESS_SIGNAL_RT22);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT23, PROCESS_SIGNAL_RT23);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT24, PROCESS_SIGNAL_RT24);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT25, PROCESS_SIGNAL_RT25);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT26, PROCESS_SIGNAL_RT26);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT27, PROCESS_SIGNAL_RT27);

    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT28, PROCESS_SIGNAL_RT28);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT29, PROCESS_SIGNAL_RT29);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT30, PROCESS_SIGNAL_RT30);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT31, PROCESS_SIGNAL_RT31);
    REGISTER_CONSTANT(VIR_DOMAIN_PROCESS_SIGNAL_RT32, PROCESS_SIGNAL_RT32);

    REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_DEFAULT, DESTROY_DEFAULT);
    REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_GRACEFUL, DESTROY_GRACEFUL);
    REGISTER_CONSTANT(VIR_DOMAIN_DESTROY_REMOVE_LOGS, DESTROY_REMOVE_LOGS);


    REGISTER_CONSTANT(VIR_DOMAIN_METADATA_DESCRIPTION, METADATA_DESCRIPTION);
    REGISTER_CONSTANT(VIR_DOMAIN_METADATA_TITLE, METADATA_TITLE);
    REGISTER_CONSTANT(VIR_DOMAIN_METADATA_ELEMENT, METADATA_ELEMENT);

    REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_NONE, DISK_ERROR_NONE);
    REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_NO_SPACE, DISK_ERROR_NO_SPACE);
    REGISTER_CONSTANT(VIR_DOMAIN_DISK_ERROR_UNSPEC, DISK_ERROR_UNSPEC);


    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_ABORT_ASYNC, BLOCK_JOB_ABORT_ASYNC);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_ABORT_PIVOT, BLOCK_JOB_ABORT_PIVOT);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_SHALLOW, BLOCK_REBASE_SHALLOW);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_REUSE_EXT, BLOCK_REBASE_REUSE_EXT);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY_RAW, BLOCK_REBASE_COPY_RAW);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY, BLOCK_REBASE_COPY);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_COPY_DEV, BLOCK_REBASE_COPY_DEV);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_RELATIVE, BLOCK_REBASE_RELATIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_REBASE_BANDWIDTH_BYTES, BLOCK_REBASE_BANDWIDTH_BYTES);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_COPY_BANDWIDTH, BLOCK_COPY_BANDWIDTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_COPY_GRANULARITY, BLOCK_COPY_GRANULARITY);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_BLOCK_COPY_BUF_SIZE, BLOCK_COPY_BUF_SIZE);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COPY_REUSE_EXT, BLOCK_COPY_REUSE_EXT);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COPY_SHALLOW, BLOCK_COPY_SHALLOW);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COPY_TRANSIENT_JOB, BLOCK_COPY_TRANSIENT_JOB);
    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_COPY_SYNCHRONOUS_WRITES, BLOCK_COPY_SYNCHRONOUS_WRITES);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_SPEED_BANDWIDTH_BYTES, BLOCK_JOB_SPEED_BANDWIDTH_BYTES);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_PULL_BANDWIDTH_BYTES, BLOCK_PULL_BANDWIDTH_BYTES);

    REGISTER_CONSTANT(VIR_DOMAIN_BLOCK_JOB_INFO_BANDWIDTH_BYTES, BLOCK_JOB_INFO_BANDWIDTH_BYTES);

    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_ACTIVE, LIST_ACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_AUTOSTART, LIST_AUTOSTART);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_HAS_SNAPSHOT, LIST_HAS_SNAPSHOT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_INACTIVE, LIST_INACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_MANAGEDSAVE, LIST_MANAGEDSAVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_AUTOSTART, LIST_NO_AUTOSTART);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_MANAGEDSAVE, LIST_NO_MANAGEDSAVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_SNAPSHOT, LIST_NO_SNAPSHOT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_OTHER, LIST_OTHER);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_PAUSED, LIST_PAUSED);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_PERSISTENT, LIST_PERSISTENT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_RUNNING, LIST_RUNNING);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_SHUTOFF, LIST_SHUTOFF);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_TRANSIENT, LIST_TRANSIENT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_HAS_CHECKPOINT, LIST_HAS_CHECKPOINT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_DOMAINS_NO_CHECKPOINT, LIST_NO_CHECKPOINT);

    REGISTER_CONSTANT(VIR_DOMAIN_SEND_KEY_MAX_KEYS, SEND_KEY_MAX_KEYS);

    REGISTER_CONSTANT(VIR_DOMAIN_CORE_DUMP_FORMAT_RAW, CORE_DUMP_FORMAT_RAW);
    REGISTER_CONSTANT(VIR_DOMAIN_CORE_DUMP_FORMAT_KDUMP_LZO, CORE_DUMP_FORMAT_KDUMP_LZO);
    REGISTER_CONSTANT(VIR_DOMAIN_CORE_DUMP_FORMAT_KDUMP_SNAPPY, CORE_DUMP_FORMAT_KDUMP_SNAPPY);
    REGISTER_CONSTANT(VIR_DOMAIN_CORE_DUMP_FORMAT_KDUMP_ZLIB, CORE_DUMP_FORMAT_KDUMP_ZLIB);
    REGISTER_CONSTANT(VIR_DOMAIN_CORE_DUMP_FORMAT_WIN_DMP, CORE_DUMP_FORMAT_WIN_DMP);

    REGISTER_CONSTANT(VIR_DOMAIN_TIME_SYNC, TIME_SYNC);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_CPU_SHARES, TUNABLE_CPU_CPU_SHARES);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_EMULATORPIN, TUNABLE_CPU_EMULATORPIN);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_EMULATOR_PERIOD, TUNABLE_CPU_EMULATOR_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_EMULATOR_QUOTA, TUNABLE_CPU_EMULATOR_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_IOTHREAD_PERIOD, TUNABLE_CPU_IOTHREAD_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_IOTHREAD_QUOTA, TUNABLE_CPU_IOTHREAD_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_VCPUPIN, TUNABLE_CPU_VCPUPIN);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_VCPU_PERIOD, TUNABLE_CPU_VCPU_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_VCPU_QUOTA, TUNABLE_CPU_VCPU_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_GLOBAL_PERIOD, TUNABLE_CPU_GLOBAL_PERIOD);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_GLOBAL_QUOTA, TUNABLE_CPU_GLOBAL_QUOTA);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_DISK, TUNABLE_BLKDEV_DISK);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_READ_BYTES_SEC, TUNABLE_BLKDEV_READ_BYTES_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_READ_IOPS_SEC, TUNABLE_BLKDEV_READ_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_TOTAL_BYTES_SEC, TUNABLE_BLKDEV_TOTAL_BYTES_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_TOTAL_IOPS_SEC, TUNABLE_BLKDEV_TOTAL_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_WRITE_BYTES_SEC, TUNABLE_BLKDEV_WRITE_BYTES_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_WRITE_IOPS_SEC, TUNABLE_BLKDEV_WRITE_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_READ_BYTES_SEC_MAX, TUNABLE_BLKDEV_READ_BYTES_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_READ_IOPS_SEC_MAX, TUNABLE_BLKDEV_READ_IOPS_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_WRITE_BYTES_SEC_MAX, TUNABLE_BLKDEV_WRITE_BYTES_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_WRITE_IOPS_SEC_MAX, TUNABLE_BLKDEV_WRITE_IOPS_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_TOTAL_BYTES_SEC_MAX, TUNABLE_BLKDEV_TOTAL_BYTES_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_TOTAL_IOPS_SEC_MAX, TUNABLE_BLKDEV_TOTAL_IOPS_SEC_MAX);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_SIZE_IOPS_SEC, TUNABLE_BLKDEV_SIZE_IOPS_SEC);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_GROUP_NAME, TUNABLE_BLKDEV_GROUP_NAME);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_READ_BYTES_SEC_MAX_LENGTH, TUNABLE_BLKDEV_READ_BYTES_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_READ_IOPS_SEC_MAX_LENGTH, TUNABLE_BLKDEV_READ_IOPS_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_WRITE_BYTES_SEC_MAX_LENGTH, TUNABLE_BLKDEV_WRITE_BYTES_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_WRITE_IOPS_SEC_MAX_LENGTH, TUNABLE_BLKDEV_WRITE_IOPS_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_TOTAL_BYTES_SEC_MAX_LENGTH, TUNABLE_BLKDEV_TOTAL_BYTES_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_BLKDEV_TOTAL_IOPS_SEC_MAX_LENGTH, TUNABLE_BLKDEV_TOTAL_IOPS_SEC_MAX_LENGTH);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_TUNABLE_CPU_IOTHREADSPIN, TUNABLE_IOTHREADSPIN);


    REGISTER_CONSTANT(VIR_DOMAIN_INTERFACE_ADDRESSES_SRC_AGENT, INTERFACE_ADDRESSES_SRC_AGENT);
    REGISTER_CONSTANT(VIR_DOMAIN_INTERFACE_ADDRESSES_SRC_LEASE, INTERFACE_ADDRESSES_SRC_LEASE);
    REGISTER_CONSTANT(VIR_DOMAIN_INTERFACE_ADDRESSES_SRC_ARP, INTERFACE_ADDRESSES_SRC_ARP);


    REGISTER_CONSTANT(VIR_DOMAIN_PASSWORD_ENCRYPTED, PASSWORD_ENCRYPTED);

    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_UNKNOWN, JOB_OPERATION_UNKNOWN);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_START, JOB_OPERATION_START);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_SAVE, JOB_OPERATION_SAVE);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_RESTORE, JOB_OPERATION_RESTORE);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_MIGRATION_IN, JOB_OPERATION_MIGRATION_IN);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_MIGRATION_OUT, JOB_OPERATION_MIGRATION_OUT);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_SNAPSHOT, JOB_OPERATION_SNAPSHOT);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_SNAPSHOT_REVERT, JOB_OPERATION_SNAPSHOT_REVERT);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_DUMP, JOB_OPERATION_DUMP);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_BACKUP, JOB_OPERATION_BACKUP);
    REGISTER_CONSTANT(VIR_DOMAIN_JOB_OPERATION_SNAPSHOT_DELETE, JOB_OPERATION_SNAPSHOT_DELETE);

    REGISTER_CONSTANT(VIR_DOMAIN_ABORT_JOB_POSTCOPY, DOMAIN_ABORT_JOB_POSTCOPY);

    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_POWEROFF, LIFECYCLE_POWEROFF);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_REBOOT, LIFECYCLE_REBOOT);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_CRASH, LIFECYCLE_CRASH);

    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_ACTION_DESTROY, LIFECYCLE_ACTION_DESTROY);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_ACTION_RESTART, LIFECYCLE_ACTION_RESTART);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_ACTION_RESTART_RENAME, LIFECYCLE_ACTION_RESTART_RENAME);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_ACTION_PRESERVE, LIFECYCLE_ACTION_PRESERVE);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_ACTION_COREDUMP_DESTROY, LIFECYCLE_ACTION_COREDUMP_DESTROY);
    REGISTER_CONSTANT(VIR_DOMAIN_LIFECYCLE_ACTION_COREDUMP_RESTART, LIFECYCLE_ACTION_COREDUMP_RESTART);

    REGISTER_CONSTANT(VIR_DOMAIN_SAVE_IMAGE_XML_SECURE, SAVE_IMAGE_XML_SECURE);


    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_MEASUREMENT, LAUNCH_SECURITY_SEV_MEASUREMENT);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_API_MAJOR, LAUNCH_SECURITY_SEV_API_MAJOR);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_API_MINOR, LAUNCH_SECURITY_SEV_API_MINOR);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_BUILD_ID, LAUNCH_SECURITY_SEV_BUILD_ID);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_POLICY, LAUNCH_SECURITY_SEV_POLICY);

    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_SECRET, LAUNCH_SECURITY_SEV_SECRET);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_SECRET_HEADER, LAUNCH_SECURITY_SEV_SECRET_HEADER);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_LAUNCH_SECURITY_SEV_SECRET_SET_ADDRESS, LAUNCH_SECURITY_SEV_SECRET_SET_ADDRESS);

    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_USERS, GUEST_INFO_USERS);
    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_OS, GUEST_INFO_OS);
    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_TIMEZONE, GUEST_INFO_TIMEZONE);
    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_HOSTNAME, GUEST_INFO_HOSTNAME);
    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_FILESYSTEM, GUEST_INFO_FILESYSTEM);
    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_DISKS, GUEST_INFO_DISKS);
    REGISTER_CONSTANT(VIR_DOMAIN_GUEST_INFO_INTERFACES, GUEST_INFO_INTERFACES);

    REGISTER_CONSTANT(VIR_DOMAIN_AGENT_RESPONSE_TIMEOUT_BLOCK, AGENT_RESPONSE_TIMEOUT_BLOCK);
    REGISTER_CONSTANT(VIR_DOMAIN_AGENT_RESPONSE_TIMEOUT_NOWAIT, AGENT_RESPONSE_TIMEOUT_NOWAIT);
    REGISTER_CONSTANT(VIR_DOMAIN_AGENT_RESPONSE_TIMEOUT_DEFAULT, AGENT_RESPONSE_TIMEOUT_DEFAULT);

    REGISTER_CONSTANT(VIR_DOMAIN_BACKUP_BEGIN_REUSE_EXTERNAL, BACKUP_BEGIN_REUSE_EXTERNAL);


    REGISTER_CONSTANT(VIR_DOMAIN_GET_HOSTNAME_AGENT, GET_HOSTNAME_AGENT);
    REGISTER_CONSTANT(VIR_DOMAIN_GET_HOSTNAME_LEASE, GET_HOSTNAME_LEASE);


    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_MEMORY_FAILURE_ACTION_IGNORE, EVENT_MEMORY_FAILURE_ACTION_IGNORE);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_MEMORY_FAILURE_ACTION_INJECT, EVENT_MEMORY_FAILURE_ACTION_INJECT);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_MEMORY_FAILURE_ACTION_FATAL, EVENT_MEMORY_FAILURE_ACTION_FATAL);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_MEMORY_FAILURE_ACTION_RESET, EVENT_MEMORY_FAILURE_ACTION_RESET);

    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_MEMORY_FAILURE_RECIPIENT_HYPERVISOR, EVENT_MEMORY_FAILURE_RECIPIENT_HYPERVISOR);
    REGISTER_CONSTANT(VIR_DOMAIN_EVENT_MEMORY_FAILURE_RECIPIENT_GUEST, EVENT_MEMORY_FAILURE_RECIPIENT_GUEST);

    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_FAILURE_ACTION_REQUIRED, MEMORY_FAILURE_ACTION_REQUIRED);
    REGISTER_CONSTANT(VIR_DOMAIN_MEMORY_FAILURE_RECURSIVE, MEMORY_FAILURE_RECURSIVE);

    REGISTER_CONSTANT(VIR_DOMAIN_AUTHORIZED_SSH_KEYS_SET_APPEND, AUTHORIZED_SSH_KEYS_SET_APPEND);
    REGISTER_CONSTANT(VIR_DOMAIN_AUTHORIZED_SSH_KEYS_SET_REMOVE, AUTHORIZED_SSH_KEYS_SET_REMOVE);

    REGISTER_CONSTANT(VIR_DOMAIN_MESSAGE_DEPRECATION, MESSAGE_DEPRECATION);
    REGISTER_CONSTANT(VIR_DOMAIN_MESSAGE_TAINTING, MESSAGE_TAINTING);

    REGISTER_CONSTANT(VIR_DOMAIN_DIRTYRATE_UNSTARTED, DIRTYRATE_UNSTARTED);
    REGISTER_CONSTANT(VIR_DOMAIN_DIRTYRATE_MEASURING, DIRTYRATE_MEASURING);
    REGISTER_CONSTANT(VIR_DOMAIN_DIRTYRATE_MEASURED, DIRTYRATE_MEASURED);

    REGISTER_CONSTANT(VIR_DOMAIN_DIRTYRATE_MODE_PAGE_SAMPLING, DIRTYRATE_MODE_PAGE_SAMPLING);
    REGISTER_CONSTANT(VIR_DOMAIN_DIRTYRATE_MODE_DIRTY_BITMAP, DIRTYRATE_MODE_DIRTY_BITMAP);
    REGISTER_CONSTANT(VIR_DOMAIN_DIRTYRATE_MODE_DIRTY_RING, DIRTYRATE_MODE_DIRTY_RING);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SAVE_PARAM_FILE, SAVE_PARAM_FILE);
    REGISTER_CONSTANT_STR(VIR_DOMAIN_SAVE_PARAM_DXML, SAVE_PARAM_DXML);

    REGISTER_CONSTANT(VIR_DOMAIN_FD_ASSOCIATE_SECLABEL_RESTORE, FD_ASSOCIATE_SECLABEL_RESTORE);
    REGISTER_CONSTANT(VIR_DOMAIN_FD_ASSOCIATE_SECLABEL_WRITABLE, FD_ASSOCIATE_SECLABEL_WRITABLE);

    stash = gv_stashpv( "Sys::Virt::DomainSnapshot", TRUE );
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_CHILDREN, DELETE_CHILDREN);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_METADATA_ONLY, DELETE_METADATA_ONLY);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_DELETE_CHILDREN_ONLY, DELETE_CHILDREN_ONLY);

    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_REDEFINE, CREATE_REDEFINE);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_CURRENT, CREATE_CURRENT);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_NO_METADATA, CREATE_NO_METADATA);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_HALT, CREATE_HALT);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_DISK_ONLY, CREATE_DISK_ONLY);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_REUSE_EXT, CREATE_REUSE_EXT);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_QUIESCE, CREATE_QUIESCE);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_ATOMIC, CREATE_ATOMIC);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_LIVE, CREATE_LIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_CREATE_VALIDATE, CREATE_VALIDATE);

    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_ROOTS, LIST_ROOTS);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_DESCENDANTS, LIST_DESCENDANTS);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_METADATA, LIST_METADATA);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_LEAVES, LIST_LEAVES);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_NO_LEAVES, LIST_NO_LEAVES);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_NO_METADATA, LIST_NO_METADATA);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_ACTIVE, LIST_ACTIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_INACTIVE, LIST_INACTIVE);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_EXTERNAL, LIST_EXTERNAL);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_INTERNAL, LIST_INTERNAL);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_DISK_ONLY, LIST_DISK_ONLY);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_LIST_TOPOLOGICAL, LIST_TOPOLOGICAL);


    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_RUNNING, REVERT_RUNNING);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_PAUSED, REVERT_PAUSED);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_FORCE, REVERT_FORCE);
    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_REVERT_RESET_NVRAM, REVERT_RESET_NVRAM);

    REGISTER_CONSTANT(VIR_DOMAIN_SNAPSHOT_XML_SECURE, XML_SECURE);

    stash = gv_stashpv( "Sys::Virt::DomainCheckpoint", TRUE );
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_DELETE_CHILDREN, DELETE_CHILDREN);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_DELETE_METADATA_ONLY, DELETE_METADATA_ONLY);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_DELETE_CHILDREN_ONLY, DELETE_CHILDREN_ONLY);

    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_CREATE_REDEFINE, CREATE_REDEFINE);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_CREATE_QUIESCE, CREATE_QUIESCE);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_CREATE_REDEFINE_VALIDATE, CREATE_REDEFINE_VALIDATE);

    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_LIST_ROOTS, LIST_ROOTS);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_LIST_DESCENDANTS, LIST_DESCENDANTS);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_LIST_LEAVES, LIST_LEAVES);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_LIST_NO_LEAVES, LIST_NO_LEAVES);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_LIST_TOPOLOGICAL, LIST_TOPOLOGICAL);

    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_XML_SECURE, XML_SECURE);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_XML_SIZE, XML_SIZE);
    REGISTER_CONSTANT(VIR_DOMAIN_CHECKPOINT_XML_NO_DOMAIN, XML_NO_DOMAIN);

    stash = gv_stashpv( "Sys::Virt::StoragePool", TRUE );
    REGISTER_CONSTANT(VIR_STORAGE_POOL_INACTIVE, STATE_INACTIVE);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILDING, STATE_BUILDING);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_RUNNING, STATE_RUNNING);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_DEGRADED, STATE_DEGRADED);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_INACCESSIBLE, STATE_INACCESSIBLE);

    REGISTER_CONSTANT(VIR_STORAGE_POOL_DEFINE_VALIDATE, DEFINE_VALIDATE);

    REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NEW, BUILD_NEW);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_REPAIR, BUILD_REPAIR);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_RESIZE, BUILD_RESIZE);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_NO_OVERWRITE, BUILD_NO_OVERWRITE);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_BUILD_OVERWRITE, BUILD_OVERWRITE);

    REGISTER_CONSTANT(VIR_STORAGE_POOL_CREATE_NORMAL, CREATE_NORMAL);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_CREATE_WITH_BUILD, CREATE_WITH_BUILD);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_CREATE_WITH_BUILD_OVERWRITE, CREATE_WITH_BUILD_OVERWRITE);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_CREATE_WITH_BUILD_NO_OVERWRITE, CREATE_WITH_BUILD_NO_OVERWRITE);

    REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_NORMAL, DELETE_NORMAL);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_DELETE_ZEROED, DELETE_ZEROED);

    REGISTER_CONSTANT(VIR_STORAGE_XML_INACTIVE, XML_INACTIVE);


    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_INACTIVE, LIST_INACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_ACTIVE, LIST_ACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_PERSISTENT, LIST_PERSISTENT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_TRANSIENT, LIST_TRANSIENT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_AUTOSTART, LIST_AUTOSTART);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_NO_AUTOSTART, LIST_NO_AUTOSTART);

    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_DIR, LIST_DIR);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_FS, LIST_FS);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_NETFS, LIST_NETFS);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_LOGICAL, LIST_LOGICAL);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_DISK, LIST_DISK);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_ISCSI, LIST_ISCSI);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_SCSI, LIST_SCSI);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_MPATH, LIST_MPATH);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_RBD, LIST_RBD);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_SHEEPDOG, LIST_SHEEPDOG);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_GLUSTER, LIST_GLUSTER);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_ZFS, LIST_ZFS);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_VSTORAGE, LIST_VSTORAGE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_STORAGE_POOLS_ISCSI_DIRECT, LIST_ISCSI_DIRECT);

    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_ID_REFRESH, EVENT_ID_REFRESH);

    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_DEFINED, EVENT_DEFINED);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_UNDEFINED, EVENT_UNDEFINED);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_STARTED, EVENT_STARTED);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_STOPPED, EVENT_STOPPED);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_CREATED, EVENT_CREATED);
    REGISTER_CONSTANT(VIR_STORAGE_POOL_EVENT_DELETED, EVENT_DELETED);


    stash = gv_stashpv( "Sys::Virt::Network", TRUE );
    REGISTER_CONSTANT(VIR_NETWORK_XML_INACTIVE, XML_INACTIVE);

    REGISTER_CONSTANT(VIR_NETWORK_DEFINE_VALIDATE, DEFINE_VALIDATE);

    REGISTER_CONSTANT(VIR_NETWORK_CREATE_VALIDATE, CREATE_VALIDATE);

    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_NONE, UPDATE_COMMAND_NONE);
    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_MODIFY, UPDATE_COMMAND_MODIFY);
    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_DELETE, UPDATE_COMMAND_DELETE);
    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_ADD_LAST, UPDATE_COMMAND_ADD_LAST);
    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_COMMAND_ADD_FIRST, UPDATE_COMMAND_ADD_FIRST);

    REGISTER_CONSTANT(VIR_NETWORK_SECTION_NONE, SECTION_NONE);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_BRIDGE, SECTION_BRIDGE);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_DOMAIN, SECTION_DOMAIN);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_IP, SECTION_IP);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_IP_DHCP_HOST, SECTION_IP_DHCP_HOST);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_IP_DHCP_RANGE, SECTION_IP_DHCP_RANGE);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_FORWARD, SECTION_FORWARD);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_FORWARD_INTERFACE, SECTION_FORWARD_INTERFACE);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_FORWARD_PF, SECTION_FORWARD_PF);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_PORTGROUP, SECTION_PORTGROUP);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_DNS_HOST, SECTION_DNS_HOST);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_DNS_TXT, SECTION_DNS_TXT);
    REGISTER_CONSTANT(VIR_NETWORK_SECTION_DNS_SRV, SECTION_DNS_SRV);

    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_AFFECT_CURRENT, UPDATE_AFFECT_CURRENT);
    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_AFFECT_LIVE, UPDATE_AFFECT_LIVE);
    REGISTER_CONSTANT(VIR_NETWORK_UPDATE_AFFECT_CONFIG, UPDATE_AFFECT_CONFIG);

    REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_ACTIVE, LIST_ACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_INACTIVE, LIST_INACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_AUTOSTART, LIST_AUTOSTART);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_NO_AUTOSTART, LIST_NO_AUTOSTART);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_PERSISTENT, LIST_PERSISTENT);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NETWORKS_TRANSIENT, LIST_TRANSIENT);

    REGISTER_CONSTANT(VIR_NETWORK_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);

    REGISTER_CONSTANT(VIR_NETWORK_EVENT_DEFINED, EVENT_DEFINED);
    REGISTER_CONSTANT(VIR_NETWORK_EVENT_UNDEFINED, EVENT_UNDEFINED);
    REGISTER_CONSTANT(VIR_NETWORK_EVENT_STARTED, EVENT_STARTED);
    REGISTER_CONSTANT(VIR_NETWORK_EVENT_STOPPED, EVENT_STOPPED);


    stash = gv_stashpv( "Sys::Virt::NetworkPort", TRUE );
    REGISTER_CONSTANT(VIR_NETWORK_PORT_CREATE_RECLAIM, CREATE_RECLAIM);
    REGISTER_CONSTANT(VIR_NETWORK_PORT_CREATE_VALIDATE, CREATE_VALIDATE);

    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_IN_AVERAGE, BANDWIDTH_IN_AVERAGE);
    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_IN_BURST, BANDWIDTH_IN_BURST);
    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_IN_FLOOR, BANDWIDTH_IN_FLOOR);
    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_IN_PEAK, BANDWIDTH_IN_PEAK);
    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_OUT_AVERAGE, BANDWIDTH_OUT_AVERAGE);
    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_OUT_BURST, BANDWIDTH_OUT_BURST);
    REGISTER_CONSTANT_STR(VIR_NETWORK_PORT_BANDWIDTH_OUT_PEAK, BANDWIDTH_OUT_PEAK);

    stash = gv_stashpv( "Sys::Virt::Interface", TRUE );
    REGISTER_CONSTANT(VIR_INTERFACE_XML_INACTIVE, XML_INACTIVE);

    REGISTER_CONSTANT(VIR_INTERFACE_DEFINE_VALIDATE, DEFINE_VALIDATE);

    REGISTER_CONSTANT(VIR_CONNECT_LIST_INTERFACES_ACTIVE, LIST_ACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_INTERFACES_INACTIVE, LIST_INACTIVE);


    stash = gv_stashpv( "Sys::Virt::NodeDevice", TRUE );

    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SYSTEM, LIST_CAP_SYSTEM);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_PCI_DEV, LIST_CAP_PCI_DEV);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_USB_DEV, LIST_CAP_USB_DEV);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_USB_INTERFACE, LIST_CAP_USB_INTERFACE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_NET, LIST_CAP_NET);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI_HOST, LIST_CAP_SCSI_HOST);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI_TARGET, LIST_CAP_SCSI_TARGET);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI, LIST_CAP_SCSI);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_STORAGE, LIST_CAP_STORAGE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_FC_HOST, LIST_CAP_FC_HOST);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_VPORTS, LIST_CAP_VPORTS);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_SCSI_GENERIC, LIST_CAP_SCSI_GENERIC);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_DRM, LIST_CAP_DRM);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_MDEV, LIST_CAP_MDEV);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_MDEV_TYPES, LIST_CAP_MDEV_TYPES);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_CCW_DEV, LIST_CAP_CCW_DEV);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_CSS_DEV, LIST_CAP_CSS_DEV);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_VDPA, LIST_CAP_VDPA);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_AP_CARD, LIST_CAP_AP_CARD);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_AP_MATRIX, LIST_CAP_AP_MATRIX);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_AP_QUEUE, LIST_CAP_AP_QUEUE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_CAP_VPD, LIST_CAP_VPD);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_ACTIVE, LIST_ACTIVE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_NODE_DEVICES_INACTIVE, LIST_INACTIVE);

    REGISTER_CONSTANT(VIR_NODE_DEVICE_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);
    REGISTER_CONSTANT(VIR_NODE_DEVICE_EVENT_ID_UPDATE, EVENT_ID_UPDATE);

    REGISTER_CONSTANT(VIR_NODE_DEVICE_EVENT_CREATED, EVENT_CREATED);
    REGISTER_CONSTANT(VIR_NODE_DEVICE_EVENT_DELETED, EVENT_DELETED);
    REGISTER_CONSTANT(VIR_NODE_DEVICE_EVENT_DEFINED, EVENT_DEFINED);
    REGISTER_CONSTANT(VIR_NODE_DEVICE_EVENT_UNDEFINED, EVENT_UNDEFINED);

    REGISTER_CONSTANT(VIR_NODE_DEVICE_CREATE_XML_VALIDATE, CREATE_XML_VALIDATE);

    REGISTER_CONSTANT(VIR_NODE_DEVICE_DEFINE_XML_VALIDATE, DEFINE_XML_VALIDATE);


    stash = gv_stashpv( "Sys::Virt::StorageVol", TRUE );
    REGISTER_CONSTANT(VIR_STORAGE_VOL_FILE, TYPE_FILE);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_BLOCK, TYPE_BLOCK);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_DIR, TYPE_DIR);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_NETWORK, TYPE_NETWORK);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_NETDIR, TYPE_NETDIR);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_PLOOP, TYPE_PLOOP);

    REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_NORMAL, DELETE_NORMAL);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_ZEROED, DELETE_ZEROED);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_DELETE_WITH_SNAPSHOTS, DELETE_WITH_SNAPSHOTS);


    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_ZERO, WIPE_ALG_ZERO);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_NNSA, WIPE_ALG_NNSA);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_DOD, WIPE_ALG_DOD);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_BSI, WIPE_ALG_BSI);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_GUTMANN, WIPE_ALG_GUTMANN);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_SCHNEIER, WIPE_ALG_SCHNEIER);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_PFITZNER7, WIPE_ALG_PFITZNER7);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_PFITZNER33, WIPE_ALG_PFITZNER33);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_RANDOM, WIPE_ALG_RANDOM);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_WIPE_ALG_TRIM, WIPE_ALG_TRIM);

    REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_ALLOCATE, RESIZE_ALLOCATE);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_DELTA, RESIZE_DELTA);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_RESIZE_SHRINK, RESIZE_SHRINK);

    REGISTER_CONSTANT(VIR_STORAGE_VOL_CREATE_PREALLOC_METADATA, CREATE_PREALLOC_METADATA);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_CREATE_REFLINK, CREATE_REFLINK);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_CREATE_VALIDATE, CREATE_VALIDATE);

    REGISTER_CONSTANT(VIR_STORAGE_VOL_USE_ALLOCATION, USE_ALLOCATION);
    REGISTER_CONSTANT(VIR_STORAGE_VOL_GET_PHYSICAL, GET_PHYSICAL);

    REGISTER_CONSTANT(VIR_STORAGE_VOL_DOWNLOAD_SPARSE_STREAM, VOL_DOWNLOAD_SPARSE_STREAM);

    REGISTER_CONSTANT(VIR_STORAGE_VOL_UPLOAD_SPARSE_STREAM, VOL_UPLOAD_SPARSE_STREAM);

    stash = gv_stashpv( "Sys::Virt::Secret", TRUE );
    REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_NONE, USAGE_TYPE_NONE);
    REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_VOLUME, USAGE_TYPE_VOLUME);
    REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_CEPH, USAGE_TYPE_CEPH);
    REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_ISCSI, USAGE_TYPE_ISCSI);
    REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_TLS, USAGE_TYPE_TLS);
    REGISTER_CONSTANT(VIR_SECRET_USAGE_TYPE_VTPM, USAGE_TYPE_VTPM);

    REGISTER_CONSTANT(VIR_SECRET_DEFINE_VALIDATE, DEFINE_VALIDATE);

    REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_EPHEMERAL, LIST_EPHEMERAL);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_NO_EPHEMERAL, LIST_NO_EPHEMERAL);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_PRIVATE, LIST_PRIVATE);
    REGISTER_CONSTANT(VIR_CONNECT_LIST_SECRETS_NO_PRIVATE, LIST_NO_PRIVATE);

    REGISTER_CONSTANT(VIR_SECRET_EVENT_ID_LIFECYCLE, EVENT_ID_LIFECYCLE);
    REGISTER_CONSTANT(VIR_SECRET_EVENT_ID_VALUE_CHANGED, EVENT_ID_VALUE_CHANGED);

    REGISTER_CONSTANT(VIR_SECRET_EVENT_DEFINED, EVENT_DEFINED);
    REGISTER_CONSTANT(VIR_SECRET_EVENT_UNDEFINED, EVENT_UNDEFINED);


    stash = gv_stashpv( "Sys::Virt::NWFilter", TRUE );
    REGISTER_CONSTANT(VIR_NWFILTER_DEFINE_VALIDATE, DEFINE_VALIDATE);


    stash = gv_stashpv( "Sys::Virt::NWFilterBinding", TRUE );
    REGISTER_CONSTANT(VIR_NWFILTER_BINDING_CREATE_VALIDATE, CREATE_VALIDATE);


    stash = gv_stashpv( "Sys::Virt::Stream", TRUE );
    REGISTER_CONSTANT(VIR_STREAM_NONBLOCK, NONBLOCK);

    REGISTER_CONSTANT(VIR_STREAM_EVENT_READABLE, EVENT_READABLE);
    REGISTER_CONSTANT(VIR_STREAM_EVENT_WRITABLE, EVENT_WRITABLE);
    REGISTER_CONSTANT(VIR_STREAM_EVENT_ERROR, EVENT_ERROR);
    REGISTER_CONSTANT(VIR_STREAM_EVENT_HANGUP, EVENT_HANGUP);

    REGISTER_CONSTANT(VIR_STREAM_RECV_STOP_AT_HOLE, RECV_STOP_AT_HOLE);



    stash = gv_stashpv( "Sys::Virt::Error", TRUE );

    REGISTER_CONSTANT(VIR_ERR_NONE, LEVEL_NONE);
    REGISTER_CONSTANT(VIR_ERR_WARNING, LEVEL_WARNING);
    REGISTER_CONSTANT(VIR_ERR_ERROR, LEVEL_ERROR);

    REGISTER_CONSTANT(VIR_FROM_NONE, FROM_NONE);
    REGISTER_CONSTANT(VIR_FROM_XEN, FROM_XEN);
    REGISTER_CONSTANT(VIR_FROM_XEND, FROM_XEND);
    REGISTER_CONSTANT(VIR_FROM_XENSTORE, FROM_XENSTORE);
    REGISTER_CONSTANT(VIR_FROM_SEXPR, FROM_SEXPR);
    REGISTER_CONSTANT(VIR_FROM_XML, FROM_XML);
    REGISTER_CONSTANT(VIR_FROM_DOM, FROM_DOM);
    REGISTER_CONSTANT(VIR_FROM_RPC, FROM_RPC);
    REGISTER_CONSTANT(VIR_FROM_PROXY, FROM_PROXY);
    REGISTER_CONSTANT(VIR_FROM_CONF, FROM_CONF);
    REGISTER_CONSTANT(VIR_FROM_QEMU, FROM_QEMU);
    REGISTER_CONSTANT(VIR_FROM_NET, FROM_NET);
    REGISTER_CONSTANT(VIR_FROM_TEST, FROM_TEST);
    REGISTER_CONSTANT(VIR_FROM_REMOTE, FROM_REMOTE);
    REGISTER_CONSTANT(VIR_FROM_OPENVZ, FROM_OPENVZ);
    REGISTER_CONSTANT(VIR_FROM_XENXM, FROM_XENXM);
    REGISTER_CONSTANT(VIR_FROM_STATS_LINUX, FROM_STATS_LINUX);
    REGISTER_CONSTANT(VIR_FROM_LXC, FROM_LXC);
    REGISTER_CONSTANT(VIR_FROM_STORAGE, FROM_STORAGE);
    REGISTER_CONSTANT(VIR_FROM_NETWORK, FROM_NETWORK);
    REGISTER_CONSTANT(VIR_FROM_DOMAIN, FROM_DOMAIN);
    REGISTER_CONSTANT(VIR_FROM_UML, FROM_UML);
    REGISTER_CONSTANT(VIR_FROM_NODEDEV, FROM_NODEDEV);
    REGISTER_CONSTANT(VIR_FROM_XEN_INOTIFY, FROM_XEN_INOTIFY);
    REGISTER_CONSTANT(VIR_FROM_SECURITY, FROM_SECURITY);
    REGISTER_CONSTANT(VIR_FROM_VBOX, FROM_VBOX);
    REGISTER_CONSTANT(VIR_FROM_INTERFACE, FROM_INTERFACE);
    REGISTER_CONSTANT(VIR_FROM_ONE, FROM_ONE);
    REGISTER_CONSTANT(VIR_FROM_ESX, FROM_ESX);
    REGISTER_CONSTANT(VIR_FROM_PHYP, FROM_PHYP);
    REGISTER_CONSTANT(VIR_FROM_SECRET, FROM_SECRET);
    REGISTER_CONSTANT(VIR_FROM_CPU, FROM_CPU);
    REGISTER_CONSTANT(VIR_FROM_XENAPI, FROM_XENAPI);
    REGISTER_CONSTANT(VIR_FROM_NWFILTER, FROM_NWFILTER);
    REGISTER_CONSTANT(VIR_FROM_HOOK, FROM_HOOK);
    REGISTER_CONSTANT(VIR_FROM_DOMAIN_SNAPSHOT, FROM_DOMAIN_SNAPSHOT);
    REGISTER_CONSTANT(VIR_FROM_AUDIT, FROM_AUDIT);
    REGISTER_CONSTANT(VIR_FROM_SYSINFO, FROM_SYSINFO);
    REGISTER_CONSTANT(VIR_FROM_STREAMS, FROM_STREAMS);
    REGISTER_CONSTANT(VIR_FROM_VMWARE, FROM_VMWARE);
    REGISTER_CONSTANT(VIR_FROM_EVENT, FROM_EVENT);
    REGISTER_CONSTANT(VIR_FROM_LIBXL, FROM_LIBXL);
    REGISTER_CONSTANT(VIR_FROM_LOCKING, FROM_LOCKING);
    REGISTER_CONSTANT(VIR_FROM_HYPERV, FROM_HYPERV);
    REGISTER_CONSTANT(VIR_FROM_CAPABILITIES, FROM_CAPABILITIES);
    REGISTER_CONSTANT(VIR_FROM_AUTH, FROM_AUTH);
    REGISTER_CONSTANT(VIR_FROM_URI, FROM_URI);
    REGISTER_CONSTANT(VIR_FROM_DBUS, FROM_DBUS);
    REGISTER_CONSTANT(VIR_FROM_DEVICE, FROM_DEVICE);
    REGISTER_CONSTANT(VIR_FROM_PARALLELS, FROM_PARALLELS);
    REGISTER_CONSTANT(VIR_FROM_SSH, FROM_SSH);
    REGISTER_CONSTANT(VIR_FROM_LOCKSPACE, FROM_LOCKSPACE);
    REGISTER_CONSTANT(VIR_FROM_INITCTL, FROM_INITCTL);
    REGISTER_CONSTANT(VIR_FROM_CGROUP, FROM_CGROUP);
    REGISTER_CONSTANT(VIR_FROM_IDENTITY, FROM_IDENTITY);
    REGISTER_CONSTANT(VIR_FROM_ACCESS, FROM_ACCESS);
    REGISTER_CONSTANT(VIR_FROM_SYSTEMD, FROM_SYSTEMD);
    REGISTER_CONSTANT(VIR_FROM_BHYVE, FROM_BHYVE);
    REGISTER_CONSTANT(VIR_FROM_CRYPTO, FROM_CRYPTO);
    REGISTER_CONSTANT(VIR_FROM_FIREWALL, FROM_FIREWALL);
    REGISTER_CONSTANT(VIR_FROM_POLKIT, FROM_POLKIT);
    REGISTER_CONSTANT(VIR_FROM_THREAD, FROM_THREAD);
    REGISTER_CONSTANT(VIR_FROM_ADMIN, FROM_ADMIN);
    REGISTER_CONSTANT(VIR_FROM_LOGGING, FROM_LOGGING);
    REGISTER_CONSTANT(VIR_FROM_XENXL, FROM_XENXL);
    REGISTER_CONSTANT(VIR_FROM_PERF, FROM_PERF);
    REGISTER_CONSTANT(VIR_FROM_LIBSSH, FROM_LIBSSH);
    REGISTER_CONSTANT(VIR_FROM_RESCTRL, FROM_RESCTRL);
    REGISTER_CONSTANT(VIR_FROM_FIREWALLD, FROM_FIREWALLD);
    REGISTER_CONSTANT(VIR_FROM_DOMAIN_CHECKPOINT, FROM_DOMAIN_CHECKPOINT);
    REGISTER_CONSTANT(VIR_FROM_TPM, FROM_TPM);
    REGISTER_CONSTANT(VIR_FROM_BPF, FROM_BPF);
    REGISTER_CONSTANT(VIR_FROM_CH, FROM_CH);


    REGISTER_CONSTANT(VIR_ERR_OK, ERR_OK);
    REGISTER_CONSTANT(VIR_ERR_INTERNAL_ERROR, ERR_INTERNAL_ERROR);
    REGISTER_CONSTANT(VIR_ERR_NO_MEMORY, ERR_NO_MEMORY);
    REGISTER_CONSTANT(VIR_ERR_NO_SUPPORT, ERR_NO_SUPPORT);
    REGISTER_CONSTANT(VIR_ERR_UNKNOWN_HOST, ERR_UNKNOWN_HOST);
    REGISTER_CONSTANT(VIR_ERR_NO_CONNECT, ERR_NO_CONNECT);
    REGISTER_CONSTANT(VIR_ERR_INVALID_CONN, ERR_INVALID_CONN);
    REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN, ERR_INVALID_DOMAIN);
    REGISTER_CONSTANT(VIR_ERR_INVALID_ARG, ERR_INVALID_ARG);
    REGISTER_CONSTANT(VIR_ERR_OPERATION_FAILED, ERR_OPERATION_FAILED);
    REGISTER_CONSTANT(VIR_ERR_GET_FAILED, ERR_GET_FAILED);
    REGISTER_CONSTANT(VIR_ERR_POST_FAILED, ERR_POST_FAILED);
    REGISTER_CONSTANT(VIR_ERR_HTTP_ERROR, ERR_HTTP_ERROR);
    REGISTER_CONSTANT(VIR_ERR_SEXPR_SERIAL, ERR_SEXPR_SERIAL);
    REGISTER_CONSTANT(VIR_ERR_NO_XEN, ERR_NO_XEN);
    REGISTER_CONSTANT(VIR_ERR_XEN_CALL, ERR_XEN_CALL);
    REGISTER_CONSTANT(VIR_ERR_OS_TYPE, ERR_OS_TYPE);
    REGISTER_CONSTANT(VIR_ERR_NO_KERNEL, ERR_NO_KERNEL);
    REGISTER_CONSTANT(VIR_ERR_NO_ROOT, ERR_NO_ROOT);
    REGISTER_CONSTANT(VIR_ERR_NO_SOURCE, ERR_NO_SOURCE);
    REGISTER_CONSTANT(VIR_ERR_NO_TARGET, ERR_NO_TARGET);
    REGISTER_CONSTANT(VIR_ERR_NO_NAME, ERR_NO_NAME);
    REGISTER_CONSTANT(VIR_ERR_NO_OS, ERR_NO_OS);
    REGISTER_CONSTANT(VIR_ERR_NO_DEVICE, ERR_NO_DEVICE);
    REGISTER_CONSTANT(VIR_ERR_NO_XENSTORE, ERR_NO_XENSTORE);
    REGISTER_CONSTANT(VIR_ERR_DRIVER_FULL, ERR_DRIVER_FULL);
    REGISTER_CONSTANT(VIR_ERR_CALL_FAILED, ERR_CALL_FAILED);
    REGISTER_CONSTANT(VIR_ERR_XML_ERROR, ERR_XML_ERROR);
    REGISTER_CONSTANT(VIR_ERR_DOM_EXIST, ERR_DOM_EXIST);
    REGISTER_CONSTANT(VIR_ERR_OPERATION_DENIED, ERR_OPERATIONED_DENIED);
    REGISTER_CONSTANT(VIR_ERR_OPEN_FAILED, ERR_OPEN_FAILED);
    REGISTER_CONSTANT(VIR_ERR_READ_FAILED, ERR_READ_FAILED);
    REGISTER_CONSTANT(VIR_ERR_PARSE_FAILED, ERR_PARSE_FAILED);
    REGISTER_CONSTANT(VIR_ERR_CONF_SYNTAX, ERR_CONF_SYNTAX);
    REGISTER_CONSTANT(VIR_ERR_WRITE_FAILED, ERR_WRITE_FAILED);
    REGISTER_CONSTANT(VIR_ERR_XML_DETAIL, ERR_XML_DETAIL);
    REGISTER_CONSTANT(VIR_ERR_INVALID_NETWORK, ERR_INVALID_NETWORK);
    REGISTER_CONSTANT(VIR_ERR_NETWORK_EXIST, ERR_NETWORK_EXIST);
    REGISTER_CONSTANT(VIR_ERR_SYSTEM_ERROR, ERR_SYSTEM_ERROR);
    REGISTER_CONSTANT(VIR_ERR_RPC, ERR_RPC);
    REGISTER_CONSTANT(VIR_ERR_GNUTLS_ERROR, ERR_GNUTLS_ERROR);
    REGISTER_CONSTANT(VIR_WAR_NO_NETWORK, WAR_NO_NETWORK);
    REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN, ERR_NO_DOMAIN);
    REGISTER_CONSTANT(VIR_ERR_NO_NETWORK, ERR_NO_NETWORK);
    REGISTER_CONSTANT(VIR_ERR_INVALID_MAC, ERR_INVALID_MAC);
    REGISTER_CONSTANT(VIR_ERR_AUTH_FAILED, ERR_AUTH_FAILED);
    REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_POOL, ERR_INVALID_STORAGE_POOL);
    REGISTER_CONSTANT(VIR_ERR_INVALID_STORAGE_VOL, ERR_INVALID_STORAGE_VOL);
    REGISTER_CONSTANT(VIR_WAR_NO_STORAGE, WAR_NO_STORAGE);
    REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_POOL, ERR_NO_STORAGE_POOL);
    REGISTER_CONSTANT(VIR_ERR_NO_STORAGE_VOL, ERR_NO_STORAGE_VOL);
    REGISTER_CONSTANT(VIR_WAR_NO_NODE, WAR_NO_NODE);
    REGISTER_CONSTANT(VIR_ERR_INVALID_NODE_DEVICE, ERR_INVALID_NODE_DEVICE);
    REGISTER_CONSTANT(VIR_ERR_NO_NODE_DEVICE, ERR_NO_NODE_DEVICE);
    REGISTER_CONSTANT(VIR_ERR_NO_SECURITY_MODEL, ERR_NO_SECURITY_MODEL);
    REGISTER_CONSTANT(VIR_ERR_OPERATION_INVALID, ERR_OPERATION_INVALID);
    REGISTER_CONSTANT(VIR_WAR_NO_INTERFACE, WAR_NO_INTERFACE);
    REGISTER_CONSTANT(VIR_ERR_NO_INTERFACE, ERR_NO_INTERFACE);
    REGISTER_CONSTANT(VIR_ERR_INVALID_INTERFACE, ERR_INVALID_INTERFACE);
    REGISTER_CONSTANT(VIR_ERR_MULTIPLE_INTERFACES, ERR_MULTIPLE_INTERFACES);
    REGISTER_CONSTANT(VIR_WAR_NO_NWFILTER, WAR_NO_NWFILTER);
    REGISTER_CONSTANT(VIR_ERR_INVALID_NWFILTER, ERR_INVALID_NWFILTER);
    REGISTER_CONSTANT(VIR_ERR_NO_NWFILTER, ERR_NO_NWFILTER);
    REGISTER_CONSTANT(VIR_ERR_BUILD_FIREWALL, ERR_BUILD_FIREWALL);
    REGISTER_CONSTANT(VIR_WAR_NO_SECRET, WAR_NO_SECRET);
    REGISTER_CONSTANT(VIR_ERR_INVALID_SECRET, ERR_INVALID_SECRET);
    REGISTER_CONSTANT(VIR_ERR_NO_SECRET, ERR_NO_SECRET);
    REGISTER_CONSTANT(VIR_ERR_CONFIG_UNSUPPORTED, ERR_CONFIG_UNSUPPORTED);
    REGISTER_CONSTANT(VIR_ERR_OPERATION_TIMEOUT, ERR_OPERATION_TIMEOUT);
    REGISTER_CONSTANT(VIR_ERR_MIGRATE_PERSIST_FAILED, ERR_MIGRATE_PERSIST_FAILED);
    REGISTER_CONSTANT(VIR_ERR_HOOK_SCRIPT_FAILED, ERR_HOOK_SCRIPT_FAILED);
    REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN_SNAPSHOT, ERR_INVALID_DOMAIN_SNAPSHOT);
    REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_SNAPSHOT, ERR_NO_DOMAIN_SNAPSHOT);
    REGISTER_CONSTANT(VIR_ERR_INVALID_STREAM, ERR_INVALID_STREAM);
    REGISTER_CONSTANT(VIR_ERR_ARGUMENT_UNSUPPORTED, ERR_ARGUMENT_UNSUPPORTED);
    REGISTER_CONSTANT(VIR_ERR_STORAGE_PROBE_FAILED, ERR_STORAGE_PROBE_FAILED);
    REGISTER_CONSTANT(VIR_ERR_STORAGE_POOL_BUILT, ERR_STORAGE_POOL_BUILT);
    REGISTER_CONSTANT(VIR_ERR_SNAPSHOT_REVERT_RISKY, ERR_SNAPSHOT_REVERT_RISKY);
    REGISTER_CONSTANT(VIR_ERR_OPERATION_ABORTED, ERR_OPERATION_ABORTED);
    REGISTER_CONSTANT(VIR_ERR_AUTH_CANCELLED, ERR_AUTH_CANCELLED);
    REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_METADATA, ERR_NO_DOMAIN_METADATA);
    REGISTER_CONSTANT(VIR_ERR_MIGRATE_UNSAFE, ERR_MIGRATE_UNSAFE);
    REGISTER_CONSTANT(VIR_ERR_OVERFLOW, ERR_OVERFLOW);
    REGISTER_CONSTANT(VIR_ERR_BLOCK_COPY_ACTIVE, ERR_BLOCK_COPY_ACTIVE);
    REGISTER_CONSTANT(VIR_ERR_AGENT_UNRESPONSIVE, ERR_AGENT_UNRESPONSIVE);
    REGISTER_CONSTANT(VIR_ERR_OPERATION_UNSUPPORTED, ERR_OPERATION_UNSUPPORTED);
    REGISTER_CONSTANT(VIR_ERR_SSH, ERR_SSH);
    REGISTER_CONSTANT(VIR_ERR_RESOURCE_BUSY, ERR_RESOURCE_BUSY);
    REGISTER_CONSTANT(VIR_ERR_ACCESS_DENIED, ERR_ACCESS_DENIED);
    REGISTER_CONSTANT(VIR_ERR_DBUS_SERVICE, ERR_DBUS_SERVICE);
    REGISTER_CONSTANT(VIR_ERR_STORAGE_VOL_EXIST, ERR_STORAGE_VOL_EXIST);
    REGISTER_CONSTANT(VIR_ERR_CPU_INCOMPATIBLE, ERR_CPU_INCOMPATIBLE);
    REGISTER_CONSTANT(VIR_ERR_XML_INVALID_SCHEMA, ERR_INVALID_SCHEMA);
    REGISTER_CONSTANT(VIR_ERR_MIGRATE_FINISH_OK, ERR_MIGRATE_FINISH_OK);
    REGISTER_CONSTANT(VIR_ERR_AUTH_UNAVAILABLE, ERR_AUTH_UNAVAILABLE);
    REGISTER_CONSTANT(VIR_ERR_NO_SERVER, ERR_NO_SERVER);
    REGISTER_CONSTANT(VIR_ERR_NO_CLIENT, ERR_NO_CLIENT);
    REGISTER_CONSTANT(VIR_ERR_AGENT_UNSYNCED, ERR_AGENT_UNSYNCED);
    REGISTER_CONSTANT(VIR_ERR_LIBSSH, ERR_LIBSSH);
    REGISTER_CONSTANT(VIR_ERR_DEVICE_MISSING, ERR_DEVICE_MISSING);
    REGISTER_CONSTANT(VIR_ERR_INVALID_NWFILTER_BINDING, ERR_INVALID_NWFILTER_BINDING);
    REGISTER_CONSTANT(VIR_ERR_NO_NWFILTER_BINDING, ERR_NO_NWFILTER_BINDING);
    REGISTER_CONSTANT(VIR_ERR_INVALID_DOMAIN_CHECKPOINT, ERR_INVALID_DOMAIN_CHECKPOINT);
    REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_BACKUP, ERR_NO_DOMAIN_BACKUP);
    REGISTER_CONSTANT(VIR_ERR_NO_DOMAIN_CHECKPOINT, ERR_NO_DOMAIN_CHECKPOINT);
    REGISTER_CONSTANT(VIR_ERR_NO_NETWORK_PORT, ERR_NO_NETWORK_PORT);
    REGISTER_CONSTANT(VIR_ERR_INVALID_NETWORK_PORT, ERR_INVALID_NETWORK_PORT);
    REGISTER_CONSTANT(VIR_ERR_NETWORK_PORT_EXIST, ERR_NETWORK_PORT_EXIST);
    REGISTER_CONSTANT(VIR_ERR_NO_HOSTNAME, ERR_NO_HOSTNAME);
    REGISTER_CONSTANT(VIR_ERR_CHECKPOINT_INCONSISTENT, ERR_CHECKPOINT_INCONSISTENT);
    REGISTER_CONSTANT(VIR_ERR_MULTIPLE_DOMAINS, ERR_MULTIPLE_DOMAINS);
}

#line 22077 "lib/Sys/Virt.c"

    /* End of Initialisation Section */

#if PERL_VERSION_LE(5, 21, 5)
#  if PERL_VERSION_GE(5, 9, 0)
    if (PL_unitcheckav)
        call_list(PL_scopestack_ix, PL_unitcheckav);
#  endif
    XSRETURN_YES;
#else
    Perl_xs_boot_epilog(aTHX_ ax);
#endif
}

